# QuantumSymbolics

Computer algebra tools for symbolic manipulations in quantum mechanics and quantum information.

<table>
    <tr>
        <td>Documentation</td>
        <td>
            <a href="https://quantumsavory.github.io/QuantumSymbolics.jl/stable"><img src="https://img.shields.io/badge/docs-stable-blue.svg" alt="Documentation of latest stable version"></a>
            <a href="https://quantumsavory.github.io/QuantumSymbolics.jl/dev"><img src="https://img.shields.io/badge/docs-dev-blue.svg" alt="Documentation of dev version"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Continuous integration</td>
        <td>
            <a href="https://github.com/QuantumSavory/QuantumSymbolics.jl/actions?query=workflow%3ACI+branch%3Amain"><img src="https://github.com/QuantumSavory/QuantumSymbolics.jl/actions/workflows/ci.yml/badge.svg" alt="GitHub Workflow Status"></a>
            <a href="https://buildkite.com/quantumsavory/quantumsymbolics"><img src="https://badge.buildkite.com/f5d8fe7ebb50cf445cec53e9fc47052e4613af3682c2668371.svg?branch=main" alt="Buildkite Workflow Status"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Code coverage</td>
        <td>
            <a href="https://codecov.io/gh/QuantumSavory/QuantumSymbolics.jl"><img src="https://img.shields.io/codecov/c/gh/QuantumSavory/QuantumSymbolics.jl?label=codecov" alt="Test coverage from codecov"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Static analysis with</td>
        <td>
            <a href="https://github.com/aviatesk/JET.jl"><img src="https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a" alt="JET static analysis"></a>
            <a href="https://github.com/JuliaTesting/Aqua.jl"><img src="https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg" alt="Aqua QA"></a>
        </td>
    </tr>
</table>

export PauliNoiseCPTP, DephasingCPTP, DephasingCPTP, GateCPTP

abstract type NoiseCPTP <: Symbolic{AbstractSuperOperator} end
isexpr(::NoiseCPTP) = false
basis(x::NoiseCPTP) = x.basis

"""Single-qubit Pauli noise CPTP map

```jldoctest
julia> apply!(express(Z1), [1], express(PauliNoiseCPTP(1/4,1/4,1/4)))
Operator(dim=2x2)
  basis: Spin(1/2)
 0.5+0.0im  0.0+0.0im
 0.0+0.0im  0.5+0.0im
```"""
@withmetadata struct PauliNoiseCPTP <: NoiseCPTP
    px
    py
    pz
end
basis(x::PauliNoiseCPTP) = SpinBasis(1//2)
symbollabel(x::PauliNoiseCPTP) = "𝒫"

"""Single-qubit dephasing CPTP map"""
@withmetadata struct DephasingCPTP <: NoiseCPTP
    p
end
basis(x::DephasingCPTP) = SpinBasis(1//2)
symbollabel(x::DephasingCPTP) = "𝒟𝓅𝒽"

"""Single-qubit depolarization CPTP map"""
@withmetadata struct DepolarizationCPTP <: NoiseCPTP
    p
    basis::Basis
end
symbollabel(x::DepolarizationCPTP) = "𝒟ℯ𝓅ℴ𝓁"

"""A unitary gate followed by a CPTP map"""
@withmetadata struct GateCPTP <: NoiseCPTP
    gate::Symbolic{AbstractOperator}
    cptp::NoiseCPTP
end
basis(x::GateCPTP) = basis(x.cptp)
function Base.show(io::IO, x::GateCPTP)
    print(io, x.cptp)
    print(io, "[")
    print(io, x.gate)
    print(io, "]")
end

##
# This file defines quantum objects (kets, bras, and operators) with various properties
##

"""Symbolic bra"""
struct SBra <: Symbolic{AbstractBra}
    name::Symbol
    basis::Basis
end
SBra(name) = SBra(name, qubit_basis)

"""
    @bra(name, basis=SpinBasis(1//2))

Define a symbolic bra of type `SBra`. By default, the defined basis is the spin-1/2 basis.

```jldoctest
julia> @bra b₁
⟨b₁|

julia> @bra b₂ FockBasis(2)
⟨b₂|
```
"""
macro bra(name, basis)
    :($(esc(name)) = SBra($(Expr(:quote, name)), $(basis)))
end
macro bra(name)
    :($(esc(name)) = SBra($(Expr(:quote, name))))
end

"""Symbolic ket"""
struct SKet <: Symbolic{AbstractKet}
    name::Symbol
    basis::Basis
end
SKet(name) = SKet(name, qubit_basis)

"""
    @ket(name, basis=SpinBasis(1//2))

Define a symbolic ket of type `SKet`. By default, the defined basis is the spin-1/2 basis.

```jldoctest
julia> @ket k₁
|k₁⟩

julia> @ket k₂ FockBasis(2)
|k₂⟩
```
"""
macro ket(name, basis)
    :($(esc(name)) = SKet($(Expr(:quote, name)), $(basis)))
end
macro ket(name)
    :($(esc(name)) = SKet($(Expr(:quote, name))))
end

"""Symbolic operator"""
struct SOperator <: Symbolic{AbstractOperator}
    name::Symbol
    basis::Basis
end
SOperator(name) = SOperator(name, qubit_basis)

"""
    @op(name, basis=SpinBasis(1//2))

Define a symbolic operator of type `SOperator`. By default, the defined basis is the spin-1/2 basis.

```jldoctest
julia> @op A
A

julia> @op B FockBasis(2)
B
```
"""
macro op(name, basis)
    :($(esc(name)) = SOperator($(Expr(:quote, name)), $(basis)))
end
macro op(name)
    :($(esc(name)) = SOperator($(Expr(:quote, name))))
end
ishermitian(x::SOperator) = false
isunitary(x::SOperator) = false

"""Symbolic Hermitian operator"""
struct SHermitianOperator <: Symbolic{AbstractOperator}
    name::Symbol
    basis::Basis
end
SHermitianOperator(name) = SHermitianOperator(name, qubit_basis)

ishermitian(::SHermitianOperator) = true
isunitary(::SHermitianOperator) = false

"""Symbolic unitary operator"""
struct SUnitaryOperator <: Symbolic{AbstractOperator}
    name::Symbol
    basis::Basis
end
SUnitaryOperator(name) = SUnitaryOperator(name, qubit_basis)

ishermitian(::SUnitaryOperator) = false
isunitary(::SUnitaryOperator) = true

"""Symbolic Hermitian and unitary operator"""
struct SHermitianUnitaryOperator <: Symbolic{AbstractOperator}
    name::Symbol
    basis::Basis
end
SHermitianUnitaryOperator(name) = SHermitianUnitaryOperator(name, qubit_basis)

ishermitian(::SHermitianUnitaryOperator) = true
isunitary(::SHermitianUnitaryOperator) = true

"""Symbolic superoperator"""
struct SSuperOperator <: Symbolic{AbstractSuperOperator}
    name::Symbol
    basis::Basis
end
SSuperOperator(name) = SSuperOperator(name, qubit_basis)
macro superop(name, basis)
    :($(esc(name)) = SSuperOperator($(Expr(:quote, name)), $(basis)))
end
macro superop(name)
    :($(esc(name)) = SSuperOperator($(Expr(:quote, name))))
end
ishermitian(x::SSuperOperator) = false
isunitary(x::SSuperOperator) = false

const SymQ = Union{SKet,SBra,SOperator,SHermitianOperator,SUnitaryOperator,SHermitianUnitaryOperator,SSuperOperator}
isexpr(::SymQ) = false
metadata(::SymQ) = nothing
symbollabel(x::SymQ) = x.name
basis(x::SymQ) = x.basis

Base.show(io::IO, x::SKet) = print(io, "|$(symbollabel(x))⟩")
Base.show(io::IO, x::SBra) = print(io, "⟨$(symbollabel(x))|")
Base.show(io::IO, x::Union{SOperator,SHermitianOperator,SUnitaryOperator,SHermitianUnitaryOperator,SSuperOperator}) = print(io, "$(symbollabel(x))")
Base.show(io::IO, x::SymQObj) = print(io, symbollabel(x)) # fallback that probably is not great

struct SZero{T<:QObj} <: Symbolic{T} end

function Base.zero(x::Symbolic{T}) where T<:QObj
    return SZero{T}()
end

"""Symbolic zero bra"""
const SZeroBra = SZero{AbstractBra}

"""Symbolic zero ket"""
const SZeroKet = SZero{AbstractKet}

"""Symbolic zero operator"""
const SZeroOperator = SZero{AbstractOperator}

isexpr(::SZero) = false
metadata(::SZero) = nothing
symbollabel(x::SZero) =  "𝟎"
basis(x::SZero) = nothing

Base.show(io::IO, x::SZero) = print(io, symbollabel(x))
Base.iszero(x::SymQObj) = isa(x, SZero)

@testitem "QuantumToolbox objects" begin
    using QuantumSymbolics
    using QuantumToolbox

    α = rand(ComplexF64)
    n = rand(1:9)

    @testset "Fock states and operators" begin
        repr = QuantumToolboxRepr(cutoff = 10)
        @test express(vac, repr) ≈ fock(10, 0)
        @test express(FockState(n), repr) ≈ fock(10, n)
        @test express(CoherentState(α), repr) ≈ coherent(10, α)
        @test express(SqueezedState(α), repr) ≈ squeeze(10, α) * fock(10, 0)
        @test express(NumberOp(), repr) ≈ num(10)
        @test express(CreateOp(), repr) ≈ create(10)
        @test express(DestroyOp(), repr) ≈ destroy(10)
        @test express(DisplaceOp(α), repr) ≈ displace(10, α)
    end

    @testset "Quantum gates" begin
        repr = QuantumToolboxRepr()
        @test express(H, repr) ≈ to_sparse(Qobj([1.0+0.0im 1.; 1. -1.]/√2))
        @test express(X, repr) ≈ sigmax()
        @test express(Y, repr) ≈ sigmay()
        @test express(Z, repr) ≈ sigmaz()
        @test express(CPHASE, repr) ≈ Qobj([1.0+0.0im 0. 0. 0.; 0. 1. 0. 0.; 0. 0. 1. 0.; 0. 0. 0. -1.], dims = (2,2))
        @test express(CNOT, repr) ≈ Qobj([1.0+0.0im 0. 0. 0.; 0. 1. 0. 0.; 0. 0. 0. 1.; 0. 0. 1. 0.], dims = (2,2))
        @test express(QuantumSymbolics.PauliM(), repr) ≈ sigmam()
        @test express(QuantumSymbolics.PauliP(), repr) ≈ sigmap()
    end

    @testset "Pure states" begin
        repr = QuantumToolboxRepr()
        @test express(XBasisState(1, SpinBasis(1//2)), repr) ≈ Qobj([1.0+0.0im, 1.0]/√2)
        @test express(XBasisState(2, SpinBasis(1//2)), repr) ≈ Qobj([1.0+0.0im, -1.0]/√2)
        @test express(YBasisState(1, SpinBasis(1//2)), repr) ≈ Qobj([1.0+0.0im, 1.0im]/√2)
        @test express(YBasisState(2, SpinBasis(1//2)), repr) ≈ Qobj([1.0+0.0im, -1.0im]/√2)
        @test express(ZBasisState(1, SpinBasis(1//2)), repr) ≈ Qobj([1.0+0.0im, 0.0])
        @test express(ZBasisState(2, SpinBasis(1//2)), repr) ≈ Qobj([0.0+0.0im, 1.0])
    end

    @testset "Linear algebra" begin
        repr = QuantumToolboxRepr()
        @test express(QuantumSymbolics.tensor(X, Y) + QuantumSymbolics.tensor(Z, X), repr) ≈ QuantumToolbox.tensor(express(X, repr), express(Y, repr)) + QuantumToolbox.tensor(express(Z, repr), express(X, repr))
        @test express(CreateOp() * (FockState(1) + CoherentState(α)), repr) ≈ express(CreateOp(), repr) * (express(FockState(1), repr) + express(CoherentState(α), repr))
        @test express(IdentityOp(QuantumSymbolics.tensor(X, Y)), repr) ≈ qeye(4)
        @test express(MixedState(QuantumSymbolics.tensor(X, Y)), repr) ≈ qeye(4) / 4
    end
end

@testitem "Conditional Cliffords" begin
    using QuantumClifford
    using QuantumOpticsBase
    using LinearAlgebra

    for control in (:X, :Y, :Z)
        for target in (:X, :Y, :Z)
            structname = Symbol(control,"C",target,"Gate")
            gate = eval(structname)()
            gate_qo = express(gate, QuantumOpticsRepr())
            gate_qc = Operator(CliffordOperator(express(gate, CliffordRepr(), UseAsOperation())(1,2),2))
            @test gate_qo ≈ gate_qc
        end
    end
end

# Most of the useful functionality declared here is implemented in MixedCliffordOpticsExt

export StabilizerState

"""State defined by a stabilizer tableau

For full functionality you also need to import the `QuantumClifford` library.

```jldoctest
julia> using QuantumClifford, QuantumOptics # needed for the internal representation of the stabilizer tableaux and the conversion to a ket

julia> StabilizerState(S"XX ZZ")
𝒮₂

julia> express(StabilizerState(S"-X"))
Ket(dim=2)
  basis: Spin(1/2)
  0.7071067811865475 + 0.0im
 -0.7071067811865475 + 0.0im
```"""
@withmetadata struct StabilizerState{T} <: Symbolic{AbstractKet} where {T}
    stabilizer::T
end
isexpr(::StabilizerState) = false
basis(x::StabilizerState) = SpinBasis(1//2)^nqubits(x.stabilizer)
symbollabel(x::StabilizerState) = "𝒮$(num_to_sub(nqubits(x.stabilizer)))"
Base.show(io::IO, x::StabilizerState) = print(io, symbollabel(x))

StabilizerState(s::T) where {T} = StabilizerState{T}(s) # TODO this is necessary because the @withmetadata macro is not very smart

using Test
using QuantumSymbolics

@testset "Conditional Cliffords" begin
    using QuantumClifford
    using QuantumOpticsBase
    using QuantumToolbox
    using LinearAlgebra

    P = [1. 0. 0. 0.;   # Maps QuantumOptics to QuantumToolbox basis
         0. 0. 1. 0.;
         0. 1. 0. 0.;
         0. 0. 0. 1.]
    for control in (:X, :Y, :Z)
        for target in (:X, :Y, :Z)
            structname = Symbol(control,"C",target,"Gate")
            gate = eval(structname)()
            gate_qo = express(gate, QuantumOpticsRepr())
            gate_qc = QuantumOpticsBase.Operator(CliffordOperator(express(gate, CliffordRepr(), UseAsOperation())(1,2),2))
            gate_qt = express(gate, QuantumToolboxRepr())
            @test gate_qo ≈ gate_qc
            @test P * gate_qo.data * P' ≈ gate_qt.data atol = 1e-10
        end
    end
end

function prefactorscalings(xs)
    terms = []
    coeff = 1::Any
    for x in xs
        if isa(x, SScaled)
            coeff *= x.coeff
            push!(terms, x.obj)
        elseif isa(x, Union{Number, Symbolic{Number}})
            coeff *= x
        else
            push!(terms,x)
        end
    end
    coeff, terms
end

function flattenop(f, terms)
    newterms = []
    for obj in terms
        if isexpr(obj) && operation(obj) === f
            append!(newterms, arguments(obj))
        else
            push!(newterms, obj)
        end
    end
    newterms
end

function countmap(samples) # A simpler version of StatsBase.countmap, because StatsBase is slow to import
    counts = Dict{Any,Any}()
    for s in samples
        counts[s] = get(counts, s, 0)+1
    end
    counts
end

function countmap_flatten(samples, flattenadd, flattenmul)
    counts = Dict{Any,Any}()
    for s in samples
        if s isa flattenadd
            for (term,coef) in pairs(s.dict)
                counts[term] = get(counts, term, 0)+coef
            end
        elseif s isa flattenmul
            coef, term = arguments(s)
            if term isa flattenadd
                for (_term,_coef) in pairs(term.dict)
                    counts[_term] = get(counts, _term, 0)+coef*_coef
                end
            else
                counts[term] = get(counts, term, 0)+coef
            end
        else
            counts[s] = get(counts, s, 0)+1
        end
    end
    for (term,coef) in pairs(counts)
        if iszero(coef)===true # iszero might return symbolic expressions instead of true/false # TODO make into a proper function like isdefinitelyzero, see whether upstream Symbolics has it
            delete!(counts, term)
        end
    end
    counts
end

using Test
using QuantumSymbolics

@testset "Misc linear algebra" begin
    @op A; @op B;
    O = SZeroOperator()

    @bra p
    @bra q
        
    @ket m
    @ket n
    
    @testset "Complex Conjugate" begin
        @test isequal(conj(O), O)
        @test isequal(conj(conj(A)), A)
    end

    @testset "Transpose" begin
        @test isequal(transpose(2*A), 2*transpose(A))
        @test isequal(transpose(A+B), transpose(A)+transpose(B))
        @test isequal(transpose(A*B), transpose(B)*transpose(A))
        @test isequal(transpose(A⊗B), transpose(A)⊗transpose(B))
        @test isequal(transpose(O), O)
        @test isequal(transpose(transpose(A)), A)
    end

    @testset "Vectorization" begin
        @test isequal(vec(2*A), 2*vec(A))
        @test isequal(vec(A+B), vec(A)+vec(B))
        @test isequal(basis(vec(A)), SpinBasis(1//2)⊗SpinBasis(1//2))
    end

    @testset "Exponential" begin
        @test isequal(exp(A), SExpOperator(A))
    end

    @testset "Vector of Operators" begin
        @test isequal([1 1;-im im]*[A;B], [A + B;im*B-im*A])  
    end

    @testset "Vector of Kets" begin
        @test isequal([1 1;-im im] *[p;q], [p + q;im*q-im*p])
    end

    @testset "Vector of Bras" begin
        @test isequal([1 1;-im im] *[m;n], [m + n;im*n-im*m])
    end

end

using Test
using QuantumSymbolics

@testset "Test Pauli" begin
    @testset "simplify errors" begin
        @test_throws ErrorException qsimplify(X)
    end

    @testset "MulOperator tests" begin
        @test isequal(qsimplify(X*X,rewriter=qsimplify_pauli), I)
        @test isequal(qsimplify(Y*Y,rewriter=qsimplify_pauli), I)
        @test isequal(qsimplify(Z*Z,rewriter=qsimplify_pauli), I)
        @test isequal(qsimplify(X*Y,rewriter=qsimplify_pauli), im*Z)
        @test isequal(qsimplify(Y*Z,rewriter=qsimplify_pauli), im*X)
        @test isequal(qsimplify(Z*X,rewriter=qsimplify_pauli), im*Y)
        @test isequal(qsimplify(Y*X,rewriter=qsimplify_pauli), -im*Z)
        @test isequal(qsimplify(Z*Y,rewriter=qsimplify_pauli), -im*X)
        @test isequal(qsimplify(X*Z,rewriter=qsimplify_pauli), -im*Y)
        @test isequal(qsimplify(H*X*H,rewriter=qsimplify_pauli), Z)
        @test isequal(qsimplify(H*Y*H,rewriter=qsimplify_pauli), -Y)
        @test isequal(qsimplify(H*Z*H,rewriter=qsimplify_pauli), X)
    end

    @testset "ApplyKet tests" begin
        @test isequal(qsimplify(X*X1,rewriter=qsimplify_pauli), X1)
        @test isequal(qsimplify(Y*X1,rewriter=qsimplify_pauli), -im*X2)
        @test isequal(qsimplify(Z*X1,rewriter=qsimplify_pauli), X2)

        @test isequal(qsimplify(X*X2,rewriter=qsimplify_pauli), -X2)
        @test isequal(qsimplify(Y*X2,rewriter=qsimplify_pauli), im*X1)
        @test isequal(qsimplify(Z*X2,rewriter=qsimplify_pauli), X1)

        @test isequal(qsimplify(X*Y1,rewriter=qsimplify_pauli), im*Y2)
        @test isequal(qsimplify(Y*Y1,rewriter=qsimplify_pauli), Y1)
        @test isequal(qsimplify(Z*Y1,rewriter=qsimplify_pauli), Y2)

        @test isequal(qsimplify(X*Z1,rewriter=qsimplify_pauli), Z2)
        @test isequal(qsimplify(Y*Z1,rewriter=qsimplify_pauli), im*Z2)
        @test isequal(qsimplify(Z*Z1,rewriter=qsimplify_pauli), Z1)

        @test isequal(qsimplify(X*Z2,rewriter=qsimplify_pauli), Z1)
        @test isequal(qsimplify(Y*Z2,rewriter=qsimplify_pauli), -im*Z1)
        @test isequal(qsimplify(Z*Z2,rewriter=qsimplify_pauli), -Z2)

        @test isequal(qsimplify(H*X1,rewriter=qsimplify_pauli), Z1)
        @test isequal(qsimplify(H*X2,rewriter=qsimplify_pauli), Z2)
        @test isequal(qsimplify(H*Y1,rewriter=qsimplify_pauli), (X1+im*X2)/sqrt(2))
        @test isequal(qsimplify(H*Y2,rewriter=qsimplify_pauli), (X1-im*X2)/sqrt(2))
        @test isequal(qsimplify(H*Z1,rewriter=qsimplify_pauli), X1)
        @test isequal(qsimplify(H*Z2,rewriter=qsimplify_pauli), X2)
    end
end

@testitem "Test qo" begin
    using QuantumOptics
    using QuantumSymbolics
    #using QuantumOpticsExt: LazyPrePost
    const LazyPrePost = Base.get_extension(QuantumSymbolics, :QuantumOpticsExt).LazyPrePost

    bs = GenericBasis(2),GenericBasis(2)
    op0 = Operator(bs...,rand(2,2))
    op21 = Operator(bs...,rand(2,2))
    op22 = Operator(bs...,rand(2,2))
    op31 = Operator(bs...,rand(2,2))
    op32 = Operator(bs...,rand(2,2))
    l2 = LazyPrePost(op21,op22)
    l3 = LazyPrePost(op31,op32)
    @test spre(op21)*spost(op22) ≈ spost(op22)*spre(op21)
    @test spre(op21)*spost(op22)*op0 ≈ l2*op0
    @test spre(op31)*spost(op32)*spre(op21)*spost(op22)*op0 ≈ (l3*l2)*op0 ≈ l3*(l2*op0)
    @test (l2+l3) * op0 ≈ spre(op21)*spost(op22)*op0 + spre(op31)*spost(op32)*op0

    op0a = Operator(bs...,rand(2,2))
    op0b = Operator(bs...,rand(2,2))
    opt0 = op0⊗op0a⊗op0b
    b = basis(opt0)
    @test embed(b,b,[1],l2)*opt0 ≈ (spre(op21)*spost(op22)*op0)⊗op0a⊗op0b
    @test embed(b,b,[1],l2+l3)*opt0 ≈ (spre(op21)*spost(op22)*op0 + spre(op31)*spost(op32)*op0)⊗op0a⊗op0b
end

module QuantumToolboxExt

using QuantumToolbox
using QuantumSymbolics
using QuantumSymbolics:
    HGate, XGate, YGate, ZGate, CPHASEGate, CNOTGate, PauliP, PauliM,
    XCXGate, XCYGate, XCZGate, YCXGate, YCYGate, YCZGate, ZCXGate, ZCYGate, ZCZGate,
    XBasisState, YBasisState, ZBasisState,
    NumberOp, CreateOp, DestroyOp,
    FockState,
    MixedState, IdentityOp, STensor,
    qubit_basis
import QuantumSymbolics: express, express_nolookup
using TermInterface
using TermInterface: isexpr, head, operation, arguments, metadata

const _l0 = QuantumToolbox.basis(2,0)
const _l1 = QuantumToolbox.basis(2,1)
const _s₊ = (_l0+_l1)/√2
const _s₋ = (_l0-_l1)/√2
const _i₊ = (_l0+im*_l1)/√2
const _i₋ = (_l0-im*_l1)/√2
const _σ₊ = QuantumToolbox.sigmap()
const _σ₋ = QuantumToolbox.sigmam()
const _l00 = QuantumToolbox.proj(_l0)
const _l11 = QuantumToolbox.proj(_l1)
const _id = QuantumToolbox.qeye(2)
const _z = QuantumToolbox.sigmaz()
const _x = QuantumToolbox.sigmax()
const _y = QuantumToolbox.sigmay()
const _hadamard = (_z+_x)/√2
const _cnot = QuantumToolbox.tensor(_l00,_id) + QuantumToolbox.tensor(_l11,_x)
const _cphase = QuantumToolbox.tensor(_l00,_id) + QuantumToolbox.tensor(_l11,_z)
const _phase = _l00 + im*_l11
const _iphase = _l00 - im*_l11

const _f0₂ = QuantumToolbox.basis(2, 0)
const _f1₂ = QuantumToolbox.basis(2, 1)
const _ad₂ = QuantumToolbox.create(2)
const _a₂ = QuantumToolbox.destroy(2)
const _n₂ = QuantumToolbox.num(2)

express_nolookup(::HGate, ::QuantumToolboxRepr) = _hadamard
express_nolookup(::XGate, ::QuantumToolboxRepr) = _x
express_nolookup(::YGate, ::QuantumToolboxRepr) = _y
express_nolookup(::ZGate, ::QuantumToolboxRepr) = _z
express_nolookup(::CPHASEGate, ::QuantumToolboxRepr) = _cphase
express_nolookup(::CNOTGate, ::QuantumToolboxRepr) = _cnot

const xyzopdict = Dict(:X=>_x, :Y=>_y, :Z=>_z)
const xyzstatedict = Dict(:X=>(_s₊,_s₋),:Y=>(_i₊,_i₋),:Z=>(_l0,_l1))
for control in (:X, :Y, :Z)
    for target in (:X, :Y, :Z)
        k1, k2 = xyzstatedict[control]
        o = xyzopdict[target]
        gate = QuantumToolbox.tensor(proj(k1),_id) + QuantumToolbox.tensor(proj(k2),o)
        structname = Symbol(control,"C",target,"Gate")
        let gate=copy(gate)
            @eval express_nolookup(::$(structname), ::QuantumToolboxRepr) = $gate
        end
    end
end

express_nolookup(::PauliM, ::QuantumToolboxRepr) = _σ₋
express_nolookup(::PauliP, ::QuantumToolboxRepr) = _σ₊

express_nolookup(s::XBasisState, ::QuantumToolboxRepr) = (_s₊,_s₋)[s.idx]
express_nolookup(s::YBasisState, ::QuantumToolboxRepr) = (_i₊,_i₋)[s.idx]
express_nolookup(s::ZBasisState, ::QuantumToolboxRepr) = (_l0,_l1)[s.idx]

express_nolookup(s::FockState, r::QuantumToolboxRepr) = fock(r.cutoff, s.idx)
express_nolookup(s::CoherentState, r::QuantumToolboxRepr) = coherent(r.cutoff,s.alpha)
express_nolookup(s::SqueezedState, r::QuantumToolboxRepr) = (c = r.cutoff; squeeze(c, s.z)*fock(c, 0))
express_nolookup(o::NumberOp, r::QuantumToolboxRepr) = num(r.cutoff)
express_nolookup(o::CreateOp, r::QuantumToolboxRepr) = create(r.cutoff)
express_nolookup(o::DestroyOp, r::QuantumToolboxRepr) = destroy(r.cutoff)
express_nolookup(o::DisplaceOp, r::QuantumToolboxRepr) = displace(r.cutoff, o.alpha)
express_nolookup(o::SqueezeOp, r::QuantumToolboxRepr) = squeeze(r.cutoff, o.z)
express_nolookup(x::MixedState, r::QuantumToolboxRepr) = (l = length(x.basis); return qeye(l)/l)
express_nolookup(x::IdentityOp, r::QuantumToolboxRepr) = qeye(length(x.basis))

express_nolookup(s::SOuterKetBra, r::QuantumToolboxRepr) = proj(express(s.ket, r), express(s.bra, r))
express_nolookup(s::STensor, r::QuantumToolboxRepr) = QuantumToolbox.tensor((express(i, r) for i in s.terms)...)

end

using Symbolics
import Symbolics: simplify,Term
using SymbolicUtils
import SymbolicUtils: Symbolic,_isone,flatten_term,isnotflat,Chain,Fixpoint,Prewalk,sorted_arguments
using TermInterface
import TermInterface: isexpr,head,iscall,children,operation,arguments,metadata,maketerm
import MacroTools
import MacroTools: namify, @capture

using LinearAlgebra
import LinearAlgebra: eigvecs,ishermitian,conj,transpose,inv,exp,vec,tr

import QuantumInterface:
    apply!,
    tensor, ⊗,
    basis,Basis,samebases,IncompatibleBases,SpinBasis,FockBasis,CompositeBasis,
    nqubits,
    projector,dagger,tr,ptrace,
    AbstractBra,AbstractKet,AbstractOperator,AbstractSuperOperator,
    express,AbstractRepresentation,AbstractUse,UseAsState,UseAsObservable,UseAsOperation,
    QuantumOpticsRepr,QuantumMCRepr,CliffordRepr

export SymQObj,QObj,
       AbstractRepresentation,AbstractUse,
       QuantumOpticsRepr,QuantumMCRepr,CliffordRepr,
       UseAsState,UseAsObservable,UseAsOperation,
       apply!,
       express,
       tensor,⊗,
       dagger,projector,commutator,anticommutator,conj,transpose,inv,exp,vec,tr,ptrace,
       I,X,Y,Z,σˣ,σʸ,σᶻ,Pm,Pp,σ₋,σ₊,
       H,CNOT,CPHASE,XCX,XCY,XCZ,YCX,YCY,YCZ,ZCX,ZCY,ZCZ,
       X1,X2,Y1,Y2,Z1,Z2,X₁,X₂,Y₁,Y₂,Z₁,Z₂,L0,L1,Lp,Lm,Lpi,Lmi,L₀,L₁,L₊,L₋,L₊ᵢ,L₋ᵢ,
       vac,F₀,F0,F₁,F1,inf_fock_basis,
       N,n̂,Create,âꜛ,Destroy,â,basis,SpinBasis,FockBasis,
       SBra,SKet,SOperator,SHermitianOperator,SUnitaryOperator,SHermitianUnitaryOperator,SSuperOperator,
       @ket,@bra,@op,@superop,
       SAdd,SAddBra,SAddKet,SAddOperator,
       SScaled,SScaledBra,SScaledOperator,SScaledKet,
       STensorBra,STensorKet,STensorOperator,
       SZeroBra,SZeroKet,SZeroOperator,
       SConjugate,STranspose,SProjector,SDagger,SInvOperator,SExpOperator,SVec,STrace,SPartialTrace,
       MixedState,IdentityOp,
       SApplyKet,SApplyBra,SMulOperator,SSuperOpApply,SCommutator,SAnticommutator,SBraKet,SOuterKetBra,
       HGate,XGate,YGate,ZGate,CPHASEGate,CNOTGate,
       XBasisState,YBasisState,ZBasisState,FockState,CoherentState,SqueezedState,
       NumberOp,CreateOp,DestroyOp,PhaseShiftOp,DisplaceOp,SqueezeOp,
       XCXGate,XCYGate,XCZGate,YCXGate,YCYGate,YCZGate,ZCXGate,ZCYGate,ZCZGate,
       qsimplify,qsimplify_pauli,qsimplify_commutator,qsimplify_anticommutator,qsimplify_fock,
       qexpand,
       isunitary,
       KrausRepr,kraus

##
# Metadata cache helpers
##

const CacheType = Dict{Tuple{<:AbstractRepresentation,<:AbstractUse},Any}
mutable struct Metadata
    express_cache::CacheType # TODO use more efficient mapping
end
Metadata() = Metadata(CacheType())

"""Decorate a struct definition in order to add a metadata dict which would be storing cached `express` results."""
macro withmetadata(strct)
    ex = quote $strct end
    if @capture(ex, (struct T_{params__} fields__ end) | (struct T_{params__} <: A_ fields__ end))
        struct_name = namify(T)
        args = (namify(i) for i in fields if !MacroTools.isexpr(i, String, :string))
        constructor = :($struct_name{S}($(args...)) where S = new{S}($((args..., :(Metadata()))...)))
    elseif @capture(ex, struct T_ fields__ end)
        struct_name = namify(T)
        args = (namify(i) for i in fields if !MacroTools.isexpr(i, String, :string))
        constructor = :($struct_name($(args...)) = new($((args..., :(Metadata()))...)))
    else @capture(ex, struct T_ end)
        struct_name = namify(T)
        constructor = :($struct_name() = new($:(Metadata())))
    end
    struct_args = strct.args[end].args
    push!(struct_args, constructor, :(metadata::Metadata))
    esc(quote
    Base.@__doc__ $strct
    metadata(x::$struct_name)=x.metadata
    end)
end

##
# Basic Types
##

const QObj = Union{AbstractBra,AbstractKet,AbstractOperator,AbstractSuperOperator}
const SymQObj = Symbolic{<:QObj} # TODO Should we use Sym or Symbolic... Sym has a lot of predefined goodies, including metadata support
Base.:(-)(x::SymQObj) = (-1)*x
Base.:(-)(x::SymQObj,y::SymQObj) = x + (-y)
Base.hash(x::SymQObj, h::UInt) = isexpr(x) ? hash((head(x), arguments(x)), h) :
hash((typeof(x),symbollabel(x),basis(x)), h)
maketerm(::Type{<:SymQObj}, f, a, m) = f(a...)

function Base.isequal(x::X,y::Y) where {X<:SymQObj, Y<:SymQObj}
    if X==Y
        if isexpr(x)
            if operation(x)==operation(y)
                ax,ay = arguments(x),arguments(y)
                (operation(x) === +) ? x._set_precomputed == y._set_precomputed : all(zip(ax,ay)) do xy isequal(xy...) end
            else
                false
            end
        else
            propsequal(x,y) # this is unholy
        end
    else
        false
    end
end
Base.isequal(::SymQObj, ::Symbolic{Complex}) = false
Base.isequal(::Symbolic{Complex}, ::SymQObj) = false

# TODO check that this does not cause incredibly bad runtime performance
# use a macro to provide specializations if that is indeed the case
propsequal(x,y) = all(n->(n==:metadata || isequal(getproperty(x,n),getproperty(y,n))), propertynames(x))


##
# Utilities
##

include("utils.jl")

##
# Most symbolic objects defined here
##

include("literal_objects.jl")
include("basic_ops_homogeneous.jl")
include("basic_ops_inhomogeneous.jl")
include("basic_superops.jl")
include("linalg.jl")
include("predefined.jl")
include("predefined_CPTP.jl")
include("predefined_fock.jl")

##
# Symbolic and simplification rules
##

include("rules.jl")

##
# Expressing in specific formalism
##

include("express.jl")

##
# Printing
##

include("latexify.jl")

using Revise # for interactive work on docs
push!(LOAD_PATH,"../src/")

using Documenter
using DocumenterCitations
using AnythingLLMDocs
using QuantumSymbolics
using QuantumInterface
using LinearAlgebra

DocMeta.setdocmeta!(QuantumSymbolics, :DocTestSetup, :(using QuantumSymbolics, QuantumOptics, QuantumClifford, QuantumInterface, LinearAlgebra); recursive=true)

function main()
    doc_modules = [QuantumSymbolics, QuantumInterface]
    api_base="https://anythingllm.krastanov.org/api/v1"
    anythingllm_assets = integrate_anythingllm(
        "QuantumSymbolics",
        doc_modules,
        @__DIR__,
        api_base;
        repo = "github.com/QuantumSavory/QuantumSymbolics.jl.git",
        options = EmbedOptions(),
    )

    bib = CitationBibliography(joinpath(@__DIR__,"src/references.bib"), style=:authoryear)
    assets = Any["assets/init.js"]
    append!(assets, anythingllm_assets)

    makedocs(
    plugins=[bib],
    doctest = false,
    clean = true,
    sitename = "QuantumSymbolics.jl",
    format = Documenter.HTML(
        assets=assets
    ),
    modules = doc_modules,
    checkdocs = :exports,
    warnonly = false,
    authors = "Stefan Krastanov",
    pages = [
        "QuantumSymbolics.jl" => "index.md",
        "Getting Started with QuantumSymbolics.jl" => "introduction.md",
        "Express Functionality" => "express.md",
        "Qubit Basis Choice" => "qubit_basis.md",
        "Quantum Harmonic Oscillators" => "QHO.md",
        "API" => "API.md",
    ]
    )

    deploydocs(
        repo = "github.com/QuantumSavory/QuantumSymbolics.jl.git",
        devbranch = "main",
        deploy_config = Documenter.Buildkite(),
        push_preview = true
    )
end

main()

module GabsExt

using QuantumSymbolics
using QuantumSymbolics: CoherentState, GabsRepr
import QuantumSymbolics: express, express_nolookup

using Gabs

function express_nolookup(x::FockState, repr::GabsRepr)
    x.idx == 0 || throw(ArgumentError("Fock states with index ≥ 0 are non-Gaussian and unsupported via the Gabs representation."))
    return vacuumstate(repr.basis(1))
end
express_nolookup(x::CoherentState, repr::GabsRepr) = coherentstate(repr.basis(1), x.alpha)
express_nolookup(x::BosonicThermalState, repr::GabsRepr) = thermalstate(repr.basis(1), x.photons)
express_nolookup(x::PhaseShiftOp, repr::GabsRepr) = phaseshift(repr.basis(1), x.phase)
express_nolookup(x::DisplaceOp, repr::GabsRepr) = displace(repr.basis(1), x.alpha)
express_nolookup(x::BeamSplitterOp, repr::GabsRepr) = beamsplitter(repr.basis(2), x.transmit)

for (f,g) in [(:SqueezedState, :squeezedstate),(:SqueezeOp,:squeeze)]
    @eval function express_nolookup(x::$f, repr::GabsRepr)
        r, i = (real(x.z), imag(x.z))
        return ($g)(repr.basis(1), sqrt(r^2 + i^2), atan(i, r))
    end
end
for (f,g) in [(:TwoSqueezedState, :eprstate),(:TwoSqueezeOp,:twosqueeze)]
    @eval function express_nolookup(x::$f, repr::GabsRepr)
        r, i = (real(x.z), imag(x.z))
        return ($g)(repr.basis(2), sqrt(r^2 + i^2), atan(i, r))
    end
end

express_nolookup(x::AttenuatorCPTP, repr::GabsRepr) = attenuator(repr.basis(1), x.theta, x.noise)
express_nolookup(x::AmplifierCPTP, repr::GabsRepr) = amplifier(repr.basis(1), x.r, x.noise)

end

##
# Predefined objects in the Fock space.
##

"""Fock state in defined Fock basis."""
@withmetadata struct FockState <: SpecialKet
    idx::Int
    basis::FockBasis
end
FockState(idx::Int) = FockState(idx, inf_fock_basis)
symbollabel(x::FockState) = "$(x.idx)"

"""Coherent state in defined Fock basis."""
@withmetadata struct CoherentState <: SpecialKet
    alpha::Number # TODO parameterize
    basis::FockBasis
end
CoherentState(alpha::Number) = CoherentState(alpha, inf_fock_basis)
symbollabel(x::CoherentState) = "$(x.alpha)"

"""Squeezed vacuum state in defined Fock basis."""
@withmetadata struct SqueezedState <: SpecialKet
    z::Number
    basis::FockBasis
end
SqueezedState(z::Number) = SqueezedState(z, inf_fock_basis)
symbollabel(x::SqueezedState) = "0,$(x.z)"

const inf_fock_basis = FockBasis(Inf,0.)
"""Vacuum basis state of n"""
const vac = const F₀ = const F0 = FockState(0)
"""Single photon basis state of n"""
const F₁ = const F1 = FockState(1)

##
# Gates and Operators on harmonic oscillators
##

abstract type AbstractSingleBosonOp <: Symbolic{AbstractOperator} end
abstract type AbstractSingleBosonGate <: AbstractSingleBosonOp end # TODO maybe an IsUnitaryTrait is a better choice
isexpr(::AbstractSingleBosonGate) = false
basis(x::AbstractSingleBosonOp) = inf_fock_basis

"""Number operator.

```jldoctest
julia> f = FockState(2)
|2⟩

julia> num = NumberOp()
n

julia> qsimplify(num*f, rewriter=qsimplify_fock)
2|2⟩
```
"""
@withmetadata struct NumberOp <: AbstractSingleBosonOp 
    basis::FockBasis
end
NumberOp() = NumberOp(inf_fock_basis)
symbollabel(::NumberOp) = "n"

"""Creation (raising) operator.

```jldoctest
julia> f = FockState(2)
|2⟩

julia> create = CreateOp()
a†

julia> qsimplify(create*f, rewriter=qsimplify_fock)
(sqrt(3))|3⟩
```
"""
@withmetadata struct CreateOp <: AbstractSingleBosonOp
    basis::FockBasis
end
CreateOp() = CreateOp(inf_fock_basis)
symbollabel(::CreateOp) = "a†"

"""Annihilation (lowering or destroy) operator in defined Fock basis.

```jldoctest
julia> f = FockState(2)
|2⟩

julia> destroy = DestroyOp()
a

julia> qsimplify(destroy*f, rewriter=qsimplify_fock)
(sqrt(2))|1⟩
```
"""
@withmetadata struct DestroyOp <: AbstractSingleBosonOp
    basis::FockBasis
end
DestroyOp() = DestroyOp(inf_fock_basis)
symbollabel(::DestroyOp) = "a"

"""Phase-shift operator in defined Fock basis.

```jldoctest
julia> c = CoherentState(im)
|im⟩

julia> phase = PhaseShiftOp(pi)
U(π)

julia> qsimplify(phase*c, rewriter=qsimplify_fock)
|1.2246467991473532e-16 - 1.0im⟩
```
"""
@withmetadata struct PhaseShiftOp <: AbstractSingleBosonOp
    phase::Number
    basis::FockBasis
end
PhaseShiftOp(phase::Number) = PhaseShiftOp(phase, inf_fock_basis)
symbollabel(x::PhaseShiftOp) = "U($(x.phase))"

"""Displacement operator in defined Fock basis.

```jldoctest
julia> f = FockState(0)
|0⟩

julia> displace = DisplaceOp(im)
D(im)

julia> qsimplify(displace*f, rewriter=qsimplify_fock)
|im⟩
```
"""
@withmetadata struct DisplaceOp <: AbstractSingleBosonOp
    alpha::Number
    basis::FockBasis
end
DisplaceOp(alpha::Number) = DisplaceOp(alpha, inf_fock_basis)
symbollabel(x::DisplaceOp) = "D($(x.alpha))"

"""Number operator, also available as the constant `n̂`, in an infinite dimension Fock basis."""
const N = const n̂ = NumberOp()
"""Creation operator, also available as the constant `âꜛ`, in an infinite dimension Fock basis.
There is no unicode dagger superscript, so we use the uparrow"""
const Create = const âꜛ = CreateOp()
"""Annihilation operator, also available as the constant `â`, in an infinite dimension Fock basis."""
const Destroy = const â = DestroyOp()

"""Squeezing operator in defined Fock basis.

```jldoctest
julia> S = SqueezeOp(pi)
S(π)

julia> qsimplify(S*vac, rewriter=qsimplify_fock)
|0,π⟩
```
"""
@withmetadata struct SqueezeOp <: AbstractSingleBosonOp
    z::Number
    basis::FockBasis
end
SqueezeOp(z::Number) = SqueezeOp(z, inf_fock_basis)
symbollabel(x::SqueezeOp) = "S($(x.z))"

using Latexify
using Latexify: LaTeXString

"""The label to put in between |⟩ or ⟨|, etc."""
function symbollabel end

"""Pretty printer helper for subscript indices"""
function num_to_sub(n::Int)
    str = string(n)
    replace(str,
        "1"=>"₁",
        "2"=>"₂",
        "3"=>"₃",
        "4"=>"₄",
        "5"=>"₅",
        "6"=>"₆",
        "7"=>"₇",
        "8"=>"₈",
        "9"=>"₉",
        "0"=>"₀",
    )
end
@latexrecipe function f(x::SBra)
    return Expr(:latexifymerge, "\\left\\langle ", symbollabel(x), "\\right|")
end
@latexrecipe function f(x::Union{SpecialKet,SKet})
    return Expr(:latexifymerge, "\\left|", symbollabel(x), "\\right\\rangle")
end
@latexrecipe function f(x::Union{SOperator,SHermitianOperator,SUnitaryOperator,SHermitianUnitaryOperator,AbstractSingleQubitOp,AbstractTwoQubitOp,AbstractSingleBosonOp})
    return LaTeXString("\\hat $(symbollabel(x))")
end
@latexrecipe function f(x::SZero)
    return LaTeXString("\\bm{O}")
end
@latexrecipe function f(x::SDagger)
    if isexpr(x.obj)
        return Expr(:latexifymerge, "\\left( ", latexify(x.obj), "\\right)^\\dagger")
    else
        return Expr(:latexifymerge, latexify(x.obj), "\\^\\dagger")
    end
end
@latexrecipe function f(x::Union{SScaled,SMulOperator,SOuterKetBra,SApplyKet,SApplyBra})
    cdot --> false
    return _toexpr(x)
end
@latexrecipe function f(x::SCommutator)
    return Expr(:latexifymerge, "\\left\\lbrack", latexify(x.op1), ",", latexify(x.op2), "\\right\\rbrack")
end
@latexrecipe function f(x::SAnticommutator)
    return Expr(:latexifymerge, "\\left\\{", latexify(x.op1), ",", latexify(x.op2), "\\right\\}")
end
@latexrecipe function f(x::SBraKet)
    return Expr(:latexifymerge, "\\left\\langle ", symbollabel(x.bra), "\\mid ", symbollabel(x.ket), "\\right\\rangle")
end
@latexrecipe function f(x::MixedState)
    return LaTeXString("\\mathbb{M}")
end

@latexrecipe function f(x::IdentityOp)
    return LaTeXString("\\mathbb{I}")
end
@latexrecipe function f(x::SInvOperator)
    return Expr(:latexifymerge, latexify(x.op), "\\^{-1}")
end

function _toexpr(x)
    if isexpr(x)
        return Expr(:call, head(x), arguments(x)...)
    else
        x
    end
end
function _addparen(x)
    if isexpr(x)
        return Expr(:latexifymerge, "\\left(", x, "\\right)")
    else
        return x
    end
end
function _toexpr(x::STensor)
    args = [b for a in arguments(x) for b in (_addparen(a), "\\otimes")][1:end-1]
    return Expr(:latexifymerge, args...)
end

@latexrecipe function f(x::SymQObj)
    return _toexpr(x)
end

Base.show(io::IO, ::MIME"text/latex", x::SymQObj) = print(io, latexify(x))

module QuantumCliffordExt

using QuantumInterface
using QuantumInterface: AbstractKet, AbstractOperator, AbstractSuperOperator, CompositeBasis
using QuantumSymbolics
using QuantumSymbolics: HGate, XGate, YGate, ZGate, CPHASEGate, CNOTGate,
    XBasisState, YBasisState, ZBasisState, MixedState, IdentityOp,
    XCXGate, XCYGate, XCZGate, YCXGate, YCYGate, YCZGate, ZCXGate, ZCYGate, ZCZGate,
    Symbolic
import QuantumSymbolics: express, express_nolookup, express_from_cache
using TermInterface
using TermInterface: isexpr, head, operation, arguments, metadata

using QuantumClifford

const _qc_l = MixedDestabilizer(S"Z")
const _qc_h = MixedDestabilizer(S"-Z")
const _qc_s₊ = MixedDestabilizer(S"X")
const _qc_s₋ = MixedDestabilizer(S"-X")
const _qc_i₊ = MixedDestabilizer(S"Y")
const _qc_i₋ = MixedDestabilizer(S"-Y")

express_nolookup(s::XBasisState, ::CliffordRepr) = (_qc_s₊,_qc_s₋)[s.idx]
express_nolookup(s::YBasisState, ::CliffordRepr) = (_qc_i₊,_qc_i₋)[s.idx]
express_nolookup(s::ZBasisState, ::CliffordRepr) = (_qc_l,_qc_h)[s.idx]
function express_nolookup(s::Symbolic{T}, repr::CliffordRepr) where {T<:Union{AbstractKet,AbstractOperator}}
    if isexpr(s) && operation(s)==⊗
        #operation(s)(express.(arguments(s), (repr,))...) # TODO this does not work because QuantumClifford.⊗ is different from ⊗
        QuantumClifford.tensor(express.(arguments(s), (repr,))...)
    else
        error("Encountered an object $(s) of type $(typeof(s)) that can not be converted to $(repr) representation") # TODO make a nice error type
    end
end

express_nolookup(::CPHASEGate,       ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sCPHASE
express_nolookup(::CNOTGate,         ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sCNOT

for control in (:X, :Y, :Z)
    for target in (:X, :Y, :Z)
        structname = Symbol(control,"C",target,"Gate")
        qcname = Symbol("s",control,"C",target)
        defexpress = :(express_nolookup(::$(structname), ::CliffordRepr, ::UseAsOperation) = $(qcname))
        eval(defexpress)
    end
end

express_nolookup(::XGate,            ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sX
express_nolookup(::YGate,            ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sY
express_nolookup(::ZGate,            ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sZ
express_nolookup(::HGate,            ::CliffordRepr, ::UseAsOperation) = QuantumClifford.sHadamard
express_nolookup(x::STensorOperator,  r::CliffordRepr, u::UseAsOperation) = QCGateSequence([express(t,r,u) for t in x.terms])

express_nolookup(op::QuantumClifford.PauliOperator, ::CliffordRepr, ::UseAsObservable) = op
express_nolookup(op::STensorOperator, r::CliffordRepr, u::UseAsObservable) = QuantumClifford.tensor(express.(arguments(op),(r,),(u,))...)
express_nolookup(::XGate, ::CliffordRepr, ::UseAsObservable) = QuantumClifford.P"X"
express_nolookup(::YGate, ::CliffordRepr, ::UseAsObservable) = QuantumClifford.P"Y"
express_nolookup(::ZGate, ::CliffordRepr, ::UseAsObservable) = QuantumClifford.P"Z"
express_nolookup(op::SScaledOperator, r::CliffordRepr, u::UseAsObservable) = arguments(op)[1] * express(arguments(op)[2],r,u)
express_nolookup(x::SMulOperator,     r::CliffordRepr, u::UseAsObservable) = (*)((express(t,r,u) for t in arguments(x))...)
express_nolookup(op, ::CliffordRepr, ::UseAsObservable) = error("Can not convert $(op) into a `PauliOperator`, which is the only observable that can be computed for QuantumClifford objects. Consider defining `express_nolookup(op, ::CliffordRepr, ::UseAsObservable)::PauliOperator` for this object.")

struct QCRandomSampler # TODO specify types
    operators # union of QCRandomSampler and MixedDestabilizer
    weights
end
function express_nolookup(x::SAddOperator, repr::CliffordRepr)
    weights = collect(values(x.dict))
    symops = collect(keys(x.dict))
    # TODO assert norms of operators are all ==1
    @assert sum(weights) ≈ 1.0
    ops = express_nolookup.(symops, (repr,))
    QCRandomSampler(ops, weights)
end
function express_from_cache(x::QCRandomSampler)
    threshold = rand()
    cweights = cumsum(x.weights)
    i = findfirst(>=(threshold), cweights) # TODO make alloc free
    express_from_cache(x.operators[i])
end
function express_nolookup(x::MixedState, ::CliffordRepr)
    nqubits = isa(x.basis, CompositeBasis) ? length(x.basis.bases) : 1
    # TODO assert all are qubits
    one(MixedDestabilizer,0,nqubits)
end
express_nolookup(x::SProjector, repr::CliffordRepr) = express_nolookup(x.ket, repr)

struct QCGateSequence <: QuantumClifford.AbstractSymbolicOperator
    gates # TODO constructor that flattens nested QCGateSequence
end

function QuantumClifford.apply!(
    state::QuantumClifford.MixedDestabilizer,
    indices::AbstractVector{Int},
    gseq::QCGateSequence,
)
    for g in gseq.gates[end:-1:begin]
        apply_popindex!(state, indices, g)
    end
    state
end

function QuantumClifford.apply!(
    r::QuantumClifford.Register,
    indices::Base.AbstractVecOrTuple{Int},
    operation::Symbolic{AbstractOperator},
)
    QuantumClifford.apply!(r, indices, express(operation, CliffordRepr(), UseAsOperation()))
end

function QuantumClifford.apply!(
    r::QuantumClifford.Register,
    indices::Base.AbstractVecOrTuple{Int},
    operation::Symbolic{AbstractSuperOperator},
)
    QuantumClifford.apply!(r, indices, express(operation, CliffordRepr(), UseAsOperation()))
end

apply_popindex!(
    state,
    indices::AbstractVector{Int},
    g::Type{<:QuantumClifford.AbstractSingleQubitOperator},
) = QuantumClifford.apply!(state, g(pop!(indices)::Int))

apply_popindex!(
    state,
    indices::AbstractVector{Int},
    g::Type{<:QuantumClifford.AbstractTwoQubitOperator},
) = QuantumClifford.apply!(state, g(pop!(indices)::Int, pop!(indices)::Int))

QuantumInterface.projector(state::QuantumClifford.Stabilizer) =
    QuantumInterface.projector(StabilizerState(state))

end

using Test
using QuantumSymbolics: Metadata, @withmetadata

@testset "Test metadata decoration" begin
    using QuantumSymbolics: Metadata, @withmetadata
    
    @withmetadata struct Foo1
        a::Int
    end
    @test Foo1(2).metadata isa Metadata

    @withmetadata struct Foo2
        "hi"
        a::Int
    end
    @test Foo2(2).metadata isa Metadata

    @withmetadata struct Foo3{T<:Int}
        "hi"
        a::T
        "hi"
        b::T
    end
    @test Foo3{Int}(2, 3).metadata isa Metadata

    @withmetadata struct Foo4{T<:Int} <: Integer
        a::T
        b::T
    end
    @test Foo4{Int}(2, 3).metadata isa Metadata

    @withmetadata struct Foo5 <: Integer
        a
    end
    @test Foo5(2).metadata isa Metadata

    @withmetadata struct Foo6 <: Integer end
    @test Foo6().metadata isa Metadata
end

@testitem "Test throwing" begin
    using QuantumOptics
    using QuantumInterface: IncompatibleBases

    @op A SpinBasis(1//2) ⊗ SpinBasis(1//2); @op B; @op C;
    @ket k; @bra b; @ket l SpinBasis(1//2) ⊗ SpinBasis(1//2);

    @test_throws IncompatibleBases A*B
    @test_throws IncompatibleBases commutator(A, B)
    @test_throws IncompatibleBases anticommutator(A, B)
    @test_throws IncompatibleBases A*k
    @test_throws IncompatibleBases b*A
    @test_throws IncompatibleBases l*b
    @test_throws IncompatibleBases b*l
    @test_throws ArgumentError ptrace(B, 2)
    @test_throws ArgumentError ptrace(B+C, 2)
end

##
# This file defines the symbolic operations for quantum objects (kets, operators, and bras) that are inhomogeneous in their arguments.
##

"""Symbolic application of an operator on a ket (from the left).

```jldoctest
julia> @ket k; @op A;

julia> A*k
A|k⟩
```
"""
@withmetadata struct SApplyKet <: Symbolic{AbstractKet}
    op
    ket
end
isexpr(::SApplyKet) = true
iscall(::SApplyKet) = true
arguments(x::SApplyKet) = [x.op,x.ket]
operation(x::SApplyKet) = *
head(x::SApplyKet) = :*
children(x::SApplyKet) = [:*,x.op,x.ket]
function Base.:(*)(op::Symbolic{AbstractOperator}, k::Symbolic{AbstractKet})
    if !(samebases(basis(op),basis(k)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([op k])
        coeff*SApplyKet(cleanterms...)
    end
end
Base.:(*)(op::SZeroOperator, k::Symbolic{AbstractKet}) = SZeroKet()
Base.:(*)(op::Symbolic{AbstractOperator}, k::SZeroKet) = SZeroKet()
Base.:(*)(op::SZeroOperator, k::SZeroKet) = SZeroKet()
function Base.show(io::IO, x::SApplyKet) 
    str_func = x -> x isa SAdd || x isa STensorOperator ? "("*string(x)*")" : string(x)
    print(io, join(map(str_func, arguments(x)),""))
end
basis(x::SApplyKet) = basis(x.ket)

"""Symbolic application of an operator on a bra (from the right).

```jldoctest
julia> @bra b; @op A;

julia> b*A
⟨b|A
```
"""
@withmetadata struct SApplyBra <: Symbolic{AbstractBra}
    bra
    op
end
isexpr(::SApplyBra) = true
iscall(::SApplyBra) = true
arguments(x::SApplyBra) = [x.bra,x.op]
operation(x::SApplyBra) = *
head(x::SApplyBra) = :*
children(x::SApplyBra) = [:*,x.bra,x.op]
function Base.:(*)(b::Symbolic{AbstractBra}, op::Symbolic{AbstractOperator}) 
    if !(samebases(basis(b),basis(op)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([b op])
        coeff*SApplyBra(cleanterms...)
    end
end
Base.:(*)(b::SZeroBra, op::Symbolic{AbstractOperator}) = SZeroBra()
Base.:(*)(b::Symbolic{AbstractBra}, op::SZeroOperator) = SZeroBra()
Base.:(*)(b::SZeroBra, op::SZeroOperator) = SZeroBra()
function Base.show(io::IO, x::SApplyBra) 
    str_func = x -> x isa SAdd || x isa STensorOperator ? "("*string(x)*")" : string(x)
    print(io, join(map(str_func, arguments(x)),""))
end
basis(x::SApplyBra) = basis(x.bra)

"""Symbolic inner product of a bra and a ket.

```jldoctest
julia> @bra b; @ket k;

julia> b*k
⟨b||k⟩
```
"""
@withmetadata struct SBraKet <: Symbolic{Complex}
    bra
    ket
end
isexpr(::SBraKet) = true
iscall(::SBraKet) = true
arguments(x::SBraKet) = [x.bra,x.ket]
operation(x::SBraKet) = *
head(x::SBraKet) = :*
children(x::SBraKet) = [:*,x.bra,x.ket]
function Base.:(*)(b::Symbolic{AbstractBra}, k::Symbolic{AbstractKet}) 
    if !(samebases(basis(b),basis(k)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([b k])
        coeff == 1 ? SBraKet(cleanterms...) : coeff*SBraKet(cleanterms...)
    end
end
Base.:(*)(b::SZeroBra, k::Symbolic{AbstractKet}) = 0
Base.:(*)(b::Symbolic{AbstractBra}, k::SZeroKet) = 0
Base.:(*)(b::SZeroBra, k::SZeroKet) = 0
Base.show(io::IO, x::SBraKet) = begin print(io,x.bra); print(io,x.ket) end
Base.hash(x::SBraKet, h::UInt) = hash((head(x), arguments(x)), h)
maketerm(::Type{SBraKet}, f, a, m) = f(a...)
Base.isequal(x::SBraKet, y::SBraKet) = isequal(x.bra, y.bra) && isequal(x.ket, y.ket)

"""Symbolic outer product of a ket and a bra.

```jldoctest 
julia> @bra b; @ket k;

julia> k*b 
|k⟩⟨b|
```
"""
@withmetadata struct SOuterKetBra <: Symbolic{AbstractOperator}
    ket
    bra
end
isexpr(::SOuterKetBra) = true
iscall(::SOuterKetBra) = true
arguments(x::SOuterKetBra) = [x.ket,x.bra]
operation(x::SOuterKetBra) = *
head(x::SOuterKetBra) = :*
children(x::SOuterKetBra) = [:*,x.ket,x.bra]
function Base.:(*)(k::Symbolic{AbstractKet}, b::Symbolic{AbstractBra})
    if !(samebases(basis(k),basis(b)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([k b])
        coeff*SOuterKetBra(cleanterms...)
    end
end
Base.:(*)(k::SZeroKet, b::Symbolic{AbstractBra}) = SZeroOperator()
Base.:(*)(k::Symbolic{AbstractKet}, b::SZeroBra) = SZeroOperator()
Base.:(*)(k::SZeroKet, b::SZeroBra) = SZeroOperator()
Base.show(io::IO, x::SOuterKetBra) = begin print(io, x.ket); print(io, x.bra) end
basis(x::SOuterKetBra) = basis(x.ket)

using Test
using QuantumSymbolics

@testset "Outer Product" begin
    using QuantumOpticsBase

    @test isequal(L1*dagger(L0), SOuterKetBra(L1,dagger(L0)))

    @test isequal(express(L1*dagger(L0)), projector(express(L1), express(dagger(L0))))

end

##
# This file defines the symbolic operations for quantum objects (kets, operators, and bras)
# that are homogeneous in their arguments.
##

"""Scaling of a quantum object (ket, operator, or bra) by a number.

```jldoctest
julia> @ket k
|k⟩

julia> 2*k
2|k⟩

julia> @op A
A

julia> 2*A
2A
```
"""
@withmetadata struct SScaled{T<:QObj} <: Symbolic{T}
    coeff
    obj
end
isexpr(::SScaled) = true
iscall(::SScaled) = true
arguments(x::SScaled) = [x.coeff,x.obj]
operation(x::SScaled) = *
head(x::SScaled) = :*
children(x::SScaled) = [:*,x.coeff,x.obj]
function Base.:(*)(c::U, x::Symbolic{T}) where {U<:Union{Number, Symbolic{<:Number}},T<:QObj}
    if (isa(c, Number) && iszero(c)) || iszero(x)
        SZero{T}()
    elseif _isone(c)
        x
    elseif isa(x, SScaled)
        SScaled{T}(c*x.coeff, x.obj)
    else
        SScaled{T}(c, x)
    end
end

Base.:(*)(x::Symbolic{T}, c::Number) where {T<:QObj} = c*x
Base.:(*)(x::Symbolic{T}, y::Symbolic{S}) where {T<:QObj,S<:QObj} = throw(ArgumentError("multiplication between $(typeof(x)) and $(typeof(y)) is not defined; maybe you are looking for a tensor product `tensor`"))
Base.:(/)(x::Symbolic{T}, c::Number) where {T<:QObj} = iszero(c) ? throw(DomainError(c,"cannot divide QSymbolics expressions by zero")) : (1/c)*x
basis(x::SScaled) = basis(x.obj)

const SScaledKet = SScaled{AbstractKet}
function Base.show(io::IO, x::SScaledKet)
    if x.coeff isa Real
        if x.obj isa SAddKet
            print(io, "$(x.coeff)($(x.obj))")
        else
            print(io, "$(x.coeff)$(x.obj)")
        end
    else
        if x.obj isa SAddKet
            print(io, "($(x.coeff))($(x.obj))")
        else
            print(io, "($(x.coeff))$(x.obj)")
        end
    end
end
const SScaledOperator = SScaled{AbstractOperator}
function Base.show(io::IO, x::SScaledOperator)
    if x.coeff isa Real
        if x.obj isa SAddOperator
            print(io, "$(x.coeff)($(x.obj))")
        else
            print(io, "$(x.coeff)$(x.obj)")
        end
    else
        if x.obj isa SAddOperator
            print(io, "($(x.coeff))($(x.obj))")
        else
            print(io, "($(x.coeff))$(x.obj)")
        end
    end
end
const SScaledBra = SScaled{AbstractBra}
function Base.show(io::IO, x::SScaledBra)
    if x.coeff isa Real
        if x.obj isa SAddBra
            print(io, "$(x.coeff)($(x.obj))")
        else
            print(io, "$(x.coeff)$(x.obj)")
        end
    else
        if x.obj isa SAddBra
            print(io, "($(x.coeff))($(x.obj))")
        else
            print(io, "($(x.coeff))$(x.obj)")
        end
    end
end

"""Addition of quantum objects (kets, operators, or bras).

```jldoctest
julia> @ket k₁; @ket k₂;

julia> k₁ + k₂
|k₁⟩+|k₂⟩
```
"""
@withmetadata struct SAdd{T<:QObj} <: Symbolic{T}
    dict
    _set_precomputed
    _arguments_precomputed
end
function SAdd{S}(d) where S
    isempty(d) && return SZero{S}()
    terms = [c*obj for (obj,c) in d]
    length(d)==1 ? first(terms) : SAdd{S}(d,Set(terms),terms)
end
isexpr(::SAdd) = true
iscall(::SAdd) = true
arguments(x::SAdd) = x._arguments_precomputed
operation(x::SAdd) = +
head(x::SAdd) = :+
children(x::SAdd) = [:+; x._arguments_precomputed]
function Base.:(+)(x::Symbolic{T}, xs::Vararg{Symbolic{T}, N}) where {T<:QObj, N}
    xs = (x, xs...)
    xs = collect(xs)
    f = first(xs)
    nonzero_terms = filter!(x->!iszero(x),xs)
    isempty(nonzero_terms) ? f : SAdd{T}(countmap_flatten(nonzero_terms, SAdd{T}, SScaled{T}))
end
basis(x::SAdd) = basis(first(x.dict).first)

const SAddBra = SAdd{AbstractBra}
function Base.show(io::IO, x::SAddBra)
    ordered_terms = sort([repr(i) for i in arguments(x)])
    print(io, join(ordered_terms,"+")::String) # type assert to help inference
end
const SAddKet = SAdd{AbstractKet}
function Base.show(io::IO, x::SAddKet)
    ordered_terms = sort([repr(i) for i in arguments(x)])
    print(io, join(ordered_terms,"+")::String) # type assert to help inference
end
const SAddOperator = SAdd{AbstractOperator}
function Base.show(io::IO, x::SAddOperator)
    repr_func = x -> x isa STensor ? "("*repr(x)*")" : repr(x)
    ordered_terms = sort([repr_func(i) for i in arguments(x)])
    print(io, join(ordered_terms,"+")::String) # type assert to help inference
end

"""Symbolic application of operator on operator.

```jldoctest
julia> @op A; @op B;

julia> A*B
AB
```
"""
@withmetadata struct SMulOperator <: Symbolic{AbstractOperator}
    terms
end
isexpr(::SMulOperator) = true
iscall(::SMulOperator) = true
arguments(x::SMulOperator) = x.terms
operation(x::SMulOperator) = *
head(x::SMulOperator) = :*
children(x::SMulOperator) = [:*;x.terms]
function Base.:(*)(x::Symbolic{AbstractOperator}, xs::Vararg{Symbolic{AbstractOperator}, N}) where {N}
    xs = (x, xs...)
    zero_ind = findfirst(x->iszero(x), xs)
    if isnothing(zero_ind)
        if any(x->!(samebases(basis(x),basis(first(xs)))),xs)
            throw(IncompatibleBases())
        else
            terms = flattenop(*, collect(xs))
            coeff, cleanterms = prefactorscalings(terms)
            coeff * SMulOperator(cleanterms)
        end
    else
        SZeroOperator()
    end
end
function Base.show(io::IO, x::SMulOperator)
    str_func = x -> x isa SAdd || x isa STensor ? "("*string(x)*")" : string(x)
    print(io, join(map(str_func, arguments(x)),""))
end
basis(x::SMulOperator) = basis(first(x.terms))

"""Tensor product of quantum objects (kets, operators, or bras).

```jldoctest
julia> @ket k₁; @ket k₂;

julia> k₁ ⊗ k₂
|k₁⟩|k₂⟩

julia> @op A; @op B;

julia> A ⊗ B
A⊗B
```
"""
@withmetadata struct STensor{T<:QObj} <: Symbolic{T}
    terms
end
isexpr(::STensor) = true
iscall(::STensor) = true
arguments(x::STensor) = x.terms
operation(x::STensor) = ⊗
head(x::STensor) = :⊗
children(x::STensor) = [:⊗; x.terms]
function ⊗(xs::Symbolic{T}...) where {T<:QObj}
    zero_ind = findfirst(x->iszero(x), xs)
    if isnothing(zero_ind)
        terms = flattenop(⊗, collect(xs))
        coeff, cleanterms = prefactorscalings(terms)
        coeff * STensor{T}(cleanterms)
    else
        SZero{T}()
    end
end
basis(x::STensor) = tensor(basis.(x.terms)...)

const STensorBra = STensor{AbstractBra}
Base.show(io::IO, x::STensorBra) = print(io, join(map(string, arguments(x)),""))
const STensorKet = STensor{AbstractKet}
Base.show(io::IO, x::STensorKet) = print(io, join(map(string, arguments(x)),""))
const STensorOperator = STensor{AbstractOperator}
function Base.show(io::IO, x::STensorOperator)
    str_func = x -> x isa SAdd ? "("*string(x)*")" : string(x)
    print(io, join(map(str_func, arguments(x)),"⊗"))
end
const STensorSuperOperator = STensor{AbstractSuperOperator}
function Base.show(io::IO, x::STensorSuperOperator)
    str_func = x -> x isa SAdd ? "("*string(x)*")" : string(x)
    print(io, join(map(str_func, arguments(x)),"⊗"))
end

@testitem "Dagger" begin
    using QuantumInterface: AbstractOperator

    @bra b₁; @bra b₂;
    @ket k₁; @ket k₂;

    @op A; @op B; @op C;
    U = SUnitaryOperator(:U); ℋ = SHermitianOperator(:ℋ);

    @testset "symbolic dagger tests" begin
        @test isequal(dagger(im*k₁), -im*dagger(k₁))
        @test isequal(dagger(k₁+k₂), dagger(k₁)+dagger(k₂))
        @test isequal(dagger(im*b₁), -im*dagger(b₁))
        @test isequal(dagger(b₁+b₂), dagger(b₁)+dagger(b₂))
        @test isequal(dagger(A+B), dagger(A) + dagger(B))
        @test isequal(dagger(ℋ), ℋ)
        @test isequal(dagger(U), inv(U))
        @test isequal(dagger(b₁⊗b₂), dagger(b₁)⊗dagger(b₂))
        @test isequal(dagger(k₁⊗k₂), dagger(k₁)⊗dagger(k₂))
        @test isequal(dagger(A⊗B), dagger(A)⊗dagger(B))
        @test isequal(dagger(im*A), -im*dagger(A))
        @test isequal(dagger(A*k₁), dagger(k₁)*dagger(A))
        @test isequal(dagger(b₁*A), dagger(A)*dagger(b₁))
        @test isequal(dagger(A*B*C), dagger(C)*dagger(B)*dagger(A))
        @test isequal(dagger(b₁*k₁), dagger(k₁)*dagger(b₁))
        @test isequal(dagger(k₁*b₁), dagger(b₁)*  dagger(k₁))
        @test isequal(dagger(dagger(A)), A)
        @test isequal(dagger(dagger(A)), A)
    end
end

using Test
using QuantumSymbolics

@testset "Sym expressions" begin
    @test +(Z1) == Z1
    @test +(Z) == Z
    @test isequal(Z1 - Z2, Z1 + (-Z2))
    @test isequal(Z1 - 2*Z2 + 2*X1, -2*Z2 + Z1 + 2*X1)
    @test isequal(Z1 - 2*Z2 + 2*X1, Z1 + 2*(-Z2+X1))

    state1 = XBasisState(1, SpinBasis(1//2))
    state2 = XBasisState(1, SpinBasis(1//2))
    state3 = XBasisState(2, SpinBasis(1//2))

    @test isequal(state1, state2)
    @test !isequal(state1, state3)

    @op A
    @op B

    @test isequal(A+B+A, 2A+B)
    @test isequal(A+B-A, B)
    @test A+B-A === B
    @test 0*A === A-A-2A+2A
    @test isequal(A+B-A+B, 2B)
    @test isequal(2A-3B+2(A+B), 4A-B)
    @test isequal(2A-3B+2(A+2B), 4A+B)
end

module QuantumOpticsExt

using QuantumInterface, QuantumOpticsBase
using QuantumInterface: samebases
using QuantumSymbolics
using QuantumSymbolics:
    HGate, XGate, YGate, ZGate, CPHASEGate, CNOTGate, PauliP, PauliM,
    XCXGate, XCYGate, XCZGate, YCXGate, YCYGate, YCZGate, ZCXGate, ZCYGate, ZCZGate,
    XBasisState, YBasisState, ZBasisState,
    NumberOp, CreateOp, DestroyOp,
    FockState,
    MixedState, IdentityOp,
    qubit_basis
import QuantumSymbolics: express, express_nolookup
using TermInterface
using TermInterface: isexpr, head, operation, arguments, metadata

const _b2 = SpinBasis(1//2)
const _l0 = spinup(_b2)
const _l1 = spindown(_b2)
const _s₊ = (_l0+_l1)/√2
const _s₋ = (_l0-_l1)/√2
const _i₊ = (_l0+im*_l1)/√2
const _i₋ = (_l0-im*_l1)/√2
const _σ₊ = sigmap(_b2)
const _σ₋ = sigmam(_b2)
const _l00 = projector(_l0)
const _l11 = projector(_l1)
const _id = identityoperator(_b2)
const _z = sigmaz(_b2)
const _x = sigmax(_b2)
const _y = sigmay(_b2)
const _hadamard = (sigmaz(_b2)+sigmax(_b2))/√2
const _cnot = _l00⊗_id + _l11⊗_x
const _cphase = _l00⊗_id + _l11⊗_z
const _phase = _l00 + im*_l11
const _iphase = _l00 - im*_l11

const _bf2 = FockBasis(2)
const _f0₂ = fockstate(_bf2, 0)
const _f1₂ = fockstate(_bf2, 1)
const _ad₂ = create(_bf2)
const _a₂ = destroy(_bf2)
const _n₂ = number(_bf2)

express_nolookup(::HGate, ::QuantumOpticsRepr) = _hadamard
express_nolookup(::XGate, ::QuantumOpticsRepr) = _x
express_nolookup(::YGate, ::QuantumOpticsRepr) = _y
express_nolookup(::ZGate, ::QuantumOpticsRepr) = _z
express_nolookup(::CPHASEGate, ::QuantumOpticsRepr) = _cphase
express_nolookup(::CNOTGate, ::QuantumOpticsRepr) = _cnot

const xyzopdict = Dict(:X=>_x, :Y=>_y, :Z=>_z)
const xyzstatedict = Dict(:X=>(_s₊,_s₋),:Y=>(_i₊,_i₋),:Z=>(_l0,_l1))
for control in (:X, :Y, :Z)
    for target in (:X, :Y, :Z)
        k1, k2 = xyzstatedict[control]
        o = xyzopdict[target]
        gate = projector(k1)⊗_id + projector(k2)⊗o
        structname = Symbol(control,"C",target,"Gate")
        let gate=copy(gate)
            @eval express_nolookup(::$(structname), ::QuantumOpticsRepr) = $gate
        end
    end
end

express_nolookup(::PauliM, ::QuantumOpticsRepr) = _σ₋
express_nolookup(::PauliP, ::QuantumOpticsRepr) = _σ₊

express_nolookup(s::XBasisState, ::QuantumOpticsRepr) = (_s₊,_s₋)[s.idx]
express_nolookup(s::YBasisState, ::QuantumOpticsRepr) = (_i₊,_i₋)[s.idx]
express_nolookup(s::ZBasisState, ::QuantumOpticsRepr) = (_l0,_l1)[s.idx]

function finite_basis(s,r)
    if isfinite(length(basis(s)))
        return basis(s)
    else
        if isa(basis(s), FockBasis)
            return FockBasis(r.cutoff)
        else
            error()
        end
    end
end
express_nolookup(s::FockState, r::QuantumOpticsRepr) = fockstate(finite_basis(s,r),s.idx)
express_nolookup(s::CoherentState, r::QuantumOpticsRepr) = coherentstate(finite_basis(s,r),s.alpha)
express_nolookup(s::SqueezedState, r::QuantumOpticsRepr) = (b = finite_basis(s,r); squeeze(b, s.z)*fockstate(b, 0))
express_nolookup(o::NumberOp, r::QuantumOpticsRepr) = number(finite_basis(o,r))
express_nolookup(o::CreateOp, r::QuantumOpticsRepr) = create(finite_basis(o,r))
express_nolookup(o::DestroyOp, r::QuantumOpticsRepr) = destroy(finite_basis(o,r))
express_nolookup(o::DisplaceOp, r::QuantumOpticsRepr) = displace(finite_basis(o,r), o.alpha)
express_nolookup(o::SqueezeOp, r::QuantumOpticsRepr) = squeeze(finite_basis(o,r), o.z)
express_nolookup(x::MixedState, r::QuantumOpticsRepr) = identityoperator(finite_basis(x,r))/length(finite_basis(x,r)) # TODO there is probably a more efficient way to represent it
express_nolookup(x::IdentityOp, r::QuantumOpticsRepr) = identityoperator(finite_basis(x,r))

express_nolookup(p::PauliNoiseCPTP, ::QuantumOpticsRepr) = LazySuperSum(SpinBasis(1//2), [1-p.px-p.py-p.pz,p.px,p.py,p.pz],
                                                               [LazyPrePost(_id,_id),LazyPrePost(_x,_x),LazyPrePost(_y,_y),LazyPrePost(_z,_z)])

express_nolookup(s::SOuterKetBra, r::QuantumOpticsRepr) = projector(express(s.ket, r), express(s.bra, r))

include("should_upstream.jl")

end

@testitem "Fock" begin
    using Symbolics: Term
    state1 = FockState(1)
    state2 = FockState(2)
    cstate = CoherentState(im)
    phase1 = PhaseShiftOp(0)
    phase2 = PhaseShiftOp(pi)
    displace = DisplaceOp(im)
    squeezeop = SqueezeOp(pi)
    sstate = SqueezedState(pi)

    @testset "ladder and number operators" begin
        @test isequal(qsimplify(Destroy*vac, rewriter=qsimplify_fock), SZeroKet())
        @test isequal(qsimplify(Create*state1, rewriter=qsimplify_fock), Term(sqrt, [2])*state2)
        @test isequal(qsimplify(Destroy*state2, rewriter=qsimplify_fock), Term(sqrt, [2])*state1)
        @test isequal(qsimplify(N*state2, rewriter=qsimplify_fock), 2*state2)
        @test isequal(qsimplify(Destroy*cstate, rewriter=qsimplify_fock), im*cstate)
    end

    @testset "Displacement and phase operators" begin
        @test isequal(qsimplify(phase1*cstate, rewriter=qsimplify_fock), CoherentState(im))
        @test isequal(qsimplify(dagger(phase2)*Destroy*phase2, rewriter=qsimplify_fock), Destroy*exp(-im*pi))
        @test isequal(qsimplify(phase2*Destroy*dagger(phase2), rewriter=qsimplify_fock), Destroy*exp(im*pi))
        @test isequal(qsimplify(dagger(displace)*Destroy*displace, rewriter=qsimplify_fock), Destroy + im*IdentityOp(inf_fock_basis))
        @test_broken isequal(qsimplify(dagger(displace)*Create*displace, rewriter=qsimplify_fock), Create - im*IdentityOp(inf_fock_basis))
        @test isequal(qsimplify(displace*vac, rewriter=qsimplify_fock), cstate)
    end

    @testset "Squeeze operators" begin
        @test isequal(qsimplify(squeezeop*vac, rewriter=qsimplify_fock), sstate)
    end
end

using Test
using QuantumSymbolics

@testset "Test qo gaussian" begin
    using LinearAlgebra: diagm
    using QuantumOptics
    using QuantumSymbolics

    samestate(ket1, ket2; atol=1e-10) = isapprox(dm(ket1), dm(ket2); atol=atol, rtol=0)

    function two_mode_ops(cutoff)
        mode_basis = FockBasis(cutoff)
        basis = mode_basis^2
        return (
            basis = basis,
            vacuum = fockstate(mode_basis, 0) ⊗ fockstate(mode_basis, 0),
            a1 = embed(basis, 1, destroy(mode_basis)),
            a2 = embed(basis, 2, destroy(mode_basis)),
            ad1 = embed(basis, 1, create(mode_basis)),
            ad2 = embed(basis, 2, create(mode_basis)),
        )
    end

    @testset "Single-mode Gaussian objects" begin
        repr = QuantumOpticsRepr(10)
        basis = FockBasis(repr.cutoff)
        α = 0.2 - 0.1im
        θ = 0.3
        n̄ = 1.2

        thermal = express(BosonicThermalState(n̄), repr)
        weights = (n̄ / (n̄ + 1)) .^ collect(basis.offset:basis.N)
        expected_thermal = normalize(DenseOperator(basis, diagm(0 => weights)))

        @test thermal ≈ expected_thermal
        @test express(PhaseShiftOp(θ), repr) ≈ exp(-im * θ * dense(number(basis)))
        @test samestate(
            express(PhaseShiftOp(θ) * CoherentState(α), repr),
            coherentstate(basis, α * exp(-im * θ)),
        )
        @test express(PhaseShiftOp(θ) * BosonicThermalState(n̄) * dagger(PhaseShiftOp(θ)), repr) ≈ thermal
    end

    @testset "Two-mode Gaussian objects" begin
        repr = QuantumOpticsRepr(8)
        ops = two_mode_ops(repr.cutoff)
        z = 0.17 * exp(-0.3im)
        τ = 0.35

        twosqueeze = exp(dense(conj(z) * ops.a1 * ops.a2 - z * ops.ad1 * ops.ad2))
        beamsplitter = exp(asin(sqrt(τ)) * dense(ops.ad1 * ops.a2 - ops.a1 * ops.ad2))

        @test express(TwoSqueezeOp(z), repr) ≈ twosqueeze
        @test samestate(express(TwoSqueezedState(z), repr), twosqueeze * ops.vacuum)
        @test samestate(express(TwoSqueezeOp(z) * (vac ⊗ vac), repr), express(TwoSqueezedState(z), repr))

        @test express(BeamSplitterOp(τ), repr) ≈ beamsplitter
        @test samestate(
            express(BeamSplitterOp(τ) * (CoherentState(0.1 + 0.2im) ⊗ vac), repr),
            beamsplitter * express(CoherentState(0.1 + 0.2im) ⊗ vac, repr),
        )
    end
end

@testitem "Gabs objects" begin
    using QuantumSymbolics
    using Gabs

    α = rand(ComplexF64)
    r, θ, τ = rand(Float64), rand(Float64), rand(Float64)
    n̄ = rand(1:10)

    for basis in [QuadBlockBasis, QuadPairBasis]
        @testset "Gaussian states - $(basis)" begin
            @test express(vac, GabsRepr(basis)) ≈ vacuumstate(basis(1))
            @test express(CoherentState(α), GabsRepr(basis)) ≈ coherentstate(basis(1), α)
            @test express(SqueezedState(r*exp(im*θ)), GabsRepr(basis)) ≈ squeezedstate(basis(1), r, θ)
            @test express(TwoSqueezedState(r*exp(im*θ)), GabsRepr(basis)) ≈ eprstate(basis(2), r, θ)
            @test express(BosonicThermalState(n̄), GabsRepr(basis)) ≈ thermalstate(basis(1), n̄)
        end

        @testset "Gaussian unitaries - $(basis)" begin
            @test express(PhaseShiftOp(θ), GabsRepr(basis)) ≈ phaseshift(basis(1), θ)
            @test express(DisplaceOp(α), GabsRepr(basis)) ≈ displace(basis(1), α)
            @test express(SqueezeOp(r*exp(im*θ)), GabsRepr(basis)) ≈ squeeze(basis(1), r, θ)
            @test express(TwoSqueezeOp(r*exp(im*θ)), GabsRepr(basis)) ≈ twosqueeze(basis(2), r, θ)
            @test express(BeamSplitterOp(τ), GabsRepr(basis)) ≈ beamsplitter(basis(2), τ)
        end

        @testset "Gaussian channels - $(basis)" begin
            @test express(AttenuatorCPTP(θ, τ), GabsRepr(basis)) ≈ attenuator(basis(1), θ, τ)
            @test express(AmplifierCPTP(r, τ), GabsRepr(basis)) ≈ amplifier(basis(1), r, τ)
        end

        @testset "Linear algebra operations" begin
            @test express(CoherentState(α) ⊗ TwoSqueezedState(r*exp(im*θ)) ⊗ vac, GabsRepr(basis)) ≈ coherentstate(basis(1), α) ⊗ eprstate(basis(2), r, θ) ⊗ vacuumstate(basis(1))
            @test express(DisplaceOp(α) * vac, GabsRepr(basis)) ≈ coherentstate(basis(1), α)
            @test express(DisplaceOp(α) ⊗ SqueezeOp(r*exp(im*θ)) * (vac ⊗ vac), GabsRepr(basis)) ≈ coherentstate(basis(1), α) ⊗ squeezedstate(basis(1), r, θ)
            @test_broken express(ptrace(DisplaceOp(α) ⊗ PhaseShiftOp(θ) ⊗ BeamSplitterOp(τ), [2, 3]), GabsRepr(basis)) ≈ ptrace(displace(basis(1), α) ⊗ phaseshift(basis(1), θ) ⊗ beamsplitter(basis(2), τ), [2, 3])
        end
    end
end

using Test
using QuantumSymbolics

@testset "Commutator" begin
    @op A; @op B;

    @testset "symbolic commutator tests" begin
        @test isequal(commutator(2*A, B), commutator(A, 2*B)) && isequal(2*commutator(A, B), commutator(2*A, B)) && isequal(commutator(A, 2*B), 2*commutator(A, B))
        @test commutator(A, A) == SZeroOperator()
    end

    @testset "commutator Pauli tests" begin
        @test isequal(qsimplify(commutator(X, Y), rewriter=qsimplify_commutator), 2*im*Z)
        @test isequal(qsimplify(commutator(Y, X), rewriter=qsimplify_commutator), -2*im*Z)
        @test isequal(qsimplify(commutator(Y, Z), rewriter=qsimplify_commutator), 2*im*X)
        @test isequal(qsimplify(commutator(Z, Y), rewriter=qsimplify_commutator), -2*im*X)
        @test isequal(qsimplify(commutator(Z, X), rewriter=qsimplify_commutator), 2*im*Y)
        @test isequal(qsimplify(commutator(X, Z), rewriter=qsimplify_commutator), -2*im*Y)
    end
end

using QuantumSymbolics
using TestItemRunner

JET_flag = false

if get(ENV, "JET_TEST", "") != "true"
    @info "Skipping JET tests -- must be explicitly enabled."
    @info "Environment must set JET_TEST=true."
else
    JET_flag = true
end

using Pkg
JET_flag && Pkg.add("JET")

# filter for the test
testfilter = ti -> begin
    exclude = Symbol[]
    if !JET_flag
        push!(exclude, :jet)
    end
    if !(VERSION >= v"1.10")
        push!(exclude, :doctests)
        push!(exclude, :aqua)
    end

    return all(!in(exclude), ti.tags)
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@run_package_tests filter=testfilter

@testitem "Zero operator" begin
    A = SOperator(:A, SpinBasis(1//2))
    k = SKet(:k, SpinBasis(1//2))
    b = SBra(:b, SpinBasis(1//2))

    Oop = SZeroOperator()
    Ok = SZeroKet()
    Ob = SZeroBra()

    @testset "zero operator tests" begin
        @test isequal(0*A, Oop) && isequal(A*0, Oop)
        @test isequal(2*Oop, Oop) && isequal(Oop*2, Oop) && isequal(Oop/2, Oop)
        @test isequal(Oop + A, A) && isequal(A + Oop, A) && isequal(Oop + Oop, Oop)
        @test isequal(Oop*A, Oop) && isequal(A*Oop, Oop)
        @test isequal(Oop ⊗ A, Oop) && isequal(A ⊗ Oop, Oop) && isequal(Oop*Oop, Oop)
        @test isequal(commutator(A, Oop), Oop) && isequal(commutator(Oop, A), Oop) && isequal(commutator(Oop, Oop), Oop)
        @test isequal(anticommutator(A, Oop), Oop) && isequal(anticommutator(Oop, A), Oop) && isequal(anticommutator(Oop, Oop), Oop)
        @test isequal(projector(Ok), Oop)
        @test isequal(dagger(Oop), Oop)
        @test isequal(zero(A), Oop)
    end

    @testset "zero bra and ket tests" begin
        @test isequal(0*k, Ok) && isequal(k*0, Ok)
        @test isequal(2*Ok, Ok) && isequal(Ok*2, Ok) && isequal(Ok/2, Ok)
        @test isequal(Ok + k, k) && isequal(k + Ok, k) && isequal(Ok + Ok, Ok)
        @test isequal(Ok ⊗ k, Ok) && isequal(k ⊗ Ok, Ok)
        @test isequal(0*b, Ob) && isequal(b*0, Ob)
        @test isequal(2*Ob, Ob) && isequal(Ob*2, Ob) && isequal(Ob/2, Ob)
        @test isequal(Ob + b, b) && isequal(b + Ob, b) && isequal(Ob + Ob, Ob)
        @test isequal(Ob ⊗ b, Ob) && isequal(b ⊗ Ob, Ob)
        @test isequal(Oop*k, Ok) && isequal(A*Ok, Ok) && isequal(Oop*Ok, Ok)
        @test isequal(b*Oop, Ob) && isequal(Ob*A, Ob) && isequal(Ob*Oop, Ob)
        @test isequal(Ok*b, Oop) && isequal(k*Ob, Oop) && isequal(Ok*Ob, Oop)
        @test isequal(Ob*k, 0) && isequal(b*Ok, 0) && isequal(Ob*Ok, 0)
    end
end

@testitem "Express opt" begin
    import QuantumClifford
    import QuantumOptics

    state = 1im*X2⊗Z1+2*Y1⊗(Z2+X2)+StabilizerState("XZ YY")
    express(state)
    express(state)
    state = 1im*X1⊗Z2+2*Y2⊗(Z1+X1)+StabilizerState("YX ZZ")
    nocache = @timed express(state)
    withcache = @timed express(state)
    @test nocache.time > 10*withcache.time
    @test withcache.bytes == 0
    @test nocache.value ≈ withcache.value ≈ express(1im*X1⊗Z2+2*Y2⊗(Z1+X1)+StabilizerState("YX ZZ"))

    state = 1im*X1⊗Z2+2*Y2⊗(Z1+X1)+StabilizerState("YX ZZ")
    state = SProjector(state)+2*X⊗(Z+Y)/3im
    state = state+MixedState(state)
    state2 = deepcopy(state)
    express(state)
    express(state)
    nocache = @timed express(state2)
    withcache = @timed express(state2)
    @test nocache.time > 20*withcache.time
    @test withcache.bytes == 0
    @test nocache.value ≈ withcache.value ≈ express(state2)

    state = 1im*F1⊗F0
    state1 = N⊗Create * state
    @test express(state1) ≈ 1im*express(F1)⊗express(F1)
    @test express(IdentityOp(F1)⊗Destroy)*express(state1) ≈ express((IdentityOp(F1)⊗Destroy)*state1) ≈ express(state)

    state = F0⊗X1 + F1⊗Z1
    op = N⊗X
    @test express(op*state) ≈ express(op)*express(state)
    @test express(op*state) ≈ express(F1⊗Z2)

    state = (3im*(2*dagger(Z1)+dagger(Y1))) * (3im*(2*X1+X2))

    cstate = CoherentState(im, inf_fock_basis)
    displace = DisplaceOp(im,inf_fock_basis)
    phase = PhaseShiftOp(im, inf_fock_basis)
    @test express(N*F1) ≈ express(N)*express(F1)
    @test express(Create*F1) ≈ express(Create)*express(F1)
    @test express(Destroy*F1) ≈ express(Destroy)*express(F1)
    @test express(displace*cstate) ≈ express(displace)*express(cstate)

    squeezed = SqueezedState(pi/4)
    squeezeop = SqueezeOp(pi/4)
    @test express(squeezed) ≈ express(squeezeop)*express(vac)
end

using Test
using QuantumSymbolics

@testset "Gabs and QuantumOptics Gaussian interop" begin
    using Gabs
    using QuantumOptics
    using QuantumSymbolics

    samestate(ket1, ket2; atol=1e-10) = isapprox(dm(ket1), dm(ket2); atol=atol, rtol=0)

    express_via_gabs(state, repr, basis) = express(express(state, GabsRepr(basis)), repr)

    function act_via_gabs(op, state, repr, basis)
        grepr = GabsRepr(basis)
        express(express(op, grepr) * express(state, grepr), repr)
    end

    direct_action(op, state, repr) = express(op, repr) * express(state, repr)
    symbolic_action(op, state, repr) = express(op * state, repr)

    @testset "Pure-state conversions" begin
        repr = QuantumOpticsRepr(14)
        α = 0.21 - 0.13im
        z = 0.17 * exp(-0.3im)

        direct_vacuum = express(vac, repr)
        direct_product = express(CoherentState(α) ⊗ vac, repr)
        direct_twomode_squeezed = express(TwoSqueezedState(z), repr)

        for basis in (QuadPairBasis, QuadBlockBasis)
            @test samestate(express_via_gabs(vac, repr, basis), direct_vacuum)
            @test samestate(express_via_gabs(CoherentState(α) ⊗ vac, repr, basis), direct_product)
            @test samestate(
                express_via_gabs(TwoSqueezedState(z), repr, basis),
                direct_twomode_squeezed;
                atol=1e-9,
            )
        end

        pair_state = express_via_gabs(TwoSqueezedState(z), repr, QuadPairBasis)
        block_state = express_via_gabs(TwoSqueezedState(z), repr, QuadBlockBasis)
        @test samestate(pair_state, block_state; atol=1e-9)
    end

    @testset "Simple edge cases" begin
        repr = QuantumOpticsRepr(14)
        α = 0.21 - 0.13im
        z = 0.0 + 0.2im
        πf = float(pi)

        for basis in (QuadPairBasis, QuadBlockBasis)
            @test samestate(
                act_via_gabs(PhaseShiftOp(0.0), CoherentState(α), repr, basis),
                express(CoherentState(α), repr),
            )
            @test samestate(
                act_via_gabs(PhaseShiftOp(πf), CoherentState(α), repr, basis),
                express(CoherentState(-α), repr),
            )

            @test samestate(
                act_via_gabs(BeamSplitterOp(0.0), CoherentState(α) ⊗ vac, repr, basis),
                express(CoherentState(α) ⊗ vac, repr),
            )
            @test samestate(
                act_via_gabs(BeamSplitterOp(1.0), CoherentState(α) ⊗ vac, repr, basis),
                express(vac ⊗ CoherentState(-α), repr),
            )

            @test samestate(
                act_via_gabs(TwoSqueezeOp(0.0 + 0.0im), vac ⊗ vac, repr, basis),
                express(vac ⊗ vac, repr),
            )
            @test samestate(
                act_via_gabs(TwoSqueezeOp(z), vac ⊗ vac, repr, basis),
                express(TwoSqueezedState(z), repr),
            )
        end
    end

    @testset "Operator actions agree across paths" begin
        repr = QuantumOpticsRepr(14)
        α = 0.21 - 0.13im
        z = 0.17 * exp(-0.3im)

        phase = PhaseShiftOp(pi / 2)
        beamsplitter = BeamSplitterOp(0.35)
        twosqueeze = TwoSqueezeOp(z)

        phase_state = CoherentState(α)
        twomode_state = CoherentState(α) ⊗ vac
        vacuum_pair = vac ⊗ vac

        phase_direct = direct_action(phase, phase_state, repr)
        phase_symbolic = symbolic_action(phase, phase_state, repr)
        @test samestate(phase_symbolic, phase_direct)

        beamsplitter_direct = direct_action(beamsplitter, twomode_state, repr)
        beamsplitter_symbolic = symbolic_action(beamsplitter, twomode_state, repr)
        @test samestate(beamsplitter_symbolic, beamsplitter_direct)

        twosqueeze_direct = direct_action(twosqueeze, twomode_state, repr)
        twosqueeze_symbolic = symbolic_action(twosqueeze, twomode_state, repr)
        @test samestate(twosqueeze_symbolic, twosqueeze_direct; atol=1e-9)

        twosqueeze_vacuum_direct = direct_action(twosqueeze, vacuum_pair, repr)
        twosqueeze_vacuum_symbolic = symbolic_action(twosqueeze, vacuum_pair, repr)
        twosqueeze_state = express(TwoSqueezedState(z), repr)
        @test samestate(twosqueeze_vacuum_symbolic, twosqueeze_vacuum_direct)
        @test samestate(twosqueeze_vacuum_symbolic, twosqueeze_state)

        for basis in (QuadPairBasis, QuadBlockBasis)
            phase_via_gabs = act_via_gabs(phase, phase_state, repr, basis)
            @test samestate(phase_via_gabs, phase_direct)

            beamsplitter_via_gabs = act_via_gabs(beamsplitter, twomode_state, repr, basis)
            @test samestate(beamsplitter_via_gabs, beamsplitter_direct)

            twosqueeze_via_gabs = act_via_gabs(twosqueeze, twomode_state, repr, basis)
            @test samestate(twosqueeze_via_gabs, twosqueeze_direct; atol=1e-9)

            twosqueeze_vacuum_via_gabs = act_via_gabs(twosqueeze, vacuum_pair, repr, basis)
            @test samestate(twosqueeze_vacuum_via_gabs, twosqueeze_state; atol=1e-9)
        end

        pair_state = act_via_gabs(twosqueeze, twomode_state, repr, QuadPairBasis)
        block_state = act_via_gabs(twosqueeze, twomode_state, repr, QuadBlockBasis)
        @test samestate(pair_state, block_state; atol=1e-9)
    end
end

@testitem "Base show methods" begin
    @op A; @op B;
    @superop S;
    @bra b₁; @bra b₂;
    @ket k₁; @ket k₂;

    @testset "symbolic literal objects" begin
        @test repr(k₁) == "|k₁⟩"
        @test repr(b₁) == "⟨b₁|"
        @test repr(A) == "A"
        @test repr(S) == "S"
        @test repr(zero(k₁)) == repr(zero(b₁)) == repr(zero(A)) == repr(zero(S)) == "𝟎"
    end

    @testset "symbolic addition" begin
        @test repr(k₁ + k₂) == "|k₁⟩+|k₂⟩"
        @test repr(b₁ + b₂) == "⟨b₁|+⟨b₂|"
        @test repr(A + B) == "A+B"
    end
    
    @testset "symbolic application products" begin
        @test repr(A * k₁) == "A|k₁⟩"
        @test repr(b₁ * A) == "⟨b₁|A"
        @test repr((A + B) * k₁) == "(A+B)|k₁⟩"
        @test repr(b₁ * (A + B)) == "⟨b₁|(A+B)"
        @test repr((A + B) * (k₁ + k₂)) == "(A+B)(|k₁⟩+|k₂⟩)"
        @test repr((b₁ + b₂) * (A + B)) == "(⟨b₁|+⟨b₂|)(A+B)"
        @test repr((A ⊗ B) * SKet(:k, SpinBasis(1//2)^2)) == "(A⊗B)|k⟩"
        @test repr(SBra(:b, SpinBasis(1//2)^2) * (A ⊗ B)) == "⟨b|(A⊗B)"
        @test repr((A ⊗ B) * (k₁ ⊗ k₂)) == "(A⊗B)|k₁⟩|k₂⟩"
        @test repr((b₁ ⊗ b₂) * (A ⊗ B)) == "⟨b₁|⟨b₂|(A⊗B)"
    end

    @testset "symbolic scaling" begin
        @test repr(2 * k₁) == "2|k₁⟩"
        @test repr(2 * b₁) == "2⟨b₁|"
        @test repr(2 * A) == "2A"
        @test repr(2 * (k₁ + k₂)) == "2(|k₁⟩+|k₂⟩)"
        @test repr(2 * (b₁ + b₂)) == "2(⟨b₁|+⟨b₂|)"
        @test repr(2 * (A + B)) == "2(A+B)"
        @test repr(2 * (k₁ ⊗ k₂)) == "2|k₁⟩|k₂⟩"
        @test repr(2 * (b₁ ⊗ b₂)) == "2⟨b₁|⟨b₂|"
        @test repr(2 * (A ⊗ B)) == "2A⊗B"
        @test repr((1 + im) * k₁) == "(1 + 1im)|k₁⟩"
        @test repr((1 + im) * b₁) == "(1 + 1im)⟨b₁|"
        @test repr((1 + im) * A) == "(1 + 1im)A"
        @test repr((1 + im) * (k₁ + k₂)) == "(1 + 1im)(|k₁⟩+|k₂⟩)"
        @test repr((1 + im) * (b₁ + b₂)) == "(1 + 1im)(⟨b₁|+⟨b₂|)"
        @test repr((1 + im) * (A + B)) == "(1 + 1im)(A+B)"
        @test repr((1 + im) * (k₁ ⊗ k₂)) == "(1 + 1im)|k₁⟩|k₂⟩"
        @test repr((1 + im) * (b₁ ⊗ b₂)) == "(1 + 1im)⟨b₁|⟨b₂|"
        @test repr((1 + im) * (A ⊗ B)) == "(1 + 1im)A⊗B"
    end
    
    @testset "symbolic inner and outer products" begin
        @test repr(b₁ * k₁) == "⟨b₁||k₁⟩"
        @test repr(k₁ * b₁) == "|k₁⟩⟨b₁|"
    end

    @testset "symbolic superoperators" begin
        @test repr(S * A) == "S[A]"
    end

    @testset "symbolic commutator and anticommutator" begin
        @test repr(commutator(A, B)) == "[A,B]"
        @test repr(anticommutator(A, B)) == "{A,B}"
    end

    @testset "symbolic linear algebra operations" begin
        @test repr(conj(k₁)) == "|k₁⟩ˣ"
        @test repr(conj(b₁)) == "⟨b₁|ˣ"
        @test repr(conj(A)) == "Aˣ"
        @test repr(projector(k₁)) == "𝐏[|k₁⟩]"
        @test repr(transpose(k₁)) == "|k₁⟩ᵀ"
        @test repr(transpose(b₁)) == "⟨b₁|ᵀ"
        @test repr(transpose(A)) == "Aᵀ"
        @test repr(dagger(k₁)) == "|k₁⟩†"
        @test repr(dagger(b₁)) == "⟨b₁|†"
        @test repr(dagger(A)) == "A†"
        @test repr(tr(A)) == "tr(A)"
        @test repr(ptrace(A ⊗ B, 1)) == "(tr(A))B"
        @test repr(ptrace(SOperator(:A, SpinBasis(1//2)^2), 1)) == "tr1(A)"
        @test repr(inv(A)) == "A⁻¹"
        @test repr(exp(A)) == "exp(A)"
        @test repr(vec(A)) == "|A⟩⟩"
    end
end

##
# Pure States
##

abstract type SpecialKet <: Symbolic{AbstractKet} end
isexpr(::SpecialKet) = false
basis(x::SpecialKet) = x.basis
Base.show(io::IO, x::SpecialKet) = print(io, "|$(symbollabel(x))⟩")

@withmetadata struct XBasisState <: SpecialKet
    idx::Int
    basis::Basis
end
symbollabel(x::XBasisState) = "X$(num_to_sub(x.idx))"

@withmetadata struct YBasisState <: SpecialKet
    idx::Int
    basis::Basis
end
symbollabel(x::YBasisState) = "Y$(num_to_sub(x.idx))"

@withmetadata struct ZBasisState <: SpecialKet
    idx::Int
    basis::Basis
end
symbollabel(x::ZBasisState) = "Z$(num_to_sub(x.idx))"

@withmetadata struct MomentumEigenState <: SpecialKet
    p::Number # TODO parameterize
    basis::Basis
end
symbollabel(x::MomentumEigenState) = "δₚ($(x.p))"

@withmetadata struct PositionEigenState <: SpecialKet
    x::Float64 # TODO parameterize
    basis::Basis
end
symbollabel(x::PositionEigenState) = "δₓ($(x.x))"

const qubit_basis = SpinBasis(1//2)
"""Basis state of σˣ"""
const X1 = const X₁ = const Lp = const L₊ = XBasisState(1, qubit_basis)
"""Basis state of σˣ"""
const X2 = const X₂ = const Lm = const L₋ = XBasisState(2, qubit_basis)
"""Basis state of σʸ"""
const Y1 = const Y₁ = const Lpi = const L₊ᵢ = YBasisState(1, qubit_basis)
"""Basis state of σʸ"""
const Y2 = const Y₂ = const Lmi = const L₋ᵢ = YBasisState(2, qubit_basis)
"""Basis state of σᶻ"""
const Z1 = const Z₁ = const L0 = const L₀ = ZBasisState(1, qubit_basis)
"""Basis state of σᶻ"""
const Z2 = const Z₂ = const L1 = const L₁ = ZBasisState(2, qubit_basis)

##
# Gates and Operators on qubits
##

abstract type AbstractSingleQubitOp <: Symbolic{AbstractOperator} end
abstract type AbstractTwoQubitOp <: Symbolic{AbstractOperator} end
abstract type AbstractSingleQubitGate <: AbstractSingleQubitOp end # TODO maybe an IsUnitaryTrait is a better choice
abstract type AbstractTwoQubitGate <: AbstractTwoQubitOp end
isexpr(::AbstractSingleQubitGate) = false
isexpr(::AbstractTwoQubitGate) = false
basis(::AbstractSingleQubitGate) = qubit_basis
basis(::AbstractTwoQubitGate) = qubit_basis⊗qubit_basis
Base.show(io::IO, x::AbstractSingleQubitOp) = print(io, "$(symbollabel(x))")
Base.show(io::IO, x::AbstractTwoQubitOp) = print(io, "$(symbollabel(x))")

@withmetadata struct OperatorEmbedding <: Symbolic{AbstractOperator}
    gate::Symbolic{AbstractOperator} # TODO parameterize
    indices::Vector{Int}
    basis::Basis
end
isexpr(::OperatorEmbedding) = true

@withmetadata struct XGate <: AbstractSingleQubitGate end
eigvecs(g::XGate) = [X1,X2]
symbollabel(::XGate) = "X"
ishermitian(::XGate) = true
isunitary(::XGate) = true

@withmetadata struct YGate <: AbstractSingleQubitGate end
eigvecs(g::YGate) = [Y1,Y2]
symbollabel(::YGate) = "Y"
ishermitian(::YGate) = true
isunitary(::YGate) = true

@withmetadata struct ZGate <: AbstractSingleQubitGate end
eigvecs(g::ZGate) = [Z1,Z2]
symbollabel(::ZGate) = "Z"
ishermitian(::ZGate) = true
isunitary(::ZGate) = true

@withmetadata struct PauliM <: AbstractSingleQubitGate end
symbollabel(::PauliM) = "σ₋"
ishermitian(::PauliM) = true
isunitary(::PauliM) = true

@withmetadata struct PauliP <: AbstractSingleQubitGate end
symbollabel(::PauliP) = "σ₊"
ishermitian(::PauliP) = true
isunitary(::PauliP) = true

@withmetadata struct HGate <: AbstractSingleQubitGate end
symbollabel(::HGate) = "H"
ishermitian(::HGate) = true
isunitary(::HGate) = true

@withmetadata struct CNOTGate <: AbstractTwoQubitGate end
symbollabel(::CNOTGate) = "CNOT"
ishermitian(::CNOTGate) = true
isunitary(::CNOTGate) = true

@withmetadata struct CPHASEGate <: AbstractTwoQubitGate end
symbollabel(::CPHASEGate) = "CPHASE"
ishermitian(::CPHASEGate) = true
isunitary(::CPHASEGate) = true

const xyzsuplabeldict = Dict(:X=>"ˣ",:Y=>"ʸ",:Z=>"ᶻ")
for control in (:X, :Y, :Z)
    for target in (:X, :Y, :Z)
        structname = Symbol(control,"C",target,"Gate")
        label = xyzsuplabeldict[control]*"C"*xyzsuplabeldict[target]
        declare = :(@withmetadata struct $structname <: AbstractTwoQubitGate end)
        defsymlabel = :(symbollabel(::$structname) = $label)
        instancename = Symbol(control,"C",target)
        definstance = :(const $instancename = $structname())
        eval(declare)
        eval(defsymlabel)
        eval(definstance)
    end
end

"""Pauli X operator, also available as the constant `σˣ`"""
const X = const σˣ = XGate()
"""Pauli Y operator, also available as the constant `σʸ`"""
const Y = const σʸ = YGate()
"""Pauli Z operator, also available as the constant `σᶻ`"""
const Z = const σᶻ = ZGate()
"""Pauli "minus" operator, also available as the constant `σ₋`"""
const Pm = const σ₋ = PauliM()
"""Pauli "plus" operator, also available as the constant `σ₊`"""
const Pp = const σ₊ = PauliP()
"""Hadamard gate"""
const H = HGate()
"""CNOT gate"""
const CNOT = CNOTGate()
"""CPHASE gate"""
const CPHASE = CPHASEGate()

##
# Other special or useful objects
##

"""Completely depolarized state

```jldoctest
julia> MixedState(X1⊗X2)
𝕄

julia> express(MixedState(X1⊗X2))
Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.25 + 0.0im        ⋅             ⋅             ⋅     
       ⋅       0.25 + 0.0im        ⋅             ⋅
       ⋅             ⋅       0.25 + 0.0im        ⋅
       ⋅             ⋅             ⋅       0.25 + 0.0im

julia> express(MixedState(X1⊗X2), CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
 
𝒳ₗ━━
+ X_
+ _X
𝒮𝓉𝒶𝒷
 
𝒵ₗ━━
+ Z_
+ _Z
```
"""
@withmetadata struct MixedState <: Symbolic{AbstractOperator}
    basis::Basis # From QuantumOpticsBase # TODO make QuantumInterface
end
MixedState(x::Symbolic{AbstractKet}) = MixedState(basis(x))
MixedState(x::Symbolic{AbstractOperator}) = MixedState(basis(x))
isexpr(::MixedState) = false
basis(x::MixedState) = x.basis
symbollabel(x::MixedState) = "𝕄"

"""The identity operator for a given basis

```judoctest
julia> IdentityOp(X1⊗X2)
𝕀

julia> express(IdentityOp(Z2))
Operator(dim=2x2)
  basis: Spin(1/2)sparse([1, 2], [1, 2], ComplexF64[1.0 + 0.0im, 1.0 + 0.0im], 2, 2)
```
"""
@withmetadata struct IdentityOp <: Symbolic{AbstractOperator}
    basis::Basis # From QuantumOpticsBase # TODO make QuantumInterface
end
IdentityOp(x::Symbolic{AbstractKet}) = IdentityOp(basis(x))
IdentityOp(x::Symbolic{AbstractOperator}) = IdentityOp(basis(x))
isexpr(::IdentityOp) = false
basis(x::IdentityOp) = x.basis
symbollabel(x::IdentityOp) = "𝕀"
ishermitian(::IdentityOp) = true
isunitary(::IdentityOp) = true

"""Identity operator in qubit basis"""
const I = IdentityOp(qubit_basis)   

@testitem "QuantumOptics QuantumClifford Interop" begin
    using QuantumClifford: @S_str, random_stabilizer
    using QuantumOpticsBase
    using LinearAlgebra
    #using QuantumOpticsExt: _l0, _l1, _s₊, _s₋, _i₊, _i₋
    const qo = Base.get_extension(QuantumSymbolics, :QuantumOpticsExt)
    const _l0 = qo._l0
    const _l1 = qo._l1
    const _s₊ = qo._s₊
    const _s₋ = qo._s₋
    const _i₊ = qo._i₊
    const _i₋ = qo._i₋

    for n in 1:5
        stabs = [random_stabilizer(1) for _ in 1:n]
        stab = tensor(stabs...)
        translate = Dict(S"X"=>_s₊,S"-X"=>_s₋,S"Z"=>_l0,S"-Z"=>_l1,S"Y"=>_i₊,S"-Y"=>_i₋)
        kets = [translate[s] for s in stabs]
        ket = tensor(kets...)
        @test ket.data ≈ Ket(stab).data

        rstab = random_stabilizer(n)
        lstab = random_stabilizer(n)
        lket = Ket(rstab)
        rket = Ket(lstab)
        dotket = abs(lket'*rket)
        dotstab = abs(dot(lstab,rstab))
        @test (dotket<=1e-10 && dotstab==0) || dotket≈dotstab
    end
end

##
# This file defines the expression of quantum objects (kets, operators, and bras) in various representations.
#
# The main function is `express`, which takes a quantum object and a representation and returns an expression of the object in that representation.
##
 
export express, express_nolookup, consistent_representation

import SymbolicUtils: Symbolic

"""
    express(s, repr::AbstractRepresentation=QuantumOpticsRepr()[, use::AbstractUse])

The main interface for expressing symbolic quantum objects in various representations.

```jldoctest
julia> express(X1)
Ket(dim=2)
  basis: Spin(1/2)
 0.7071067811865475 + 0.0im
 0.7071067811865475 + 0.0im

julia> express(X1, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
+ X

julia> express(QuantumSymbolics.X)
Operator(dim=2x2)
  basis: Spin(1/2)
      ⋅       1.0 + 0.0im
 1.0 + 0.0im       ⋅

julia> express(QuantumSymbolics.X, CliffordRepr(), UseAsOperation())
sX

julia> express(QuantumSymbolics.X, CliffordRepr(), UseAsObservable())
+ X
```
"""
function express(state::Symbolic, repr::AbstractRepresentation, use::AbstractUse)
    md = metadata(state)
    isnothing(md) && return express_from_cache(express_nolookup(state, repr, use))
    if haskey(md.express_cache,(repr,use))
        return express_from_cache(md.express_cache[(repr,use)])
    else
        cache = express_nolookup(state, repr, use)
        md.express_cache[(repr,use)] = cache
        return express_from_cache(cache)
    end
end

express_nolookup(x, repr::AbstractRepresentation, ::AbstractUse) = express_nolookup(x, repr)

express_nolookup(x, repr::AbstractRepresentation, ::UseAsState) = express_nolookup(x, repr)

# Most of the time the cache is exactly the expression we need,
# but we need indirection to be able to implement cases
# where the cache is a distribution over possible samples.
express_from_cache(cache) = cache

"""Pick a representation that is consistent with given representations and appropriate for the given state."""
function consistent_representation(reprs,state)
    reprs = Set(reprs)
    if length(reprs)>1
        error("There is no support for mixed representations in QuantumSymbolics.jl yet.")
    end
    first(reprs)
end
express_nolookup(state, ::QuantumMCRepr) = express_nolookup(state, QuantumOpticsRepr())

function express_nolookup(s, repr::AbstractRepresentation)
    if isexpr(s)
        operation(s)(express.(arguments(s), (repr,))...)
    else
        error("Encountered an object $(s) of type $(typeof(s)) that can not be converted to $(repr) representation") # TODO make a nice error type
    end
end

using Test
using QuantumSymbolics

@testset "Anticommutator" begin

    @op A; @op B;

    @testset "symbolic anticommutator tests" begin
        @test isequal(anticommutator(2*A, B), anticommutator(A, 2*B)) && isequal(2*anticommutator(A, B), anticommutator(2*A, B)) && isequal(2*anticommutator(A, B), anticommutator(2*A, B))
    end

    @testset "anticommutator Pauli tests" begin
        @test isequal(qsimplify(anticommutator(X, X), rewriter=qsimplify_anticommutator), 2*I)
        @test isequal(qsimplify(anticommutator(Y, Y), rewriter=qsimplify_anticommutator), 2*I)
        @test isequal(qsimplify(anticommutator(Z, Z), rewriter=qsimplify_anticommutator), 2*I)
        @test isequal(qsimplify(anticommutator(X, Y), rewriter=qsimplify_anticommutator), 0)
        @test isequal(qsimplify(anticommutator(Y, X), rewriter=qsimplify_anticommutator), 0)
        @test isequal(qsimplify(anticommutator(Y, Z), rewriter=qsimplify_anticommutator), 0)
        @test isequal(qsimplify(anticommutator(Z, Y), rewriter=qsimplify_anticommutator), 0)
        @test isequal(qsimplify(anticommutator(Z, X), rewriter=qsimplify_anticommutator), 0)
        @test isequal(qsimplify(anticommutator(X, Z), rewriter=qsimplify_anticommutator), 0)
    end
end

using Test
using QuantumSymbolics

@testset "Doctests" begin
    using Documenter
    using QuantumOptics
    using QuantumClifford

    DocMeta.setdocmeta!(QuantumSymbolics, :DocTestSetup, :(using QuantumSymbolics, QuantumOptics, QuantumClifford); recursive=true)
    doctest(QuantumSymbolics)
end

##
# This file defines manual simplification and expansion rules for specific operations of quantum objects.
##

##
# Predicate functions
##
function hasscalings(xs)
    any(xs) do x
        operation(x) == *
    end
end
_isa(T) = x->isa(x,T)
_vecisa(T) = x->all(_isa(T), x)

##
# Simplification rules
## 

# Pauli identities
RULES_PAULI = [
    @rule(~o1::_isa(XGate)*~o2::_isa(XGate) => I),
    @rule(~o1::_isa(YGate)*~o2::_isa(YGate) => I),
    @rule(~o1::_isa(ZGate)*~o2::_isa(ZGate) => I),
    @rule(~o1::_isa(XGate)*~o2::_isa(YGate) => im*Z),
    @rule(~o1::_isa(YGate)*~o2::_isa(ZGate) => im*X),
    @rule(~o1::_isa(ZGate)*~o2::_isa(XGate) => im*Y),
    @rule(~o1::_isa(YGate)*~o2::_isa(XGate) => -im*Z),
    @rule(~o1::_isa(ZGate)*~o2::_isa(YGate) => -im*X),
    @rule(~o1::_isa(XGate)*~o2::_isa(ZGate) => -im*Y),
    @rule(~o1::_isa(HGate)*~o2::_isa(XGate)*~o3::_isa(HGate) => Z),
    @rule(~o1::_isa(HGate)*~o2::_isa(YGate)*~o3::_isa(HGate) => -Y),
    @rule(~o1::_isa(HGate)*~o2::_isa(ZGate)*~o3::_isa(HGate) => X),

    @rule(~o::_isa(XGate)*~k::isequal(X1) => X1),
    @rule(~o::_isa(YGate)*~k::isequal(X1) => -im*X2),
    @rule(~o::_isa(ZGate)*~k::isequal(X1) => X2),

    @rule(~o::_isa(XGate)*~k::isequal(X2) => -X2),
    @rule(~o::_isa(YGate)*~k::isequal(X2) => im*X1),
    @rule(~o::_isa(ZGate)*~k::isequal(X2) => X1),

    @rule(~o::_isa(XGate)*~k::isequal(Y1) => im*Y2),
    @rule(~o::_isa(YGate)*~k::isequal(Y1) => Y1),
    @rule(~o::_isa(ZGate)*~k::isequal(Y1) => Y2),

    @rule(~o::_isa(XGate)*~k::isequal(Y2) => -im*Y1),
    @rule(~o::_isa(YGate)*~k::isequal(Y2) => -Y2),
    @rule(~o::_isa(ZGate)*~k::isequal(Y2) => Y1),

    @rule(~o::_isa(XGate)*~k::isequal(Z1) => Z2),
    @rule(~o::_isa(YGate)*~k::isequal(Z1) => im*Z2),
    @rule(~o::_isa(ZGate)*~k::isequal(Z1) => Z1),

    @rule(~o::_isa(XGate)*~k::isequal(Z2) => Z1),
    @rule(~o::_isa(YGate)*~k::isequal(Z2) => -im*Z1),
    @rule(~o::_isa(ZGate)*~k::isequal(Z2) => -Z2),

    @rule(~o::_isa(HGate)*~k::isequal(X1) => Z1),
    @rule(~o::_isa(HGate)*~k::isequal(X2) => Z2),
    @rule(~o::_isa(HGate)*~k::isequal(Y1) => (X1+im*X2)/sqrt(2)),
    @rule(~o::_isa(HGate)*~k::isequal(Y2) => (X1-im*X2)/sqrt(2)),
    @rule(~o::_isa(HGate)*~k::isequal(Z1) => X1),
    @rule(~o::_isa(HGate)*~k::isequal(Z2) => X2)
]

# Commutator identities
RULES_COMMUTATOR = [
    @rule(commutator(~o1::_isa(XGate), ~o2::_isa(YGate)) => 2*im*Z),
    @rule(commutator(~o1::_isa(YGate), ~o2::_isa(ZGate)) => 2*im*X),
    @rule(commutator(~o1::_isa(ZGate), ~o2::_isa(XGate)) => 2*im*Y),
    @rule(commutator(~o1::_isa(YGate), ~o2::_isa(XGate)) => -2*im*Z),
    @rule(commutator(~o1::_isa(ZGate), ~o2::_isa(YGate)) => -2*im*X),
    @rule(commutator(~o1::_isa(XGate), ~o2::_isa(ZGate)) => -2*im*Y)
]

# Anticommutator identities
RULES_ANTICOMMUTATOR = [
    @rule(anticommutator(~o1::_isa(XGate), ~o2::_isa(XGate)) => 2*I),
    @rule(anticommutator(~o1::_isa(YGate), ~o2::_isa(YGate)) => 2*I),
    @rule(anticommutator(~o1::_isa(ZGate), ~o2::_isa(ZGate)) => 2*I),
    @rule(anticommutator(~o1::_isa(XGate), ~o2::_isa(YGate))=> 0),
    @rule(anticommutator(~o1::_isa(YGate), ~o2::_isa(ZGate)) => 0),
    @rule(anticommutator(~o1::_isa(ZGate), ~o2::_isa(XGate)) => 0),
    @rule(anticommutator(~o1::_isa(YGate), ~o2::_isa(XGate)) => 0),
    @rule(anticommutator(~o1::_isa(ZGate), ~o2::_isa(YGate)) => 0),
    @rule(anticommutator(~o1::_isa(XGate), ~o2::_isa(ZGate)) => 0),
    @rule(commutator(~o1::_isa(DestroyOp), ~o2::_isa(CreateOp)) => IdentityOp(basis(~o1))),
    @rule(commutator(~o1::_isa(CreateOp), ~o2::_isa(DestroyOp)) => -IdentityOp(basis(~o1))),
    @rule(commutator(~o1::_isa(NumberOp), ~o2::_isa(DestroyOp)) => -(~o2)),
    @rule(commutator(~o1::_isa(DestroyOp), ~o2::_isa(NumberOp)) => (~o1)),
    @rule(commutator(~o1::_isa(NumberOp), ~o2::_isa(CreateOp)) => (~o2)),
    @rule(commutator(~o1::_isa(CreateOp), ~o2::_isa(NumberOp)) => -(~o1))
]

RULES_FOCK = [
    @rule(~o::_isa(DestroyOp) * ~k::isequal(vac) => SZeroKet()),
    @rule(~o::_isa(CreateOp) * ~k::_isa(FockState) => SymbolicUtils.term(sqrt, (~k).idx+1)*FockState((~k).idx+1)),
    @rule(~o::_isa(DestroyOp) * ~k::_isa(FockState) => SymbolicUtils.term(sqrt, (~k).idx)*FockState((~k).idx-1)),
    @rule(~o::_isa(NumberOp) * ~k::_isa(FockState) => (~k).idx*(~k)),
    @rule(~o::_isa(DestroyOp) * ~k::_isa(CoherentState) => (~k).alpha*(~k)),
    @rule(~o::_isa(PhaseShiftOp) * ~k::_isa(CoherentState) => CoherentState((~k).alpha * exp(-im*(~o).phase))),
    @rule(dagger(~o1::_isa(PhaseShiftOp)) * ~o2::_isa(DestroyOp) * ~o1 => ~o2*exp(-im*((~o1).phase))),
    @rule(~o1::_isa(PhaseShiftOp) * ~o2::_isa(DestroyOp) * dagger(~o1) => ~o2*exp(im*((~o1).phase))),
    @rule(dagger(~o1::_isa(DisplaceOp)) * ~o2::_isa(DestroyOp) * ~o1 => (~o2) + (~o1).alpha*IdentityOp(basis(~o2))),
    @rule(dagger(~o1::_isa(DisplaceOp)) * ~o2::_isa(CreateOp) * ~o1 => (~o2) + conj((~o1).alpha)*IdentityOp(basis(~o2))),
    @rule(~o::_isa(DisplaceOp) * ~k::((x->(isa(x,FockState) && x.idx == 0))) => CoherentState((~o).alpha)),
    @rule(~o::_isa(SqueezeOp) * ~k::isequal(vac) => SqueezedState((~o).z)),
    @rule(~o::_isa(TwoSqueezeOp) * ~k::isequal(vac ⊗ vac) => TwoSqueezedState((~o).z))
]

RULES_SIMPLIFY = [RULES_PAULI; RULES_COMMUTATOR; RULES_ANTICOMMUTATOR; RULES_FOCK]

##
# Custom tree walker for QuantumSymbolics types
# SymbolicUtils v4's Prewalk/Postwalk only walk BasicSymbolic trees.
# Our types are not BasicSymbolic, so we need our own walker.
##

"""Apply a rewriter in pre-order to a QuantumSymbolics expression tree."""
function _prewalk(rw, x)
    y = rw(x)
    if !isnothing(y)
        x = y
    end
    if isexpr(x) && iscall(x)
        args = arguments(x)
        newargs = map(a -> _prewalk(rw, a), args)
        # Always reconstruct through maketerm to ensure proper normalization
        # (e.g., flattening of associative operations like * and ⊗).
        return maketerm(typeof(x), operation(x), newargs, metadata(x))
    end
    return x
end

"""Apply a rewriter repeatedly in pre-order until no changes occur."""
function _fixpoint_prewalk(rw, x)
    while true
        y = _prewalk(rw, x)
        isequal(x, y) && return x
        x = y
    end
end

"""Recursively substitute subexpressions in a QuantumSymbolics expression tree."""
function _substitute(expr, dict)
    haskey(dict, expr) && return dict[expr]
    if isexpr(expr) && iscall(expr)
        args = arguments(expr)
        newargs = map(a -> _substitute(a, dict), args)
        return maketerm(typeof(expr), operation(expr), newargs, metadata(expr))
    end
    return expr
end

# Extend SymbolicUtils.substitute for our Symbolic types so that
# `Symbolics.substitute` (which re-exports it) works on quantum expressions.
SymbolicUtils.substitute(expr::Symbolic, dict; kwargs...) = _substitute(expr, dict)

##
# Simplification rewriters
##

qsimplify_pauli = Chain(RULES_PAULI)
qsimplify_commutator = Chain(RULES_COMMUTATOR)
qsimplify_anticommutator = Chain(RULES_ANTICOMMUTATOR)
qsimplify_fock = Chain(RULES_FOCK)

"""
    qsimplify(s; rewriter=nothing)

Manually simplify a symbolic expression of quantum objects.

If the keyword `rewriter` is not specified, then `qsimplify` will apply every defined rule to the expression.
For performance or single-purpose motivations, the user has the option to define a specific rewriter for `qsimplify` to apply to the expression.
The defined rewriters for simplification are the following objects:
    - `qsimplify_pauli`
    - `qsimplify_commutator`
    - `qsimplify_anticommutator`
    - `qsimplify_fock`

```jldoctest
julia> qsimplify(σʸ*commutator(σˣ*σᶻ, σᶻ))
(0 - 2im)Z

julia> qsimplify(anticommutator(σˣ, σˣ), rewriter=qsimplify_anticommutator)
2𝕀
```
"""
function qsimplify(s; rewriter=nothing)
    if QuantumSymbolics.isexpr(s)
        if isnothing(rewriter)
            _fixpoint_prewalk(Chain(RULES_SIMPLIFY), s)
        else
            _fixpoint_prewalk(rewriter, s)
        end
    else
        error("Object $(s) of type $(typeof(s)) is not an expression.")
    end
end

##
# Expansion rules
## 

RULES_EXPAND = [
    @rule(commutator(~o1, ~o2) => (~o1)*(~o2) - (~o2)*(~o1)),
    @rule(anticommutator(~o1, ~o2) => (~o1)*(~o2) + (~o2)*(~o1)),
    @rule(~o1 ⊗ +(~~ops) => +(map(op -> ~o1 ⊗ op, ~~ops)...)),
    @rule(+(~~ops) ⊗ ~o1 => +(map(op -> op ⊗ ~o1, ~~ops)...)),
    @rule(~o1 * +(~~ops) => +(map(op -> ~o1 * op, ~~ops)...)),
    @rule(+(~~ops) * ~o1 => +(map(op -> op * ~o1, ~~ops)...)),
    @rule(⊗(~~ops1::_vecisa(Symbolic{AbstractBra})) * ⊗(~~ops2::_vecisa(Symbolic{AbstractKet})) => *(map(*, ~~ops1, ~~ops2)...)),
    @rule(⊗(~~ops1::_vecisa(Symbolic{AbstractOperator})) * ⊗(~~ops2::_vecisa(Symbolic{AbstractOperator})) => ⊗(map(*, ~~ops1, ~~ops2)...)),
]

# 

##
# Expansion rewriter
##

"""
    qexpand(s)

Manually expand a symbolic expression of quantum objects. 

```jldoctest
julia> @op A; @op B; @op C;

julia> qexpand(commutator(A, B))
-1BA+AB

julia> qexpand(A⊗(B+C))
(A⊗B)+(A⊗C)

julia> @ket k₁; @ket k₂;

julia> qexpand(A*(k₁+k₂))
A|k₁⟩+A|k₂⟩
```
"""
function qexpand(s)
    if QuantumSymbolics.isexpr(s)
        _fixpoint_prewalk(Chain(RULES_EXPAND), s)
    else
        error("Object $(s) of type $(typeof(s)) is not an expression.")
    end
end

@testitem "Aqua" tags=[:aqua] begin
    using Aqua
    
    # Add any new types needed to QObj, or here if QObj if not appropriate.
    # Add types from elsewhere in the ecosystem here or preferably to QObj
    own_types = [Base.uniontypes(QObj)...,AbstractRepresentation,AbstractUse,]
    own_types_union = Union{SymQObj,AbstractRepresentation,AbstractUse,}

    Aqua.test_all(QuantumSymbolics, piracies=(;treat_as_own=own_types))

    function normalize_arguments(method)
        args = Base.unwrap_unionall(method.sig).types[2:end]
        normalized_args = []
        # handle few edge cases specific to our analysis
        for arg in args
            # mutation and order of if-conditions is intedtional here
            if (arg isa UnionAll) && (arg.body <: Type) arg = arg.body.parameters[1] end
            if (arg isa Core.TypeofVararg) arg = arg.T end
            if (arg isa TypeVar) arg = arg.ub end
            push!(normalized_args, arg)
        end
        return normalized_args
    end

    # Custom type-piracy detection, to catch uses of QuantumInterface types without a Symbolic
    filtered_piracies = filter(Aqua.Piracy.hunt(QuantumSymbolics)) do m
        !any(normalize_arguments(m) .<: own_types_union)
    end

    aqua_piracies = Aqua.Piracy.hunt(QuantumSymbolics, treat_as_own=own_types)
    internally_detected_piracies = setdiff(filtered_piracies, aqua_piracies)
    if !isempty(internally_detected_piracies)
        printstyled(
            stderr,
            "Internally flagged possible type-piracy:\n";
            color = Base.warn_color()
        )
        show(stderr, MIME"text/plain"(), internally_detected_piracies)
        println(stderr, "\n")
    end
    @test isempty(internally_detected_piracies)
end

using QuantumSymbolics
import QuantumOpticsBase
import QuantumClifford

using BenchmarkTools

const SUITE = BenchmarkGroup()
@ket k1; @ket k2; @bra b1; @bra b2; @op A; @op B; @op C;

# Time to import and first usage of simple operations
SUITE["latency"] = BenchmarkGroup(["slow"])
load_command = `julia --quiet --project=./ --eval="using QuantumSymbolics"`
ttfx_command = `
    julia --quiet --project=./ --eval="""
        using QuantumSymbolics;
        @ket k1; @op A;
        A * commutator(A,X) * k1
    """`
SUITE["latency"]["using"] = @benchmarkable run(load_command) samples=3 seconds=15
SUITE["latency"]["ttf_operation"] = @benchmarkable run(ttfx_command) samples=3 seconds=15
SUITE["latency"]["ttf_simplify"] = @benchmarkable qsimplify(X*Y) samples=1 evals=1


# Symbolic object creation
SUITE["creation"] = BenchmarkGroup(["symbolic"])
SUITE["creation"]["ket"] = @benchmarkable @ket _k
SUITE["creation"]["op"] = @benchmarkable @op _A
SUITE["creation"]["super_op"] = @benchmarkable @superop _S

SUITE["creation"]["large_trees"] = BenchmarkGroup(["allocs"])
function large_tree_with_plenty_reallocations(layers)
    expr_op = QuantumSymbolics.I
    expr_ket = X1
    for _ in 1:layers
        expr_op = rand([X, Y, Z, H]) + (rand([X, Y, Z, H]) * expr_op)
        expr_ket = (expr_op * expr_ket) + rand([X1, X2, Y1, Y2, Z1, Z2])
    end
    return expr_op, expr_ket
end
SUITE["creation"]["large_trees"]["10_layers"] = @benchmarkable large_tree_with_plenty_reallocations(10)
SUITE["creation"]["large_trees"]["50_layers"] = @benchmarkable large_tree_with_plenty_reallocations(50)


# Basic operations
SUITE["operations"] = BenchmarkGroup(["symbolic"])
SUITE["operations"]["scaling"] = BenchmarkGroup()
SUITE["operations"]["scaling"]["ket"] = @benchmarkable 2 * $k1
SUITE["operations"]["scaling"]["op"] = @benchmarkable 3 * $A

SUITE["operations"]["addition"] = BenchmarkGroup()
SUITE["operations"]["addition"]["ket"] = @benchmarkable $k1 + $k2
SUITE["operations"]["addition"]["op"] = @benchmarkable $A + $B

SUITE["operations"]["multiplication"] = BenchmarkGroup()
SUITE["operations"]["multiplication"]["bra_ket"] = @benchmarkable $b1 * $k1
SUITE["operations"]["multiplication"]["op_ket"] = @benchmarkable $A * $k1
SUITE["operations"]["multiplication"]["bra_op"] = @benchmarkable $b1 * $A
SUITE["operations"]["multiplication"]["inner"] = @benchmarkable $b1 * $k1
SUITE["operations"]["multiplication"]["outer"] = @benchmarkable $k1 * $b1
SUITE["operations"]["multiplication"]["op"] = @benchmarkable $A * $B 
SUITE["operations"]["multiplication"]["many"] = @benchmarkable $k1 * $b2 * $k2 * $b1 * $A * $B

SUITE["operations"]["tensor"] = BenchmarkGroup()
SUITE["operations"]["tensor"]["ket"] = @benchmarkable $k1 ⊗ $k2
SUITE["operations"]["tensor"]["op"] = @benchmarkable $A ⊗ $B
SUITE["operations"]["tensor"]["many"] = @benchmarkable $A ⊗ $B ⊗ $C ⊗ $A ⊗ $B ⊗ $C


# Linear algebra operations
SUITE["linalg"] = BenchmarkGroup(["symbolic"])
SUITE["linalg"]["trace"] = @benchmarkable tr($A)
SUITE["linalg"]["ptrace"] = @benchmarkable ptrace($A ⊗ $B, 1)
SUITE["linalg"]["inverse"] = @benchmarkable inv($A)
SUITE["linalg"]["dagger"] = @benchmarkable dagger($A)
SUITE["linalg"]["conjugate"] = @benchmarkable conj($A)
SUITE["linalg"]["transpose"] = @benchmarkable transpose($A)
SUITE["linalg"]["commutator"] = @benchmarkable commutator($A, $B)
SUITE["linalg"]["anticommutator"] = @benchmarkable anticommutator($A, $B)


# Simplification benchmarks
SUITE["manipulation"] = BenchmarkGroup(["symbolic"])
compact_pauli_expr = (H * (X+Y+Z)) * (H * (Y1+Y2+Z1))
expanded_pauli_expr = qexpand(compact_pauli_expr)
commutator_expr = commutator(X, commutator(Y, commutator(X, Z)))

SUITE["manipulation"]["expand"]["distribution"] = @benchmarkable qexpand($compact_pauli_expr)
SUITE["manipulation"]["expand"]["commutator"] = @benchmarkable qexpand($commutator_expr)
SUITE["manipulation"]["simplify"]["applicable_rules"] = @benchmarkable qsimplify($expanded_pauli_expr, rewriter=qsimplify_pauli)
# Expression isn't simplified with fock rules. Testing how fast we go through inapplicable rules.
SUITE["manipulation"]["simplify"]["irrelevant_rules"] = @benchmarkable qsimplify($expanded_pauli_expr, rewriter=qsimplify_fock)
SUITE["manipulation"]["simplify"]["commutator"] = @benchmarkable qsimplify($commutator_expr, rewriter=qsimplify_commutator)


# Expression benchmarks
SUITE["express"] = BenchmarkGroup(["express"])
clear_cache!(x) = empty!(x.metadata.express_cache)
simple_op = X⊗Y
simple_ket = Z1⊗Z1
pauli_op_4 = YCX * transpose(Z⊗Y) * YCZ * dagger(Y⊗X) * conj(ZCY) * exp(X ⊗ (2-3im)X) 
pauli_state_8 = (conj(XCY⊗Y) + dagger(Z⊗YCX) + transpose(0.5im*Y ⊗ exp(XCY))) * (X1⊗Y1⊗Z1)

SUITE["express"]["optics"]["simple_op"] = @benchmarkable express($simple_op) setup=clear_cache!(simple_op) evals=1
SUITE["express"]["optics"]["simple_ket"] = @benchmarkable express($simple_ket) setup=clear_cache!(simple_ket) evals=1
SUITE["express"]["optics"]["pauli_op_4"] = @benchmarkable express($pauli_op_4) setup=clear_cache!(pauli_op_4) evals=1
SUITE["express"]["optics"]["pauli_state_8"] = @benchmarkable express($pauli_state_8) setup=clear_cache!(pauli_state_8) evals=1

# TODO: add additional clifford expressions
SUITE["express"]["clifford"]["simple_ket"] = @benchmarkable express($simple_ket, CliffordRepr()) setup=clear_cache!(simple_ket) evals=1
SUITE["express"]["clifford"]["simple_observable"] = @benchmarkable express($simple_op, CliffordRepr(), UseAsObservable()) setup=clear_cache!(simple_op) evals=1

using QuantumInterface: AbstractSuperOperator

abstract type AbstractLazySuperOperator{B1,B2} <: AbstractSuperOperator{B1,B2} end

# TODO split in LazyPre, LazyPost and LazyPrePost
struct LazyPrePost{B,DT} <: AbstractLazySuperOperator{Tuple{B,B},Tuple{B,B}}
    preop::Operator{B,B,DT}
    postop::Operator{B,B,DT}
end
function LazyPrePost(preop::T,postop::T) where {B,DT,T<:Operator{B,B,DT}}
    LazyPrePost{B,DT}(preop,postop)
end

struct LazySuperSum{B,F,T} <: AbstractLazySuperOperator{Tuple{B,B},Tuple{B,B}}
    basis::B
    factors::F
    sops::T
end

QuantumOpticsBase.basis(sop::LazyPrePost) = basis(sop.preop)
QuantumOpticsBase.basis(sop::LazySuperSum) = sop.basis
QuantumOpticsBase.embed(bl,br,index,op::LazyPrePost) = LazyPrePost(embed(bl,br,index,op.preop),embed(bl,br,index,op.postop))
function Base.:(*)(sop::LazyPrePost, op::Operator)
    # TODO do not create the spre and spost objects, do it without intermediaries, do it in place with buffers
    r = op
    r = spre(sop.preop)*r
    r = spost(sop.postop)*r
    r
end
Base.:(*)(l::LazyPrePost, r::LazyPrePost) = LazyPrePost(l.preop*r.preop, r.postop*l.postop)
Base.:(+)(ops::LazyPrePost...) = LazySuperSum(basis(first(ops)),fill(1,length(ops)),ops)
QuantumOpticsBase.embed(bl,br,index,op::LazySuperSum) = LazySuperSum(bl, op.factors, [embed(bl,br,index,o) for o in op.sops])
function Base.:(*)(ssop::LazySuperSum, op::Operator)
    res = zero(op)
    for (f,sop) in zip(ssop.factors,ssop.sops)
        res += f*(sop*op)
    end
    res
end

struct LazySuperTensor{B,T} <: AbstractLazySuperOperator{Tuple{B,B},Tuple{B,B}}
    basis::B
    sops::T
end

function QuantumInterface.tensor(sops::AbstractSuperOperator...)
    b = QuantumInterface.tensor(basis.(sops)...)
    @assert length(sops) == length(b.bases) "tensor products of superoperators over composite bases are not implemented yet"
    LazySuperTensor(b,[embed(b,b,i,s) for (i,s) in enumerate(sops)])
end
function Base.:(*)(ssop::LazySuperTensor, op::Operator)
    for sop in ssop.sops
        op = sop*op
    end
    op
end

using Test
using QuantumSymbolics

@testset "Basis consistency" begin
    using QuantumOptics

    @test express(Z*Z1) == express(Z1)
    @test express(Z*Z2) == -express(Z2)
    @test express(X*X1) == express(X1)
    @test express(X*X2) == -express(X2)
    @test express(Y*Y1) == express(Y1)
    @test express(Y*Y2) == -express(Y2)
    @test express(Pm*Z1) == express(Z2)
    @test express(Pp*Z2) == express(Z1)
    @test express(Pm*L0) == express(L1)
    @test express(Pp*L1) == express(L0)

    @op A; @op B; @op C; @op O; @ket k;
    @superop S; K = kraus(A, B, C);

    @test basis(K) == basis(A)
end

using LinearAlgebra: diagm

finite_two_mode_basis(s, r) = isfinite(length(basis(s))) ? basis(s) : FockBasis(r.cutoff)^2

function _thermalstate(basis, photons)
    occupation = photons / (photons + 1)
    weights = occupation .^ collect(basis.offset:basis.N)
    normalize(DenseOperator(basis, diagm(0 => weights)))
end

function _two_mode_ops(basis)
    mode_basis = basis.bases[1]
    return (
        a1 = embed(basis, 1, destroy(mode_basis)),
        a2 = embed(basis, 2, destroy(mode_basis)),
        ad1 = embed(basis, 1, create(mode_basis)),
        ad2 = embed(basis, 2, create(mode_basis)),
    )
end

_phaseshift(basis, phase) = exp(-im * phase * dense(number(basis)))

function _beamsplitter(basis, transmit)
    ops = _two_mode_ops(basis)
    theta = asin(sqrt(transmit))
    exp(theta * dense(ops.ad1 * ops.a2 - ops.a1 * ops.ad2))
end

function _twosqueeze(basis, z)
    ops = _two_mode_ops(basis)
    exp(dense(conj(z) * ops.a1 * ops.a2 - z * ops.ad1 * ops.ad2))
end

function _two_mode_vacuum(basis)
    vacuum = fockstate(basis.bases[1], 0)
    vacuum ⊗ vacuum
end

express_nolookup(s::BosonicThermalState, r::QuantumOpticsRepr) = _thermalstate(finite_basis(s,r), s.photons)
express_nolookup(o::PhaseShiftOp, r::QuantumOpticsRepr) = _phaseshift(finite_basis(o,r), o.phase)
express_nolookup(o::BeamSplitterOp, r::QuantumOpticsRepr) = _beamsplitter(finite_two_mode_basis(o,r), o.transmit)
express_nolookup(s::TwoSqueezedState, r::QuantumOpticsRepr) = (b = finite_two_mode_basis(s,r); _twosqueeze(b, s.z) * _two_mode_vacuum(b))
express_nolookup(o::TwoSqueezeOp, r::QuantumOpticsRepr) = _twosqueeze(finite_two_mode_basis(o,r), o.z)

##
# Linear algebra operations on quantum objects.
##

#TODO upstream to QuantumInterface
"""The commutator of two operators."""
function commutator end
"""The anticommutator of two operators."""
function anticommutator end

"""Symbolic commutator of two operators.

```jldoctest
julia> @op A; @op B;

julia> commutator(A, B)
[A,B]

julia> commutator(A, A)
𝟎
```
"""
@withmetadata struct SCommutator <: Symbolic{AbstractOperator}
    op1
    op2
end
isexpr(::SCommutator) = true
iscall(::SCommutator) = true
arguments(x::SCommutator) = [x.op1, x.op2]
operation(x::SCommutator) = commutator
head(x::SCommutator) = :commutator
children(x::SCommutator) = [:commutator, x.op1, x.op2]
function commutator(o1::Symbolic{AbstractOperator}, o2::Symbolic{AbstractOperator})
    if !(samebases(basis(o1),basis(o2)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([o1 o2])
        cleanterms[1] === cleanterms[2] ? SZeroOperator() : coeff * SCommutator(cleanterms...)
    end
end
commutator(o1::SZeroOperator, o2::Symbolic{AbstractOperator}) = SZeroOperator()
commutator(o1::Symbolic{AbstractOperator}, o2::SZeroOperator) = SZeroOperator()
commutator(o1::SZeroOperator, o2::SZeroOperator) = SZeroOperator()
Base.show(io::IO, x::SCommutator) = print(io, "[$(x.op1),$(x.op2)]")
basis(x::SCommutator) = basis(x.op1)


"""Symbolic anticommutator of two operators.

```jldoctest
julia> @op A; @op B;

julia> anticommutator(A, B)
{A,B}
```
"""
@withmetadata struct SAnticommutator <: Symbolic{AbstractOperator}
    op1
    op2
end
isexpr(::SAnticommutator) = true
iscall(::SAnticommutator) = true
arguments(x::SAnticommutator) = [x.op1, x.op2]
operation(x::SAnticommutator) = anticommutator
head(x::SAnticommutator) = :anticommutator
children(x::SAnticommutator) = [:anticommutator, x.op1, x.op2]
function anticommutator(o1::Symbolic{AbstractOperator}, o2::Symbolic{AbstractOperator})
    if !(samebases(basis(o1),basis(o2)))
        throw(IncompatibleBases())
    else
        coeff, cleanterms = prefactorscalings([o1 o2])
        coeff * SAnticommutator(cleanterms...)
    end
end
anticommutator(o1::SZeroOperator, o2::Symbolic{AbstractOperator}) = SZeroOperator()
anticommutator(o1::Symbolic{AbstractOperator}, o2::SZeroOperator) = SZeroOperator()
anticommutator(o1::SZeroOperator, o2::SZeroOperator) = SZeroOperator()
Base.show(io::IO, x::SAnticommutator) = print(io, "{$(x.op1),$(x.op2)}")
basis(x::SAnticommutator) = basis(x.op1)


"""Complex conjugate of quantum objects (kets, bras, operators).

```jldoctest
julia> @op A; @ket k;

julia> conj(A)
Aˣ

julia> conj(k)
|k⟩ˣ
```
"""
@withmetadata struct SConjugate{T<:QObj} <: Symbolic{T}
    obj
end
isexpr(::SConjugate) = true
iscall(::SConjugate) = true
arguments(x::SConjugate) = [x.obj]
operation(x::SConjugate) = conj
head(x::SConjugate) = :conj
children(x::SConjugate) = [:conj, x.obj]
"""
    conj(x::Symbolic{AbstractKet})
    conj(x::Symbolic{AbstractBra})
    conj(x::Symbolic{AbstractOperator})
    conj(x::Symbolic{AbstractSuperOperator})

Symbolic complex conjugate operation. See also [`SConjugate`](@ref).
"""
conj(x::Symbolic{T}) where {T<:QObj} = SConjugate{T}(x)
conj(x::SZero) = x
conj(x::SConjugate) = x.obj
basis(x::SConjugate) = basis(x.obj)
function Base.show(io::IO, x::SConjugate)
    print(io,x.obj)
    print(io,"ˣ")
end


"""Projector for a given ket.

```jldoctest
julia> projector(X1⊗X2)
𝐏[|X₁⟩|X₂⟩]

julia> express(projector(X2))
Operator(dim=2x2)
  basis: Spin(1/2)
  0.5+0.0im  -0.5-0.0im
 -0.5+0.0im   0.5+0.0im
```
"""
@withmetadata struct SProjector <: Symbolic{AbstractOperator}
    ket::Symbolic{AbstractKet} # TODO parameterize
end
isexpr(::SProjector) = true
iscall(::SProjector) = true
arguments(x::SProjector) = [x.ket]
operation(x::SProjector) = projector
head(x::SProjector) = :projector
children(x::SProjector) = [:projector,x.ket]
"""
    projector(x::Symbolic{AbstractKet})

Symbolic projection operation. See also [`SProjector`](@ref).
"""
projector(x::Symbolic{AbstractKet}) = SProjector(x)
projector(x::SZeroKet) = SZeroOperator()
basis(x::SProjector) = basis(x.ket)
function Base.show(io::IO, x::SProjector)
    print(io,"𝐏[")
    print(io,x.ket)
    print(io,"]")
end


"""Transpose of quantum objects (kets, bras, operators).

```jldoctest
julia> @op A; @op B; @ket k;

julia> transpose(A)
Aᵀ

julia> transpose(A+B)
Aᵀ+Bᵀ

julia> transpose(k)
|k⟩ᵀ
```
"""
@withmetadata struct STranspose{T<:QObj} <: Symbolic{T}
    obj
end
isexpr(::STranspose) = true
iscall(::STranspose) = true
arguments(x::STranspose) = [x.obj]
operation(x::STranspose) = transpose
head(x::STranspose) = :transpose
children(x::STranspose) = [:transpose, x.obj]
"""
    transpose(x::Symbolic{AbstractKet})
    transpose(x::Symbolic{AbstractBra})
    transpose(x::Symbolic{AbstractOperator})

Symbolic transpose operation. See also [`STranspose`](@ref).
"""
transpose(x::Symbolic{T}) where {T<:Union{AbstractKet,AbstractBra,AbstractOperator}} = STranspose{T}(x)
transpose(x::SScaled) = x.coeff*transpose(x.obj)
transpose(x::SAdd) = (+)((transpose(i) for i in arguments(x))...)
transpose(x::SMulOperator) = (*)((transpose(i) for i in reverse(x.terms))...)
transpose(x::STensor) = (⊗)((transpose(i) for i in x.terms)...)
transpose(x::SZeroOperator) = x
transpose(x::STranspose) = x.obj
basis(x::STranspose) = basis(x.obj)
function Base.show(io::IO, x::STranspose)
    print(io,x.obj)
    print(io,"ᵀ")
end


"""Dagger, i.e., adjoint of quantum objects (kets, bras, operators).

```jldoctest
julia> @ket a; @op A;

julia> dagger(2*im*A*a)
(0 - 2im)|a⟩†A†

julia> @op B;

julia> dagger(A*B)
B†A†

julia> ℋ = SHermitianOperator(:ℋ); U = SUnitaryOperator(:U);

julia> dagger(ℋ)
ℋ

julia> dagger(U)
U⁻¹
```
"""
@withmetadata struct SDagger{T<:QObj} <: Symbolic{T}
    obj
end
isexpr(::SDagger) = true
iscall(::SDagger) = true
arguments(x::SDagger) = [x.obj]
operation(x::SDagger) = dagger
head(x::SDagger) = :dagger
children(x::SDagger) = [:dagger, x.obj]
"""
    dagger(x::Symbolic{AbstractKet})

Symbolic adjoint operation. See also [`SDagger`](@ref).
"""
dagger(x::Symbolic{AbstractKet})= SDagger{AbstractBra}(x)
"""
    dagger(x::Symbolic{AbstractBra})

Symbolic adjoint operation. See also [`SDagger`](@ref).
"""
dagger(x::Symbolic{AbstractBra})= SDagger{AbstractKet}(x)
"""
    dagger(x::Symbolic{AbstractOperator})

Symbolic adjoint operation. See also [`SDagger`](@ref).
"""
dagger(x::Symbolic{AbstractOperator}) = SDagger{AbstractOperator}(x)
dagger(x::SScaled) = conj(x.coeff)*dagger(x.obj)
dagger(x::SAdd) = (+)((dagger(i) for i in arguments(x))...)
dagger(x::SMulOperator) = (*)((dagger(i) for i in reverse(x.terms))...)
dagger(x::STensor) = (⊗)((dagger(i) for i in x.terms)...)
dagger(x::SZeroOperator) = x
dagger(x::SHermitianOperator) = x
dagger(x::SHermitianUnitaryOperator) = x
dagger(x::SUnitaryOperator) = inv(x)
dagger(x::SApplyKet) = dagger(x.ket)*dagger(x.op)
dagger(x::SApplyBra) = dagger(x.op)*dagger(x.bra)
dagger(x::SBraKet) = dagger(x.ket)*dagger(x.bra)
dagger(x::SOuterKetBra) = dagger(x.bra)*dagger(x.ket)
dagger(x::SDagger) = x.obj
basis(x::SDagger) = basis(x.obj)
function Base.show(io::IO, x::SDagger)
    print(io,x.obj)
    print(io,"†")
end


"""Trace of an operator

```jldoctest
julia> @op A; @op B;

julia> tr(A)
tr(A)

julia> tr(commutator(A, B))
0

julia> @bra b; @ket k;

julia> tr(k*b)
⟨b||k⟩
```
"""
@withmetadata struct STrace <: Symbolic{Complex}
    op::Symbolic{AbstractOperator}
end
isexpr(::STrace) = true
iscall(::STrace) = true
arguments(x::STrace) = [x.op]
sorted_arguments(x::STrace) = arguments(x)
operation(x::STrace) = tr
head(x::STrace) = :tr
children(x::STrace) = [:tr, x.op]
Base.show(io::IO, x::STrace) = print(io, "tr($(x.op))")
"""
    tr(x::Symbolic{AbstractOperator})

Symbolic trace operation. See also [`STrace`](@ref).
"""
tr(x::Symbolic{AbstractOperator}) = STrace(x)
tr(x::SScaled{AbstractOperator}) = x.coeff*tr(x.obj)
tr(x::SAdd{AbstractOperator}) = (+)((tr(i) for i in arguments(x))...)
tr(x::SOuterKetBra) = x.bra*x.ket
tr(x::SCommutator) = 0
tr(x::STensorOperator) = (*)((tr(i) for i in arguments(x))...)
Base.hash(x::STrace, h::UInt) = hash((head(x), arguments(x)), h)
Base.isequal(x::STrace, y::STrace) = isequal(x.op, y.op)


"""Partial trace over system i of a composite quantum system

```jldoctest
julia> @op 𝒪 SpinBasis(1//2)⊗SpinBasis(1//2);

julia> op = ptrace(𝒪, 1)
tr1(𝒪)

julia> QuantumSymbolics.basis(op)
Spin(1/2)

julia> @op A; @op B;

julia> ptrace(A⊗B, 1)
(tr(A))B

julia> @ket k; @bra b;

julia> factorizable = A ⊗ (k*b)
A⊗|k⟩⟨b|

julia> ptrace(factorizable, 1)
(tr(A))|k⟩⟨b|

julia> ptrace(factorizable, 2)
(⟨b||k⟩)A

julia> mixed_state = (A⊗(k*b)) + ((k*b)⊗B)
(A⊗|k⟩⟨b|)+(|k⟩⟨b|⊗B)

julia> ptrace(mixed_state, 1)
(tr(A))|k⟩⟨b|+(⟨b||k⟩)B

julia> ptrace(mixed_state, 2)
(tr(B))|k⟩⟨b|+(⟨b||k⟩)A
```
"""
@withmetadata struct SPartialTrace <: Symbolic{AbstractOperator}
    obj
    sys::Int
end
isexpr(::SPartialTrace) = true
iscall(::SPartialTrace) = true
arguments(x::SPartialTrace) = [x.obj, x.sys]
operation(x::SPartialTrace) = ptrace
head(x::SPartialTrace) = :ptrace
children(x::SPartialTrace) = [:ptrace, x.obj, x.sys]
function basis(x::SPartialTrace)
    obj_bases = collect(basis(x.obj).bases)
    new_bases = deleteat!(copy(obj_bases), x.sys)
    tensor(new_bases...)
end
Base.show(io::IO, x::SPartialTrace) = print(io, "tr$(x.sys)($(x.obj))")
"""
    ptrace(x::Symbolic{AbstractOperator})

Symbolic partial trace operation. See also [`SPartialTrace`](@ref).
"""
function ptrace(x::Symbolic{AbstractOperator}, s)
    ex = isexpr(x) ? qexpand(x) : x
    if isa(ex, typeof(x))
        if isa(basis(x), CompositeBasis)
            SPartialTrace(x, s)
        elseif s==1
            tr(x)
        else
            throw(ArgumentError("cannot take partial trace of a single quantum system"))
        end
    else
        ptrace(ex, s)
    end
end
function ptrace(x::SAddOperator, s)
    add_terms = []
    if isa(basis(x), CompositeBasis)
        for i in arguments(x)
            if isexpr(i)
                if isa(i, SScaledOperator) && operation(i.obj) === ⊗  # scaled tensor product
                    prod_terms = arguments(i.obj)
                    coeff = i.coeff
                elseif operation(i) === ⊗  # tensor product
                    prod_terms = arguments(i)
                    coeff = 1
                else  # multiplication of operators with composite basis
                    return SPartialTrace(x,s)
                end
            else  # operator with composite basis
                return SPartialTrace(x,s)
            end
            if any(j -> isa(basis(j), CompositeBasis), prod_terms)  # tensor product of operators with composite bases
                return SPartialTrace(x,s)
            else  # tensor product without composite basis
                sys_op = coeff*prod_terms[s]
                new_terms = deleteat!(copy(prod_terms), s)
                trace = tr(sys_op)
                isone(length(new_terms)) ? push!(add_terms, trace*first(new_terms)) : push!(add_terms, trace*(⊗)(new_terms...))
            end
        end
        (+)(add_terms...)
    elseif s==1 # partial trace must be over the first system if sum does not have a composite basis
        tr(x)
    else
        throw(ArgumentError("cannot take partial trace of a single quantum system"))
    end
end
function ptrace(x::STensorOperator, s)
    ex = qexpand(x)
    if isa(ex, SAddOperator)
        ptrace(ex, s)
    else
        terms = arguments(ex)
        newterms = []
        if any(i -> isa(basis(i), CompositeBasis), terms)
            SPartialTrace(ex, s)
        else
            sys_op = terms[s]
            new_terms = deleteat!(copy(terms), s)
            isone(length(new_terms)) ? tr(sys_op)*first(new_terms) : tr(sys_op)*STensorOperator(new_terms)
        end
    end
end


"""Inverse of an operator.

```jldoctest
julia> @op A;

julia> inv(A)
A⁻¹

julia> inv(A)*A
𝕀
```
"""
@withmetadata struct SInvOperator <: Symbolic{AbstractOperator}
    op::Symbolic{AbstractOperator}
end
isexpr(::SInvOperator) = true
iscall(::SInvOperator) = true
arguments(x::SInvOperator) = [x.op]
operation(x::SInvOperator) = inv
head(x::SInvOperator) = :inv
children(x::SInvOperator) = [:inv, x.op]
basis(x::SInvOperator) = basis(x.op)
Base.show(io::IO, x::SInvOperator) = print(io, "$(x.op)⁻¹")
Base.:(*)(invop::SInvOperator, op::SOperator) = isequal(invop.op, op) ? IdentityOp(basis(op)) : SMulOperator(invop, op)
Base.:(*)(op::SOperator, invop::SInvOperator) = isequal(op, invop.op) ? IdentityOp(basis(op)) : SMulOperator(op, invop)
"""
    inv(x::Symbolic{AbstractOperator})

Symbolic inverse of an operator. See also [`SInvOperator`](@ref).
"""
inv(x::Symbolic{AbstractOperator}) = SInvOperator(x)


"""Exponential of a symbolic operator.

```jldoctest
julia> @op A; @op B;

julia> exp(A)
exp(A)
```
"""
@withmetadata struct SExpOperator <: Symbolic{AbstractOperator}
    op::Symbolic{AbstractOperator}
end
isexpr(::SExpOperator) = true
iscall(::SExpOperator) = true
arguments(x::SExpOperator) = [x.op]
operation(x::SExpOperator) = exp
head(x::SExpOperator) = :exp
children(x::SExpOperator) = [:exp, x.op]
basis(x::SExpOperator) = basis(x.op)
Base.show(io::IO, x::SExpOperator) = print(io, "exp($(x.op))")
"""
    exp(x::Symbolic{AbstractOperator})

Symbolic exponential of an operator. See also [`SExpOperator`](@ref).
"""
exp(x::Symbolic{AbstractOperator}) = SExpOperator(x)


"""Vectorization of a symbolic operator.

```jldoctest
julia> @op A; @op B;

julia> vec(A)
|A⟩⟩

julia> vec(A+B)
|A⟩⟩+|B⟩⟩
```
"""
@withmetadata struct SVec <: Symbolic{AbstractKet}
    op::Symbolic{AbstractOperator}
end
isexpr(::SVec) = true
iscall(::SVec) = true
arguments(x::SVec) = [x.op]
operation(x::SVec) = vec
head(x::SVec) = :vec
children(x::SVec) = [:vec, x.op]
basis(x::SVec) = (⊗)(fill(basis(x.op), length(basis(x.op)))...)
Base.show(io::IO, x::SVec) = print(io, "|$(x.op)⟩⟩")
"""
    vec(x::Symbolic{AbstractOperator})

Symbolic vector representation of an operator. See also [`SVec`](@ref).
"""
vec(x::Symbolic{AbstractOperator}) = SVec(x)
vec(x::SScaled{AbstractOperator}) = x.coeff*vec(x.obj)
vec(x::SAdd{AbstractOperator}) = (+)((vec(i) for i in arguments(x))...)

@testitem "JET checks" tags=[:jet] begin
using JET
using QuantumOptics, QuantumClifford # to load the extensions

using InteractiveUtils, Latexify, SymbolicUtils

rep = report_package("QuantumSymbolics";
    ignored_modules=(
        AnyFrameModule(InteractiveUtils),
        AnyFrameModule(Latexify),
        AnyFrameModule(SymbolicUtils)
    )
)
@show rep
@test_broken length(JET.get_reports(rep)) == 0
@test length(JET.get_reports(rep)) <= 6
end

using Test

@testset "JET checks" begin
    using JET
    using QuantumOptics, QuantumClifford # to load the extensions
    using Test
    using QuantumSymbolics

    rep = JET.report_package(QuantumSymbolics, target_modules=[QuantumSymbolics])
    @show rep
    @test_broken length(JET.get_reports(rep)) == 0
    @test length(JET.get_reports(rep)) <= 6
end

@testitem "Superop" begin
    using LinearAlgebra
    using QuantumOptics

    #
    # single qubit
    #

    state = Y₁
    state_dm = SProjector(state)

    p = 0.1

    noiseop = PauliNoiseCPTP(p,p,p)
    noisy_state = noiseop * state
    noisy_state_fromdm = noiseop * state_dm

    # for one qubit
    # Fρ + (1-F)I/4 = Fρ + (1-F)(ρ + XρX + YρY + ZρZ)/4 = (1-3p)ρ + pXρX + pYρY + pZρZ
    # therefore 3/4F+1/4 = 1-3p
    # therefore 3/4F = 3/4-3p
    F = 1-4p

    mixed_dm = MixedState(state_dm)
    noisy_state_depol = F*state_dm + (1-F)*mixed_dm # TODO make a depolarization helper

    @test tr(express(noisy_state)) ≈ tr(express(noisy_state_fromdm)) ≈ tr(express(noisy_state_depol)) ≈ 1
    @test express(noisy_state) ≈ express(noisy_state_fromdm)
    @test express(noisy_state) ≈ express(noisy_state_depol)

    #
    # two qubits
    #

    pure_pair = (Z₁⊗Z₁ + Z₂⊗Z₂) / √2
    pure_pair_dm = SProjector(pure_pair)

    p = 0.1

    noiseop = PauliNoiseCPTP(p,p,p)
    noisy_pair = (noiseop ⊗ noiseop) * pure_pair
    noisy_pair_fromdm = (noiseop ⊗ noiseop) * pure_pair_dm

    @test tr(express(noisy_pair)) ≈ tr(express(noisy_pair_fromdm)) ≈ 1
    @test express(noisy_pair) ≈ express(noisy_pair_fromdm)

    @op A; @op B; @op C; @op O; @ket k;
    @superop S; K = kraus(A, B, C);

    @testset "symbolic superoperator tests" begin
        @test ishermitian(S) == false
        @test isunitary(S) == false
        @test isequal(S*SZeroOperator(), SZeroOperator())
        @test isequal(S*SZeroKet(), SZeroOperator())
        @test isequal(S*k, S*projector(k))
        @test isequal(K*O, A*O*dagger(A) + B*O*dagger(B) + C*O*dagger(C))
        @test isequal(K*k, A*projector(k)*dagger(A) + B*projector(k)*dagger(B) + C*projector(k)*dagger(C))
    end

    # TODO
    # test against depolarization
    # Depolarization over two qubits is different from depolarizing each separately (see related tutorial)
end

@testitem "Clifford" begin
    using QuantumClifford
    using QuantumOptics

    timed_express(state, repr) = @timed express(state, repr)

    state = StabilizerState(S"ZZ XX")
    state = SProjector(state)*0.5 + 0.5*MixedState(state)
    state2 = deepcopy(state)
    express(state, CliffordRepr())
    express(state, CliffordRepr())
    express(state2)
    express(state2)
    nocache = timed_express(state2, CliffordRepr())
    withcache = timed_express(state2, CliffordRepr())
    @test nocache.time > 2*withcache.time
    @test withcache.bytes <= 200
    results = Set([express(state2, CliffordRepr()) for i in 1:20])
    @test length(results)==2

    CR = CliffordRepr()
    UseOp = UseAsOperation()
    UseObs = UseAsObservable()

    @testset "Clifford representations for basis states" begin
        isequal(express(X1, CR), MixedDestabilizer(S"X"))
        isequal(express(X2, CR), MixedDestabilizer(S"-X"))
        isequal(express(Y1, CR), MixedDestabilizer(S"Y"))
        isequal(express(Y2, CR), MixedDestabilizer(S"-Y"))
        isequal(express(Z1, CR), MixedDestabilizer(S"Z"))
        isequal(express(Z2, CR), MixedDestabilizer(S"-Z"))
    end

    @testset "Clifford representations as observables" begin
        isequal(express(σˣ, CR, UseObs), P"X")
        isequal(express(σʸ, CR, UseObs), P"Y")
        isequal(express(σᶻ, CR, UseObs), P"Z")
        isequal(express(im*σˣ, CR, UseObs), im*P"X")
        isequal(express(σˣ⊗σʸ⊗σᶻ), P"X"⊗P"Y"⊗P"Z")
        isequal(express(σˣ*σʸ*σᶻ), P"X"*P"Y"*P"Z")
    end

    @testset "Clifford representations as operations" begin
        isequal(express(σˣ, CR, UseOp), sX)
        isequal(express(σʸ, CR, UseOp), sY)
        isequal(express(σᶻ, CR, UseOp), sZ)
    end

    @testset "Projector on stab state" begin
        @test isequal(projector(Stabilizer(S"X")), projector(StabilizerState(S"X")))
    end

    @testset "Clifford tensor operation apply" begin
        gate = express(σˣ⊗σᶻ, CR, UseOp)
        state = MixedDestabilizer(S"ZI IX")
        indices = [1, 2]
        apply!(state, indices, gate)

        @test isempty(indices)
        @test expect(P"ZI", state) ≈ -1
        @test expect(P"IX", state) ≈ -1
    end

    @testset "Clifford register symbolic apply" begin
        symbolic_reg = QuantumClifford.Register(copy(express(Z1, CR)))
        explicit_reg = QuantumClifford.Register(copy(express(Z1, CR)))

        apply!(symbolic_reg, (1,), QuantumSymbolics.X)
        apply!(explicit_reg, (1,), express(QuantumSymbolics.X, CR, UseOp))

        @test symbolic_reg == explicit_reg
        @test expect(P"Z", symbolic_reg.stab) ≈ -1
        @test_throws MethodError apply!(symbolic_reg, (1,), QuantumSymbolics.X; time=0.0)
    end
end

# This file contains types that depend on multiple backends
# or types for whom even the symbolic representation depends on a backend.

module MixedCliffordOpticsExt

using QuantumSymbolics
using QuantumInterface
using QuantumClifford, QuantumOpticsBase

using QuantumSymbolics: @withmetadata, Symbolic, AbstractKet, Metadata

using QuantumClifford: _T_str

import QuantumSymbolics: StabilizerState, express_nolookup

# using QuantumOpticsExt: _cphase, _z, _phase, _hadamard, _s₊
# or
#const qoe = Base.get_extension(QuantumSymbolics, :QuantumOpticsExt)
#const _cphase = qoe._cphase
#const _z = qoe._z
#const _phase = qoe._phase
#const _hadamard = qoe._hadamard
#const _s₊ = qoe._s₊
# or current solution
const _b2 = SpinBasis(1//2)
const _l0 = spinup(_b2)
const _l1 = spindown(_b2)
const _s₊ = (_l0+_l1)/√2
const _s₋ = (_l0-_l1)/√2
const _i₊ = (_l0+im*_l1)/√2
const _i₋ = (_l0-im*_l1)/√2
const _σ₊ = sigmap(_b2)
const _σ₋ = sigmam(_b2)
const _l00 = projector(_l0)
const _l11 = projector(_l1)
const _id = identityoperator(_b2)
const _z = sigmaz(_b2)
const _x = sigmax(_b2)
const _y = sigmay(_b2)
const _Id = identityoperator(_b2)
const _hadamard = (sigmaz(_b2)+sigmax(_b2))/√2
const _cnot = _l00⊗_Id + _l11⊗_x
const _cphase = _l00⊗_Id + _l11⊗_z
const _phase = _l00 + im*_l11
const _iphase = _l00 - im*_l11


function StabilizerState(x::Stabilizer)
    r,c = size(x)
    @assert r==c
    StabilizerState(MixedDestabilizer(x))
end
StabilizerState(x::String) = StabilizerState(Stabilizer(_T_str(x)))

express_nolookup(x::StabilizerState, ::CliffordRepr) = copy(x.stabilizer)

express_nolookup(x::StabilizerState, ::QuantumOpticsRepr) = Ket(stabilizerview(x.stabilizer))

end

using Test
using QuantumSymbolics

@testset "Expand" begin
    @bra b₁; @bra b₂; @bra b₃;
    @ket k₁; @ket k₂; @ket k₃;

    @op A; @op B; @op C; @op D;

    @testset "expand errors" begin
        @test_throws ErrorException qexpand(X)
    end

    @testset "expand rules" begin
        @test isequal(qexpand(commutator(A, B)), A*B - B*A)
        @test isequal(qexpand(anticommutator(A, B)), A*B + B*A)

        @test isequal(qexpand(A⊗(B+C+D)), A⊗B + A⊗C + A⊗D)
        @test isequal(qexpand(C ⊗ commutator(A, B)), C⊗(A*B) - C⊗(B*A))
        @test isequal(qexpand(k₁⊗(k₂+k₃)), k₁⊗k₂ + k₁⊗k₃)
        @test isequal(qexpand(b₁⊗(b₂+b₃)), b₁⊗b₂ + b₁⊗b₃)

        @test isequal(qexpand((B+C+D)⊗A), B⊗A + C⊗A + D⊗A)
        @test isequal(qexpand(commutator(A, B) ⊗ C), (A*B)⊗C - (B*A)⊗C)
        @test isequal(qexpand((k₂+k₃)⊗k₁), k₂⊗k₁ + k₃⊗k₁)
        @test isequal(qexpand((b₂+b₃)⊗b₁), b₂⊗b₁ + b₃⊗b₁)

        @test isequal(qexpand(A*(B+C+D)), A*B + A*C + A*D)
        @test isequal(qexpand(C * commutator(A, B)), C*A*B - C*B*A)

        @test isequal(qexpand((B+C+D)*A), B*A + C*A + D*A)
        @test isequal(qexpand(commutator(A, B) * C), A*B*C - B*A*C)

        @test isequal(qexpand((A⊗B)*(C⊗D)), (A*C)⊗(B*D))
        @test isequal(qexpand((b₁⊗b₂)*(k₁⊗k₂)), (b₁*k₁)*(b₂*k₂))
    end
end

##
# Superoperator representations
##

"""Kraus representation of a quantum channel

```jldoctest
julia> @op A₁; @op A₂; @op A₃;

julia> K = kraus(A₁, A₂, A₃)
𝒦(A₁,A₂,A₃)

julia> @op ρ;

julia> K*ρ
A₁ρA₁†+A₂ρA₂†+A₃ρA₃†
```
"""
@withmetadata struct KrausRepr <: Symbolic{AbstractSuperOperator}
    krausops
end
isexpr(::KrausRepr) = true
iscall(::KrausRepr) = true
arguments(x::KrausRepr) = x.krausops
operation(x::KrausRepr) = kraus
head(x::KrausRepr) = :kraus
children(x::KrausRepr) = [:kraus; x.krausops]
kraus(xs::Symbolic{AbstractOperator}...) = KrausRepr(collect(xs))
basis(x::KrausRepr) = basis(first(x.krausops))
Base.:(*)(sop::KrausRepr, op::Symbolic{AbstractOperator}) = (+)((i*op*dagger(i) for i in sop.krausops)...)
Base.:(*)(sop::KrausRepr, k::Symbolic{AbstractKet}) = (+)((i*SProjector(k)*dagger(i) for i in sop.krausops)...)
Base.:(*)(sop::KrausRepr, k::SZeroOperator) = SZeroOperator()
Base.:(*)(sop::KrausRepr, k::SZeroKet) = SZeroOperator()
Base.show(io::IO, x::KrausRepr) = print(io, "𝒦("*join([symbollabel(i) for i in x.krausops], ",")*")")

##
# Superoperator operations
##

"""Symbolic application of a superoperator on an operator

```jldoctest
julia> @op A; @superop S;

julia> S*A
S[A]
```
"""
@withmetadata struct SSuperOpApply <: Symbolic{AbstractOperator}
    sop
    op
end
isexpr(::SSuperOpApply) = true
iscall(::SSuperOpApply) = true
arguments(x::SSuperOpApply) = [x.sop,x.op]
operation(x::SSuperOpApply) = *
head(x::SSuperOpApply) = :*
children(x::SSuperOpApply) = [:*,x.sop,x.op]
Base.:(*)(sop::Symbolic{AbstractSuperOperator}, op::Symbolic{AbstractOperator}) = SSuperOpApply(sop,op)
Base.:(*)(sop::Symbolic{AbstractSuperOperator}, op::SZeroOperator) = SZeroOperator()
Base.:(*)(sop::Symbolic{AbstractSuperOperator}, k::Symbolic{AbstractKet}) = SSuperOpApply(sop,SProjector(k))
Base.:(*)(sop::Symbolic{AbstractSuperOperator}, k::SZeroKet) = SZeroOperator()
Base.show(io::IO, x::SSuperOpApply) = print(io, "$(x.sop)[$(x.op)]")
basis(x::SSuperOpApply) = basis(x.op)

using Test
using QuantumSymbolics

@testset "Trace" begin

    @bra b₁; @bra b₂;
    @ket k₁; @ket k₂;
    @op A; @op B; @op C; @op D; @op E; @op F;
    @op 𝒪 SpinBasis(1//2)⊗SpinBasis(1//2); @op 𝒫 SpinBasis(1//2)⊗SpinBasis(1//2);
    @op ℒ SpinBasis(1//2)⊗SpinBasis(1//2);

    @testset "trace tests" begin
        @test isequal(tr(2*A), 2*tr(A))
        @test isequal(tr(A+B), tr(A)+tr(B))
        @test isequal(tr(k₁*b₁), b₁*k₁)
        @test isequal(tr(commutator(A, B)), 0)
        @test isequal(tr(A⊗B⊗C), tr(A)*tr(B)*tr(C))
    end

    exp1 = (k₁*b₁)⊗A + (k₂*b₂)⊗B
    exp2 = A⊗(B⊗C + D⊗E)
    @testset "partial trace tests" begin

        # tests for ptrace(x::Symbolic{AbstractOperator}, s)
        @test isequal(ptrace(𝒪, 1), SPartialTrace(𝒪, 1))
        @test isequal(ptrace(𝒪, 2), SPartialTrace(𝒪, 2))
        @test isequal(ptrace(A, 1), tr(A))
        @test isequal(ptrace(A*(B+C), 1), tr(A*B)+tr(A*C))
        @test isequal(QuantumSymbolics.basis(ptrace(𝒪, 1)), SpinBasis(1//2))
        @test isequal(QuantumSymbolics.basis(ptrace(𝒪, 2)), SpinBasis(1//2))

        # tests for ptrace(x::SAddOperator, s)
        @test isequal(ptrace(A+B, 1), tr(A+B))
        @test isequal(ptrace(2*(A⊗B)+(C⊗D), 1), 2*tr(A)*B + tr(C)*D)
        @test isequal(ptrace((A⊗B)+(C⊗D), 1), tr(A)*B + tr(C)*D)
        @test isequal(ptrace((A⊗B⊗C)+(D⊗E⊗F), 1), tr(A)*(B⊗C) + tr(D)*(E⊗F))
        @test isequal(ptrace(𝒪 + 𝒫, 1), SPartialTrace(𝒪 + 𝒫, 1))
        @test isequal(ptrace(𝒪*ℒ + 𝒫*ℒ, 1), SPartialTrace(𝒪*ℒ + 𝒫*ℒ, 1))
        @test isequal(ptrace(𝒪⊗ℒ + 𝒫⊗ℒ, 1), SPartialTrace(𝒪⊗ℒ + 𝒫⊗ℒ, 1))

        # tests for ptrace(x::STensorOperator, s)
        @test isequal(ptrace(A⊗(B⊗C + D⊗E), 1),  tr(A)*(B⊗C) + tr(A)*(D⊗E)) 
        @test isequal(ptrace(𝒪⊗A, 1), SPartialTrace(𝒪⊗A, 1))
        @test isequal(ptrace(A⊗B, 1), tr(A)*B)
        @test isequal(ptrace(A⊗B⊗C, 1), tr(A)*(B⊗C))

        # additional tests 
        @test isequal(ptrace(exp1, 1), (b₁*k₁)*A + (b₂*k₂)*B)
        @test isequal(basis(ptrace(exp1, 1)), SpinBasis(1//2))
        @test isequal(ptrace(exp1, 2), tr(A)*(k₁*b₁) + tr(B)*(k₂*b₂))
        @test isequal(basis(ptrace(exp1, 2)), SpinBasis(1//2))

        @test isequal(ptrace(exp2, 1), tr(A)*(B⊗C) + tr(A)*(D⊗E))
        @test isequal(basis(ptrace(exp2, 1)), SpinBasis(1//2)⊗SpinBasis(1//2))
        @test isequal(ptrace(exp2, 2), tr(B)*(A⊗C) + tr(D)*(A⊗E))
        @test isequal(basis(ptrace(exp2, 2)), SpinBasis(1//2)⊗SpinBasis(1//2))
        @test isequal(ptrace(exp2, 3), tr(C)*(A⊗B) + tr(E)*(A⊗D))
        @test isequal(basis(ptrace(exp2, 3)), SpinBasis(1//2)⊗SpinBasis(1//2))
    end
end

# Getting Started with QuantumSymbolics.jl

```@meta
DocTestSetup = quote
    using QuantumSymbolics
end
```

QuantumSymbolics is designed for manipulation and numerical translation of symbolic quantum objects. This tutorial introduces basic features of the package.

## Installation

QuantumSymbolics.jl can be installed through the Julia package system in the standard way:

```
using Pkg
Pkg.add("QuantumSymbolics")
```

## Literal Symbolic Quantum Objects

Basic objects of type [`SBra`](@ref), [`SKet`](@ref), [`SOperator`](@ref), and [`SSuperOperator`](@ref) represent symbolic quantum objects with `name` and `basis` properties. Each type can be generated with a straightforward macro:

```jldoctest
julia> using QuantumSymbolics

julia> @bra b # object of type SBra
⟨b|

julia> @ket k # object of type SKet
|k⟩

julia> @op A # object of type SOperator
A

julia> @superop S # object of type SSuperOperator
S
```

By default, each of the above macros defines a symbolic quantum object in the spin-1/2 basis. One can simply choose a different basis, such as the Fock basis or a tensor product of several bases, by passing an object of type `Basis` to the second argument in the macro call:

```jldoctest
julia> @op B FockBasis(Inf, 0.0)
B

julia> basis(B)
Fock(cutoff=Inf)

julia> @op C SpinBasis(1//2)⊗SpinBasis(5//2)
C

julia> basis(C)
[Spin(1/2) ⊗ Spin(5/2)]
```
Here, we extracted the basis of the defined symbolic operators using the `basis` function.

Symbolic quantum objects with additional properties can be defined, such as a Hermitian operator, or the zero ket (i.e., a symbolic ket equivalent to the zero vector $\bm{0}$).

## Basic Operations

Expressions containing symbolic quantum objects can be built with a variety of functions. Let us consider the most fundamental operations: multiplication `*`, addition `+`, and the tensor product `⊗`. 

We can multiply, for example, a ket by a scalar value, or apply an operator to a ket:

```jldoctest
julia> @ket k; @op A;

julia> 2*k
2|k⟩

julia> A*k
A|k⟩
```

Similar scaling procedures can be performed on bras and operators. Addition between symbolic objects is also available, for instance:

```jldoctest
julia> @op A₁; @op A₂;

julia> A₁+A₂
A₁+A₂

julia> @bra b;

julia> 2*b + 5*b
7⟨b|
```
Built into the package are straightforward automatic simplification rules, as shown in the last example, where `2⟨b|+5⟨b|` evaluates to `7⟨b|`. 

Tensor products of symbolic objects can be performed, with basis information transferred:

```jldoctest
julia> @ket k₁; @ket k₂;

julia> tp = k₁⊗k₂
|k₁⟩|k₂⟩

julia> basis(tp)
[Spin(1/2) ⊗ Spin(1/2)]
```

Inner and outer products of bras and kets can be generated:

```jldoctest
julia> @bra b; @ket k;

julia> b*k
⟨b||k⟩

julia> k*b
|k⟩⟨b|
```

More involved combinations of operations can be explored. Here are few other straightforward examples:

```jldoctest
julia> @bra b; @ket k; @op A; @op B;

julia> 3*A*B*k
3AB|k⟩

julia> A⊗(k*b + B)
A⊗(B+|k⟩⟨b|)

julia> A-A
𝟎
```
In the last example, a zero operator, denoted `𝟎`, was returned by subtracting a symbolic operator from itself. Such an object is of the type [`SZeroOperator`](@ref), and similar objects [`SZeroBra`](@ref) and [`SZeroKet`](@ref) correspond to zero bras and zero kets, respectively.

## Linear Algebra on Bras, Kets, and Operators

QuantumSymbolics supports a wide variety of linear algebra on symbolic bras, kets, and operators. For instance, the commutator and anticommutator of two operators, can be generated:

```jldoctest
julia> @op A; @op B;

julia> commutator(A, B)
[A,B]

julia> anticommutator(A, B)
{A,B}

julia> commutator(A, A)
𝟎
```
Or, one can take the dagger of a quantum object with the [`dagger`](@ref) function:

```jldoctest
julia> @ket k; @op A; @op B;

julia> dagger(A)
A†

julia> dagger(A*k)
|k⟩†A†

julia> dagger(A*B)
B†A†
```
Below, we state all of the supported linear algebra operations on quantum objects:

- commutator of two operators: [`commutator`](@ref),
- anticommutator of two operators: [`anticommutator`](@ref),
- complex conjugate: [`conj`](@ref),
- transpose: [`transpose`](@ref),
- projection of a ket: [`projector`](@ref),
- adjoint or dagger: [`dagger`](@ref),
- trace: [`tr`](@ref),
- partial trace: [`ptrace`](@ref),
- inverse of an operator: [`inv`](@ref),
- exponential of an operator: [`exp`](@ref),
- vectorization of an operator: [`vec`](@ref).

## Predefined Quantum Objects

So far in this tutorial, we have considered arbitrary kets, bras, operators, and their corresponding operations. This package supports predefined quantum objects and operations in several formalisms, which are discussed in detail in other sections (see, for example, the [quantum harmonic oscillators](@ref Quantum-Harmonic-Oscillators) or [qubit basis](@ref Typical-Qubit-Bases) pages). To get a taste of what's available, let us consider a few symbolic examples. For a complete description, see the [full API page](@ref Full-API).

Quantum gates and their basis states can be represented symbolically:

```jldoctest
julia> CNOT # CNOT Gate
CNOT

julia> X, Y, Z, I # Pauli operators
(X, Y, Z, 𝕀)

julia> X1, X2 # Eigenstates of the Pauli X operator
(|X₁⟩, |X₂⟩)

julia> CPHASE * (Z1 ⊗ Z2) # Application of CPHASE gate on |01⟩
CPHASE|Z₁⟩|Z₂⟩
```

We also have symbolic representations of bosonic systems:

```jldoctest
julia> FockState(4) # Fock state with 4 excitation quanta
|4⟩

julia> Create, Destroy # creation and annihilation operators
(a†, a)

julia> DisplaceOp(im) # Displacement operator for single bosonic mode
D(im)

julia> N * vac # Application of number operator on vacuum state
n|0⟩
```

If we want to substitute a predefined quantum object into a general symbolic expression, we can use the [`substitute`](https://symbolics.juliasymbolics.org/v3.5/manual/expression_manipulation/#SymbolicUtils.substitute) command from [`Symbolics.jl`](https://github.com/JuliaSymbolics/Symbolics.jl):

```jldoctest
julia> using Symbolics

julia> @op A; @ket k;

julia> ex = 2*A + projector(k)
2A+𝐏[|k⟩]

julia> substitute(ex, Dict([A => X, k => X1]))
2X+𝐏[|X₁⟩]
```

## Simplifying Expressions

For predefined objects such as the Pauli operators [`X`](@ref), [`Y`](@ref), and [`Z`](@ref), additional simplification can be performed with the [`qsimplify`](@ref) function. Take the following example:

```jldoctest
julia> qsimplify(X*Z)
(0 - 1im)Y
```

Here, we have the relation $XZ = -iY$, so calling [`qsimplify`](@ref) on the expression `X*Z` will rewrite the expression as `-im*Y`.

Note that simplification rewriters used in QuantumSymbolics are built from the interface of [`SymbolicUtils.jl`](https://github.com/JuliaSymbolics/SymbolicUtils.jl). By default, when called on an expression, [`qsimplify`](@ref) will iterate through every defined simplification rule in the QuantumSymbolics package until the expression can no longer be simplified. 

Now, suppose we only want to use a specific subset of rules. For instance, say we wish to simplify commutators, but not anticommutators. Then, we can pass the keyword argument `rewriter=qsimplify_commutator` to [`qsimplify`](@ref), as done in the following example:

```jldoctest
julia> qsimplify(commutator(X, Y), rewriter=qsimplify_commutator)
(0 + 2im)Z

julia> qsimplify(anticommutator(X, Y), rewriter=qsimplify_commutator)
{X,Y}
```
As shown above, we apply [`qsimplify`](@ref) to two expressions: `commutator(X, Y)` and `anticommutator(X, Y)`. We specify that only commutator rules will be applied, thus the first expression is rewritten to `(0 + 2im)Z` while the second expression is simply returned. This feature can greatly reduce the time it takes for an expression to be simplified.

Below, we state all of the simplification rule subsets that can be passed to [`qsimplify`](@ref):

- `qsimplify_pauli` for Pauli multiplication,
- `qsimplify_commutator` for commutators of Pauli operators,
- `qsimplify_anticommutator` for anticommutators of Pauli operators.

## Expanding Expressions

Symbolic expressions containing quantum objects can be expanded with the [`qexpand`](@ref) function. We demonstrate this capability with the following examples.

```jldoctest
julia> @op A; @op B; @op C;

julia> qexpand(A⊗(B+C))
(A⊗B)+(A⊗C)

julia> qexpand((B+C)*A)
BA+CA

julia> @ket k₁; @ket k₂; @ket k₃;

julia> qexpand(k₁⊗(k₂+k₃))
|k₁⟩|k₂⟩+|k₁⟩|k₃⟩

julia> qexpand((A*B)*(k₁+k₂))
AB|k₁⟩+AB|k₂⟩
```

## Numerical Translation of Symbolic Objects

Symbolic expressions containing predefined objects can be converted to numerical representations with [`express`](@ref). Numerics packages supported by this translation capability are [`QuantumOptics.jl`](https://github.com/qojulia/QuantumOptics.jl) and [`QuantumClifford.jl`](https://github.com/QuantumSavory/QuantumClifford.jl/).

By default, [`express`](@ref) converts an object to the quantum optics state vector representation. For instance, we can represent the exponential of the Pauli operator [`X`](@ref) numerically as follows:

```jldoctest
julia> using QuantumOptics

julia> express(exp(X))
Operator(dim=2x2)
  basis: Spin(1/2)
 1.5430806327160496 + 0.0im  1.1752011684303352 + 0.0im
 1.1752011684303352 + 0.0im  1.5430806327160496 + 0.0im
```

To convert to the Clifford representation, an instance of `CliffordRepr` must be passed to [`express`](@ref). For instance, we can represent the projection of the basis state [`X1`](@ref) of the Pauli operator [`X`](@ref) as follows:

```jldoctest
julia> using QuantumClifford

julia> express(projector(X1), CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
+ X
```
For more details on using [`express`](@ref), refer to the [express functionality page](@ref express).

# QuantumSymbolics.jl

```@meta
DocTestSetup = quote
    using QuantumSymbolics
end
```

A symbolics package for quantum information science. It serves two purposes:

- It provides for algebraic manipulation of mathematical expressions related to your quantum models. Particularly helpful when having to automatically generate or simplify expressions of significant complexity.
- An assortment of "expression translators" are provided that can turn a symbolic expression into a numerical one in a variety of formalisms.

Below we list some commonly used expressions, followed by an autogenerated API list.

```@setup symb
using QuantumSymbolics
```

```@raw html
<table>
<tr>
<th></th><th>Symbolic Example</th><th>Conversion Example</th>
</tr>
<tr>
```

```@raw html
<!-- Qubit Basis States -->
<td>
```
Qubit Basis States
`X1`, `X2`, `Y1`, `Y2`, `Z1`, `Z2`
```@raw html
</td>
<td>
```
```@example symb
Z1
```
```@raw html
</td>
<td>
```
```@example symb
express(Z1)
```
```@example symb
express(Y2, CliffordRepr())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
<!-- Common gates -->
<td>
```
Common gates: `CNOT`, `H`, etc
```@raw html
</td>
<td>
```
```@example symb
CNOT
```
```@raw html
</td>
<td>
```
```@example symb
express(H)
```
```@example symb
express(CNOT, CliffordRepr(), UseAsOperation())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
<!-- Tensor products and sums -->
<td>
```
Tensor products `⊗` and sums `+`
```@raw html
</td>
<td>
```
```@example symb
(X1⊗Z2 + Y1⊗Y2 ) / √3
```
```@raw html
</td>
<td>
```
```@example symb
express(X1⊗Z1)
```
```@example symb
express(X1⊗Y2, CliffordRepr())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
<!-- Projectors -->
<td>
```
Projectors, pure density matrices
```@raw html
</td>
<td>
```
```@example symb
SProjector(X1⊗Z2)
```
```@raw html
</td>
<td>
```
```@example symb
express(SProjector(X1⊗Z1))
```
```@example symb
express(SProjector(X1⊗Z1), CliffordRepr())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
<!-- Completely mixed state -->
<td>
```
Completely depolarized (mixed) state
```@raw html
</td>
<td>
```
```@example symb
MixedState(X1)
```
```@raw html
</td>
<td>
```
```@example symb
express(MixedState(X1))
```
```@example symb
express(MixedState(X1), CliffordRepr())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
<!-- Mixtures -->
<td>
```
Impure states, represented as sum of density matrices
```@raw html
</td>
<td>
```
```@example symb
(MixedState(X1)+SProjector(Z1)) / 2
```
```@raw html
</td>
<td>
```
```@example symb
express((MixedState(X1)+SProjector(Z1)) / 2)
```
When a Clifford representation is used, an efficient sampler is generated, and stabilizer states are randomly sampled from the correct distribution:
```@example symb
express(MixedState(X1)/2+SProjector(Z1)/2, CliffordRepr())
```
```@raw html
</td>
</tr>
<tr>
```

```@raw html
</tr>
</table>
```

!!! warning "Stabilizer state expressions"

    The state written as $\frac{|Z₁⟩⊗|Z₁⟩+|Z₂⟩⊗|Z₂⟩}{√2}$ is a well known stabilizer state, namely a Bell state. However, automatically expressing it as a stabilizer is a prohibitively expensive computational operation in general. We do not perform that computation automatically. If you want to ensure that states you define can be automatically converted to tableaux for Clifford simulations, avoid using summation of kets. On the other hand, in all of our Clifford Monte-Carlo simulations, `⊗` is fully supported, as well as [`projector`](@ref), [`MixedState`](@ref), [`StabilizerState`](@ref), and summation of density matrices.



## Office Hours

Office hours are held every Friday from 12:30 – 1:30 PM Eastern Time via [Zoom](https://umass-amherst.zoom.us/j/95986275946?pwd=6h7Wbai1bXIai0XQsatNRWaVbQlTDr.1). Before joining, make sure to check the [Julia community events calendar](https://julialang.org/community/#events) to confirm whether office hours are happening, rescheduled, or canceled for the week. Feel free to bring any questions or suggestions!

## Support

QuantumSymbolics.jl is developed by [many volunteers](https://github.com/QuantumSavory/QuantumSymbolics.jl/graphs/contributors), managed at [Prof. Krastanov's lab](https://lab.krastanov.org/) at [University of Massachusetts Amherst](https://www.umass.edu/quantum/).

The development effort is supported by The [NSF Engineering and Research Center for Quantum Networks](https://cqn-erc.arizona.edu/), and
by NSF Grant 2346089 "Research Infrastructure: CIRC: New: Full-stack Codesign Tools for Quantum Hardware".

## Bounties

[We run many bug bounties and encourage submissions from novices (we are happy to help onboard you in the field).](https://github.com/QuantumSavory/.github/blob/main/BUG_BOUNTIES.md)

# Typical Qubit Bases

```@meta
DocTestSetup = quote
    using QuantumSymbolics, QuantumOptics
end
```

Here are some common conventions for representing a qubit in a physical system. This reference is provided as the conventions matter to the correct choice of noise processes and bases in which they are represented.

In monospaced `code` format we give the symbols by which these objects are callable in `QuantumSymbolics`. We provide unicode and ASCII names for convenience of typing.

## Spin $\frac{1}{2}$ qubits

First we introduce the Pauli matrices:

```jldoctest
julia> express(σᶻ) |> dense # or `Z`
Operator(dim=2x2)
  basis: Spin(1/2)
 1.0+0.0im   0.0+0.0im
 0.0+0.0im  -1.0+0.0im

julia> express(σˣ) |> dense # or `X`
Operator(dim=2x2)
  basis: Spin(1/2)
 0.0+0.0im  1.0+0.0im
 1.0+0.0im  0.0+0.0im

julia> express(σʸ) |> dense # or `Y`
Operator(dim=2x2)
  basis: Spin(1/2)
 0.0+0.0im  -0.0-1.0im
 0.0+1.0im   0.0+0.0im
```

Above `dense` is from `QuantumOptics`, used to convert their representation to a dense matrix.

The eigenvectors of each one of them provides for a convenient basis. The σᶻ basis is also called the *computational basis*. As mentioned, we have both unicode and ASCII names for convenience of typing. For these basis vectors we also have two sets of names: one based on which operator they are eigenvectors of and one in terms of typical logical representation (with prefix `L`).

- `Z1 = Z₁ = L0 = L₀ = ` $|0\rangle = \begin{pmatrix}1\\0\end{pmatrix} = |\uparrow\rangle$ with eigenvalue +1 for σᶻ
- `Z2 = Z₂ = L1 = L₁ = ` $|1\rangle = \begin{pmatrix}0\\1\end{pmatrix} = |\downarrow\rangle$ with eigenvalue +1 for σᶻ
- `X1 = X₁ = Lp = L₊ = ` $|+\rangle = \frac{1}{\sqrt 2}\begin{pmatrix}1\\1\end{pmatrix}$ with eigenvalue +1 for σˣ
- `X2 = X₂ = Lm = L₋ = ` $|-\rangle = \frac{1}{\sqrt 2}\begin{pmatrix}1\\-1\end{pmatrix}$ with eigenvalue -1 for σˣ
- `Y1 = Y₁ = Lpi = L₊ᵢ = ` $|+i\rangle = \frac{1}{\sqrt 2}\begin{pmatrix}1\\ i\end{pmatrix}$ with eigenvalue +1 for σʸ
- `Y2 = Y₂ = Lmi = L₋ᵢ = ` $|-i\rangle = \frac{1}{\sqrt 2}\begin{pmatrix}1\\-i\end{pmatrix}$ with eigenvalue -1 for σʸ

The Y vectors occasionally are denoted with R and L (stemming from the vector notation for right and left polarized light), but there is no established notation choice or ordering.

!!! warning "Talking about ground/excited and spin-up/spin-down states can lead to confusion"
    We specifically avoid using notation with "ground" and "excited" states. For physicist usually the excited state is the "up" states ($|e\rangle=|\uparrow\rangle$), but that historical choice clashes with the logical state notation as we have the logical **zero** be the "excited" state. This clash becomes particularly confusing when noise processes and relaxation process are taken into account. E.g. one might think the operator usually denoted $\hat{\sigma}_-$ would be the one corresponding to decay but we actually have $\hat{\sigma}_-|0\rangle=|1\rangle$. To avoid this confusion we strive to **not use** the notation $|\uparrow\rangle$, $|\downarrow\rangle$, $|e\rangle$, and $|g\rangle$. Similarly we strongly prefer to never use $\hat{\sigma}_-$ and $\hat{\sigma}_+$, rather only use $|1\rangle \langle0|$ and its conjugate.
    If we were instead talking about single-rail photonic qubits, we do not have the same issue (because the diagonal of the number operator is growing, instead of decreasing like the diagonal of the Pauli Z).


The basis states can be easily expressed both as kets and as tableaux (In the tableau representation below the top half corresponds to the destabilizer, while the bottom is the stabilizer):

```jldoctest
julia> express(L0, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
+ Z


julia> express(L1, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
- Z


julia> express(L₀, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
+ Z


julia> express(L₁, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
- Z


julia> express(L₊, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
+ X


julia> express(L₋, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X


julia> express(L₊ᵢ, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
+ Y


julia> express(L₋ᵢ, CliffordRepr())
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- Y
```

```jldoctest
julia> express(L₀)
Ket(dim=2)
  basis: Spin(1/2)
 1.0 + 0.0im
 0.0 + 0.0im

julia> express(L₁)
Ket(dim=2)
  basis: Spin(1/2)
 0.0 + 0.0im
 1.0 + 0.0im

julia> express(L₊)
Ket(dim=2)
  basis: Spin(1/2)
 0.7071067811865475 + 0.0im
 0.7071067811865475 + 0.0im

julia> express(L₋)
Ket(dim=2)
  basis: Spin(1/2)
  0.7071067811865475 + 0.0im
 -0.7071067811865475 + 0.0im

julia> express(L₊ᵢ)
Ket(dim=2)
  basis: Spin(1/2)
 0.7071067811865475 + 0.0im
                0.0 + 0.7071067811865475im

julia> express(L₋ᵢ)
Ket(dim=2)
  basis: Spin(1/2)
 0.7071067811865475 + 0.0im
                0.0 - 0.7071067811865475im
```

# Express functionality

```@meta
DocTestSetup = quote
    using QuantumSymbolics, QuantumOptics, QuantumClifford
end
```

A principle feature of `QuantumSymbolics` is to numerically represent symbolic quantum expressions in various formalisms using [`express`](@ref). In particular, one can translate symbolic logic to back-end toolboxes such as [`QuantumOptics.jl`](https://github.com/qojulia/QuantumOptics.jl) or [`QuantumClifford.jl`](https://github.com/QuantumSavory/QuantumClifford.jl) for simulating quantum systems with great flexibility.

As a straightforward example, consider the spin-up state $|\uparrow\rangle = |0\rangle$, the eigenstate of the Pauli operator $Z$, which can be expressed in `QuantumSymbolics` as follows:

```@example 1
using QuantumSymbolics, QuantumClifford, QuantumOptics # hide
ψ = Z1
```

Using [`express`](@ref), we can translate this symbolic object into its numerical state vector form in [`QuantumOptics.jl`](https://github.com/qojulia/QuantumOptics.jl).

```@example 1
express(ψ)
```

By default, [`express`](@ref) converts a quantum object with `QuantumOpticRepr`. It should be noted that [`express`](@ref) automatically caches this particular conversion of `ψ`. Thus, after running the above example, the numerical representation of the spin-up state is stored in the metadata of `ψ`.

```@example 1
ψ.metadata
```

The caching feature of [`express`](@ref) prevents a specific representation for a symbolic quantum object from being computed more than once. This becomes handy for translations of more complex operations, which can become computationally expensive. We also have the ability to express $|Z_1\rangle$ in the Clifford formalism with [`QuantumClifford.jl`](https://github.com/QuantumSavory/QuantumClifford.jl):

```@example 1
express(ψ, CliffordRepr())
```

Here, we specified an instance of `CliffordRepr` in the second argument to convert `ψ` into a tableau of Pauli operators containing its stabilizer and destabilizer states. Now, both the state vector and Clifford representation of `ψ` have been cached:

```@example 1
ψ.metadata
```

More involved examples can be explored. For instance, say we want to apply the tensor product $X\otimes Y$ of the Pauli operators $X$ and $Y$ to the Bell state $|\Phi^{+}\rangle = \dfrac{1}{\sqrt{2}}\left(|00\rangle + |11\rangle\right)$, and numerically express the result in the quantum optics formalism. This would be done as follows:

```@example 2
using QuantumSymbolics, QuantumClifford, QuantumOptics # hide
bellstate = (Z1⊗Z1+Z2⊗Z2)/√2
tp = σˣ⊗σʸ
express(tp*bellstate)
```

## Examples of Edge Cases
For Pauli operators, additional flexibility is given for translations to the Clifford formalism. Users have the option to convert a multi-qubit Pauli operator to an observable or operation with instances of `UseAsObservable` and `UseAsOperation`, respectively. Take the Pauli operator $Y$, for example, which in `QuantumSymbolics` is the constants `Y` or `σʸ`:

```jldoctest
julia> express(σʸ, CliffordRepr(), UseAsObservable())
+ Y

julia> express(σʸ, CliffordRepr(), UseAsOperation())
sY
```

Another edge case is translations with `QuantumOpticsRepr`, where we can additionally define a finite cutoff for bosonic states and operators, as discussed in the [quantum harmonic oscillators page](@ref Quantum-Harmonic-Oscillators). The default cutoff for such objects is 2, however a different cutoff can be specified by passing an integer to `QuantumOpticsRepr` in an `express` call. Let us see an example with the number operator:

```jldoctest
julia> express(N) |> dense
Operator(dim=3x3)
  basis: Fock(cutoff=2)
 0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  1.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  2.0+0.0im

julia> express(N, QuantumOpticsRepr(cutoff=4)) |> dense
Operator(dim=5x5)
  basis: Fock(cutoff=4)
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  1.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  2.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  3.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im  4.0+0.0im
```

# Quantum Harmonic Oscillators

```@meta
DocTestSetup = quote
    using QuantumSymbolics, QuantumOptics
end
```

In this section, we describe symbolic representations of bosonic systems in QuantumSymbolics, which can be numerically translated to [`QuantumOptics.jl`](https://github.com/qojulia/QuantumOptics.jl).

## States

A Fock state is a state with well defined number of excitation quanta of a single quantum harmonic oscillator (an eigenstate of the number operator). In the following example, we create a [`FockState`](@ref) with 3 quanta in an infinite-dimension Fock space:

```jldoctest
julia> f = FockState(3)
|3⟩
```

Both vacuum (ground) and single-photon states are defined as constants in both unicode and ASCII for convenience:

- `vac = F₀ = F0` $=|0\rangle$ in the number state representation,
- `F₁ = F1` $=|1\rangle$ in the number state representation.

To create quantum analogues of a classical harmonic oscillator, or monochromatic electromagnetic waves, we can define a coherent (a.k.a. semi-classical) state $|\alpha\rangle$, where $\alpha$ is a complex amplitude, with [`CoherentState`](@ref):

```jldoctest
julia> c = CoherentState(im)
|im⟩
```
!!! note "Naming convention for quantum harmonic oscillator bases"
    The defined basis for arbitrary symbolic bosonic states is a `FockBasis` object, due to a shared naming interface for Quantum physics packages. For instance, the command `basis(CoherentState(im))` will output `Fock(cutoff=Inf)`. This may lead to confusion, as not all bosonic states are Fock states. However, this is simply a naming convention for the basis, and symbolic and numerical results are not affected by it.

Summarized below are supported bosonic states.

- Fock state: `FockState(idx::Int)`,
- Coherent state: `CoherentState(alpha::Number)`,
- Squeezed vacuum state: `SqueezedState(z::Number)`.
  
## Operators

Operations on bosonic states are supported, and can be simplified with [`qsimplify`](@ref) and its rewriter `qsimplify_fock`. For instance, we can apply the raising (creation) $\hat{a}^{\dagger}$ and lowering (annihilation or destroy) $\hat{a}$ operators on a Fock state as follows:

```jldoctest
julia> f = FockState(3);

julia> raise = Create*f
a†|3⟩

julia> qsimplify(raise, rewriter=qsimplify_fock)
(sqrt(4))|4⟩

julia> lower = Destroy*f
a|3⟩

julia> qsimplify(lower, rewriter=qsimplify_fock)
(sqrt(3))|2⟩
```
Or, we can apply the number operator $\hat{n}$ to our Fock state:

```jldoctest
julia> f = FockState(3);

julia> num = N*f
n|3⟩

julia> qsimplify(num, rewriter=qsimplify_fock)
3|3⟩
```

Constants are defined for number and ladder operators in unicode and ASCII:

- `N = n̂` $=\hat{n}$,
- `Create = âꜛ` $=\hat{a}^{\dagger}$,
- `Destroy = â` $=\hat{a}$.

Phase-shift $U(\theta)$ and displacement $D(\alpha)$ operators, defined respectively as

$$U(\theta) = \exp\left(-i\theta\hat{n}\right) \quad \text{and} \quad D(\alpha) = \exp\left(\alpha\hat{a}^{\dagger} - \alpha\hat{a}\right),$$ 

can be defined with usual simplification rules. Consider the following example:

```jldoctest
julia> displace = DisplaceOp(im)
D(im)

julia> c = qsimplify(displace*vac, rewriter=qsimplify_fock)
|im⟩

julia> phase = PhaseShiftOp(pi)
U(π)

julia> qsimplify(phase*c, rewriter=qsimplify_fock)
|1.2246467991473532e-16 - 1.0im⟩
```
Here, we generated a coherent state $|i\rangle$ from the vacuum state $|0\rangle$ by applying the displacement operator defined by [`DisplaceOp`](@ref). Then, we shifted its phase by $\pi$ with the phase shift operator (which is called with [`PhaseShiftOp`](@ref)) to get the result $|-i\rangle$.

Summarized below are supported bosonic operators.

- Number operator: `NumberOp()`,
- Creation operator: `CreateOp()`,
- Annihilation operator: `DestroyOp()`,
- Phase-shift operator: `PhaseShiftOp(phase::Number)`,
- Displacement operator: `DisplaceOp(alpha::Number)`,
- Squeezing operator: `SqueezeOp(z::Number)`.

## Numerical Conversions to QuantumOptics.jl

Bosonic systems can be translated to the ket representation with [`express`](@ref). For instance:

```jldoctest
julia> f = FockState(1);

julia> express(f)
Ket(dim=3)
  basis: Fock(cutoff=2)
 0.0 + 0.0im
 1.0 + 0.0im
 0.0 + 0.0im

julia> express(Create) |> dense
Operator(dim=3x3)
  basis: Fock(cutoff=2)
 0.0+0.0im      0.0+0.0im  0.0+0.0im
 1.0+0.0im      0.0+0.0im  0.0+0.0im
 0.0+0.0im  1.41421+0.0im  0.0+0.0im

julia> express(Create*f)
Ket(dim=3)
  basis: Fock(cutoff=2)
                0.0 + 0.0im
                0.0 + 0.0im
 1.4142135623730951 + 0.0im

julia> express(Destroy*f)
Ket(dim=3)
  basis: Fock(cutoff=2)
 1.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
```

!!! warning "Cutoff specifications for numerical representations of quantum harmonic oscillators"
    Symbolic bosonic states and operators are naturally represented in an infinite dimension basis. For numerical conversions of such quantum objects, a finite cutoff of the highest allowed state must be defined. By default, the basis dimension of numerical conversions is set to 3 (so the number representation cutoff is 2), as demonstrated above. To define a different cutoff, one must customize the `QuantumOpticsRepr` instance, e.g. provide `QuantumOpticsRepr(cutoff=n::Int)` to [`express`](@ref).

If we wish to specify a different numerical cutoff, say 4, to the previous examples, then we rewrite them as follows:

```jldoctest
julia> f = FockState(1);

julia> express(f, QuantumOpticsRepr(cutoff=4))
Ket(dim=5)
  basis: Fock(cutoff=4)
 0.0 + 0.0im
 1.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im
 0.0 + 0.0im

julia> express(Create, QuantumOpticsRepr(4)) |> dense
Operator(dim=5x5)
  basis: Fock(cutoff=4)
 0.0+0.0im      0.0+0.0im      0.0+0.0im  0.0+0.0im  0.0+0.0im
 1.0+0.0im      0.0+0.0im      0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  1.41421+0.0im      0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im      0.0+0.0im  1.73205+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im      0.0+0.0im      0.0+0.0im  2.0+0.0im  0.0+0.0im
```
